
#-----------------------------------------------------------------------------
# Name        	: SkIndigo_1_1_16.rb
# Description 	: Model exporter and material editor for Indigo 1.1.16
# Menu Item   	: Plugins\SkIndigo\
# Author      	: Dale Martens (Whaat)
#		  Code used from following SU exporters: Su2KT by Tomasz, SU2POV by Didier Bur and OGRE exporter by Kojack
# Usage     	: Copy script to PLUGINS folder in SketchUp folder, run SU, go to Plugins\SkIndigo
# Date        	: xx xxx 2009
# Type        	: Exporter
# Version     	: 1.1.16

#Version 1.1.16

#Changed: slightly improved the material types query (shows emitting materials)
#Changed: removed environment map rotation hack and added Indigo env map rotation
#Fixed: Simple UI emitter checkbox works again
#Changed: Material preview thumbnail shows SketchUp texture if no thumbnail is present
#Changed: filenames (not pathnames) are now listed in the External texture editor drop-down list
#Changed: toolbar icons
#Added: Position Map button to Texture Editor
#Changed: UV mapping workflow

#Version 1.1.15

#Fixed: Diffuse Transmitters causing Indigo to crash

#Version 1.1.12

#Changed: updated preview scenes to work with emitting materials
#Changed: re-added emitter presets
#Changed: groups of material attributes can now be collapsed by clicking on the appropriate heading
#Changed: You can now change instancing properties for all selected groups or components simultaneously
#Changed: messed around with instancing - instancing can now be enabled for groups
#Removed: Blackbody and RGB Light material types - use emitting materials instead
#Added: IES support to emitting materials
#Added: power and efficacy to emitting materials
#Changed: base emission now determined by emitter color or temperature value
#Added: support for non-uniformly scaled instances 
#Fixed: Animation - forced to use Indigo Console for animation
#Added: option to smooth animation transitions
#Changed; re-added max subdivisions to UI
#Changed: preview thumbnail background color set from material color
#Changed: Mapping system completely reworked.  External or internal textures can now be used.
#Changed: Albedo can now be any texture in your model or a custom shader
#Changed: Blend maps can now be any texture or a custom shader
#Added: Specular Reflectivity maps and custom shader support
#Added: support for clip map shaders
#Fixed: displacement maps with clip maps and blended materials
#Fixed: automatic blending of diffuse and phong materials wth diffuse transmitters when 0<SUopacity<100

#Version 1.1.8

#Changed: disabled IGM loading
#Added: support for custom shaders for bump,displacement,exponent,sigma,emission
#Changed: saved uv set options to 'SU, 1, 2, 3'
#Changed: disabled subdivision smoothing due to confusion
#Changed: removed subdivision curvature threshold from the interface
#Changed: constant 'exponent' values are set using using the texture 'b' parameter
#Changed: constant 'blend factor' values are now set using the texture 'b' parameter
#Changed: constant 'sigma' values are now set using the texture 'b' parameter
#Changed: disabled automatic blending of diffuse transmitters when 0<SUopacity<100
#Added: sigma mapping for Oren-Nayar materials
#Added: specular reflectivity mapping for Metal materials
#Added: support for emitting materials and layer blending
#Changed: removed fresnel scale
#Changed: now using new material format
#Changed: indigo embedded_02 mesh format exclusively used
#Changed: prompts user to create linked igm material if trying to load a material with unsupported indigo attributes
#Changed: made thumbnails refresh automatically when rendering a preview - old thumbnail deleted before starting new preview
#Added: Buttons to 'jump to' child materials of blend materials
#Added: back button
#Fixed: instancing and multiple uvsets should work again

#Version 1.1.5

#Added: support for lens shifting
#Added: displacement mapping for blend materials
#Changed: nkdata files not exported when saving IGMs anymore
#Added: option to pack IGM file when saving material
#Changed: When loading an IGM with nkdata, the nkdata file must be already located in the Indigo/nkdata folder
#Added: PIGM/IGM linking (new material - Linked IGM)
#Added: PIGM loading
#Added: support for IGM loading of oren-nayar materials, phong with specular reflectivity spectrum, displacement maps
#Changed: indigo preview scene to official indigo preview scene
#Changed: made default uv set be exported with name 'default' to improve compatibility with linked IGM files

#Version 1.1.1

#Removed: option to enable or disable normal smoothing
#Added: support for displacement mapping
#Added: support for indigo subdivision and smoothing
#Added: support for fractal brownian motion procedural texture


#Version 1.0.9 Official

#Fixed: sphere primitive with no material bug
#Fixed: monochrome render bug

#Version 1.0.8

#Added: support for alpha rendering
#Changed: aperture diffraction disabled by default
#Fixed: environment map rotation
#Added: support for Oren-Nayar material
#Added: support for specular reflectivity spectrum (disable nkdata checkbox to use)

#Version 1.0.5

#Added: region rendering
#Added: Advanced Texture Editor
#Added: support for a,c, and gamma texture attributes
#Changed: all textures exported in JPG format (BMP, GIF, TIF, all PNG should now work except for grayscale textures)
#Changed: replaced cube preview scene with new fast cube preview scene
#Added: Lambertian material preset
#Changed: made IGM export compliant with new proposed IGM spec
#Changed: improved IGM loading code and fixed some bugs
#Changed: SUpreviews folder moved to the SkIndigo directory
#Changed: thumbnails saved in the indigo/SUthumbnails directory (cannot be changed)
#Changed: exported textures filenames converted to material name at export time (removes texture naming conflicts)
#Fixed: export selection only

#Version 1.0.4

#Added: support for IES profiles
#Changed: changed previews folder name to SUpreviews to avoid conflicts with other exporters' preview scenes
#Added: aperture diffraction support
#Changed: made IGM import backwards compatible with older versions of Indigo (not fully tested)
#Added: Water preset (credit CoolColJ)

#Version 1.0.1

#Fixed: IGM import with arbitrary gamma values
#Changed: made Indigo always open maximized
#Fixed: made nkdata IGMs compatible with Maxigo
#Changed: NKdata files are now exported when saving IGM
#Changed: frosted glass preset exponent to 100
#Changed: environment maps can now be located in any directory
#Removed: option to change exponent of Thin Glass materials (exports as 1 million)
#Added: watermark option
#Added: auto choose threads
#Added: halt samples per pixel
#Added: custom output image name
#Changed: low priority mode can be used when using more than 1 thread
#Added: enhanced support for nkdata including custom nkdata
#Changed: Phong with opacity less than 100% exports as blended with diffuse trasmitter
#Changed: Complete UI overhaul using dhtml web dialogs
#Added: Reinhard and Camera tonemapping

#Version 0.9.1 Official

#Changed: when applying glass or frosted glass preset, opacity now gets set to zero
#Changed: auto choose threads deactivated (conflicts with present SkIndigo UI)
#Changed: default tracing method to Bidir MLT
#Added: Fast sphere preview scene (and removed previous Sphere preview scene)
#Fixed: double gamma bug with RGB Spectrum lights
#Fixed: bump map export bug with blended diffuse/diffuse transmitters
#Fixed: save IGM bug that would occur with some nested blend materials ($g_su2in_exported_mats not properly initialized)
#Fixed: export path bugs (bug if "." in directory name or if export filename is identical to directory name)

#Version 0.9test4b

#Added: advanced user function Indigo world scale (Indigo.scale)
#Changed: RGB Absorption and RGB Scattering spectra gamma exported as 1.0
#Added: Support for Henyey-Greenstein phase function
#Changed: new material preview set courtesy of drbouvierleduc
#Added: ability to rotate environment maps (does not update with quick export)
#Fixed: sun direction bug when north angle is not default
#Fixed: material preview bug with blended materials that have clip maps

#Version 0.9test4

#Changed: You do not have to export to the Indigo directory in order to auto-render
#Changed: Quick Export can now be used even after closing SketchUp and restarting
#Changed: Default height and width to 50% of viewport dimensions
#Fixed: Loading IGM files to support new albedo_spectrum tags (loading IGM files created using previous versions not supported)
#Changed: Rendering a photomatched scene should now automatically match the photo perfectly
#Fixed: instances can now use different materials
#Changed: Shadows need not be on to enable sunlight
#Added: Black environment option
#Changed: Lots of UI improvements (toolbar, menus, etc.)
#Changed: Max number of threads to 8
#Changed: Default tracing method to Standard Path Tracing
#Changed: Prompts user to switch to Bidirectional Path tracing if using exit portals
#Fixed: material previews to work with Indigo 0.9
#Removed: Render mode and auto-render options in render settings
#Fixed: Tons of sloppy code cleanup


#Version 0.9test1

#Added: support for exit portals
#Added: support for textured emitters
#Added: material previews
#Changed: messed around with the UV set loading code
#Changed: minor UI changes

#Version 0.8 beta2

#Changed: presets for lampshade and curtains to diffuse transmitter presets
#Added: support for multiple uv sets
#Added: dummy components and dummy instancing (proxies)
#Fixed: Sketchup view zooming in when setting render settings
#Changed: Now double-click a material in the paint bucket to edit it
#Added: Explode distorted texture tool
#Added: Support for export of nested blends
#Added: Support for loading and saving of IGM nested blends
#Added: Clip map channel to all materials
#Removed: Option to disable material texture


#Version 0.8 beta1

#Added: application and material observers to determine the current selected material in the Paint Bucket
#Changed: combined material browser with material editor
#Changed: render setting 'bidirectional' to 'tracing method' to allow selection of more methods including hybrid
#Added: support for diffuse transmitter material.  Change relative amount of reflectance and transmittance with the Sketchup opacity slider
#Added: Thin Glass material type

#Version 0.7.1 Official

#Added: new light presets
#Added: support for loading and saving IGM files (Blend materials not supported yet)
#Added: support for Indigo sphere primitive by naming component definition IndigoSphere (cannot be placed inside Indigo instance)
#Added: support for Indigo instancing
#Added: Sketchup Fog export
#Changed: Default Reinhard Pre-Scale to 6.0
#Added: Export selection only
#Removed: Camera is outside the sky-sphere warning message
#Changed: Indigo path is no longer saved in the Sketchup model, it is stored in a text file in the Sketchup/Plugins directory
#Fixed: command window staying open when auto-rendering
#Changed: Default image save period to 120 seconds
#Fixed: minor bugfixes


#version 0.7test7

#Changed: Re-enabled Bidirectional Path Tracing
#Changed: export file extension from XML to IGS
#Added: Option to save igi file in render settings
#Added: Advanced user functions accessible through Ruby Console
#Changed: Materials are now listed in alphabetical order in Material Editor


#Version 0.7test5

#Added: Environment Map Support
#Added: Up to 4 threads selectable
#Changed: Mirror preset is now a specular material with high IOR (perfect dielectric)
#Added: Support for most features of Indigo 0.7
#Changed: Removed tonemapping from render settings - use Indigo tonemapper GUI
#Added: Bump map support to metals (complex IOR)
#Changed: Changed default exponent to 1000
#Added: Material editor context menu
#Added: New sss material and light presets
#Changed: aperture setting is now specified as f-stop
#Changed: minor UI changes
#Added: autofocus is selectable through focus tool
#Added: reverse gamma correction to rgb meshlights
#Added: context menu to apply material presets and quick export
#Added: New Render Modes - Export All, Separate Settings, and Settings Only (Quick Export)
#Added: Option to run Indigo in Low Priority (creates batch file) - May only work with PCs
#Changed: Material Table to Query Material Types
#Changed: Only visible geometry is exported
#Changed: Auto-render only allowed when file is exported to Indigo directory
#Changed: BPT always turned off (not working in Indigo 0.7test5)
#Changed: Default MNCR to 500 from 100.  500 works better for SSS


#Version 0.6 Official

#Changes since Beta1 - Initial Test Release
#Fixed: [,,,,] characters corrupting inifile.txt on some sytems
#Changed: Auto-render now aborts if there are no lights in scene
#Changed: Changed the way NK_Data (Complex IOR) materials are selected
#Fixed: imported 3DS materials automatically being assigned Specular material type
#Fixed: applied reverse gamma correction exponent of 2.3 to diffuse color of materials
#Changed: Sketchup camera aspect ratio will change based on width and height of render.	
#Changed: Focal Length in Set Focus Tool changed to Focus Distance
#Added: Monochrome Render Modes
#Added: Dull plastic, shiny plastic, leather, car paint, complex IOR presets
#Changed: Specular Materials can now be transparent or non-transparent depending on the opacity setting
#Changed: Negative bump values are now allowed
#Changed: Changed default fresnel to 1.0
#-----------------------------------------------------------------------------

require 'sketchup.rb'

######################
def smoothstep(min,max,input) 

r=(input.to_f-min.to_f)/(max.to_f-min.to_f)
return r*r*(3.0-2.0*r)

end


class IndigoExporter    #add these methods to this class later

def export_animation(batch_file_path,igs_path,frame_rate,smooth)

Dir.mkdir(igs_path) unless FileTest.exist?(igs_path)    #igs_path is a directory name that stores the IGS files for each frame
return 0 unless FileTest.exist?(igs_path)    #failed to create path
pages=Sketchup.active_model.pages
def_trans_time=Sketchup.active_model.options["PageOptions"]["TransitionTime"]
total_time=pages.slideshow_time
time_step=1.0/frame_rate.to_f
num_frames=(total_time*frame_rate).to_i
mesh_path=File.basename(self.path)
model_name=File.basename(mesh_path,".*")  #minus the file extension
time=0.0

#todo - check if delay is greater than 0.0 for any pages and then cancel export
page_start_time=time
page_trans=pages[0].transition_time
page_trans=def_trans_time if page_trans==-1.0
page_end_time=page_start_time+page_trans

num_frames.times {|i|
	
	Sketchup.set_status_text("Exporting Animation Frame #{i}")
	#pages.show_frame_at(time+0.01)
	get_page=pages.show_frame_at(time)
	current_page=get_page[0]
	progress=get_page[1]    #the fraction that we are into the transition
	
	
	if time>=page_end_time
		page_start_time=page_end_time
		page_trans=current_page.transition_time
		page_trans=def_trans_time if page_trans==-1.0
		page_end_time=page_start_time+page_trans
	end
	
	frame_path=File.join(File.dirname(self.path),model_name+"-#{i}.igs")
	
	smoothed_time=smoothstep(0.0,1.0,progress.to_f)*(page_end_time-page_start_time)+page_start_time
	pages.show_frame_at(smoothed_time) #if smooth
	
	out=File.new(frame_path,"w")
	out.puts "<?xml version=\"1.0\" encoding=\"utf-8\"?>"
	out.puts "<scene>"
	export_render_settings(out)
	export_tonemapping(out)
	export_camera(model.active_view,out)
	export_environment(out)
	export_fog(out) if self.model.rendering_options["DisplayFog"]

	out.puts "		<include>"
	out.puts "		<pathname>#{mesh_path}</pathname>"
	out.puts "		</include>"
	out.puts "</scene>"
	out.close
	time=time+time_step
}

#Create the batch file  - move this out of the class methods
irs=IndigoRenderSettings.new

image_name=irs.image_name
halt=irs.halt
low_priority=irs.low_priority?

indigo_path=SU2IN.get_indigo_path
return 0 if not indigo_path

#make sure that the 'renders' directory exists
root=File.dirname(indigo_path)
if not FileTest.exist?(File.join(root,"renders"))
	Dir.mkdir(File.join(root,"renders"))
end

batch=File.new(batch_file_path,"w")
batch.puts indigo_path.split(":")[0]+":"
batch.puts "cd #{File.dirname(indigo_path)}"

num_frames.times {|i|
	export_path=File.join(File.dirname(self.path),model_name+"-#{i}.igs")
	image_name=File.join(root,"renders",(File.basename(export_path,".*")+".png"))
	batch.puts "start \/wait \/low \/max indigo_console.exe \"#{export_path}\" -o \"#{image_name}\"" if low_priority
	batch.puts "start \/wait \/max indigo_console.exe \"#{export_path}\" -o \"#{image_name}\"" if !low_priority
}

batch.close
return batch_file_path

end #export animation

def export_sketchyphysics_frame(igs_path)

Dir.mkdir(igs_path) unless FileTest.exist?(igs_path)    #igs_path is a directory name that stores the IGS files for each frame - move function to initialization method???
return 0 unless FileTest.exist?(igs_path)    #failed to create path

@frame+=1
 #put this in initialization method?
mesh_path=File.basename(self.path)       
model_name=File.basename(mesh_path,".*")  #minus the file extension

#begin exporting the current frame
	
	Sketchup.set_status_text("Exporting Animation SketchyPhysics Frame #{@frame}")	
	frame_path=File.join(File.dirname(self.path),model_name+"-#{@frame}.igs")
	
	out=File.new(frame_path,"w")
	out.puts "<?xml version=\"1.0\" encoding=\"utf-8\"?>"
	out.puts "<scene>"
	export_render_settings(out)
	export_tonemapping(out)
	export_camera(model.active_view,out)
	export_environment(out)
	export_fog(out) if self.model.rendering_options["DisplayFog"]

	out.puts "		<include>"
	out.puts "		<pathname>#{mesh_path}</pathname>"
	out.puts "		</include>"
	
	export_instances(self.meshbuilder,out)
	out.puts "</scene>"
	out.close

end  #sketchyphysics frame

def create_animation_batch_file()

model = self.model
model_name=File.basename(self.path,".igs")

#Create the batch file  - move this out of the class methods
irs=IndigoRenderSettings.new

image_name=irs.image_name
halt=irs.halt
low_priority=irs.low_priority?

indigo_path=SU2IN.get_indigo_path
return 0 if not indigo_path

#make sure that the 'renders' directory exists
root=File.dirname(indigo_path)
if not FileTest.exist?(File.join(root,"renders"))
	Dir.mkdir(File.join(root,"renders"))
end

batch_file_path=self.batch_path

batch=File.new(batch_file_path,"w")
batch.puts indigo_path.split(":")[0]+":"
batch.puts "cd #{File.dirname(indigo_path)}"

@frame.times {|i|
	export_path=File.join(File.dirname(self.path),model_name+"-#{i}.igs")
	image_name=File.join(root,"renders",(File.basename(export_path,".*")+".png"))
	batch.puts "start \/wait \/low \/max indigo_console.exe \"#{export_path}\" -o \"#{image_name}\"" if low_priority
	batch.puts "start \/wait \/max indigo_console.exe \"#{export_path}\" -o \"#{image_name}\"" if !low_priority
}

batch.close
return batch_file_path

end  #create batch file

end  #end class indigo exporter


class SU2IN


##### ------  Exporting starts here ------ ######

def SU2IN::export_as(mode,textures)

model=Sketchup.active_model
model_filename = File.basename(model.path,".skp")
if model_filename!=""
	model_name = model_filename
	model_name += ".igs"
else
	model_name = "Untitled.igs" 	
end

indigo_path=SU2IN.get_indigo_path
def_path=File.dirname(indigo_path)+"\\"+model_name		#default path for exporting is the indigo directory
export_path=UI.savepanel("Export Model", "" , def_path)
return if export_path==nil
export_path=File.dirname(export_path)+"\\"+File.basename(export_path,".*")+".igs"
SU2IN.export(0,true,export_path,false)

end

####################################################
def SU2IN::export_animation(sphysics)  #sphysics is a flag for whether to export the sketchyphysics animation

model=Sketchup.active_model
model_filename = File.basename(model.path,".skp")
if model_filename!=""
	batch_name = model_filename
	batch_name += ".bat"
else
	batch_name = "Untitled.bat" 	
end
batch_file_path=UI.savepanel("Export Animation", "" , batch_name)    #path for the batch file script
return if batch_file_path==nil

if !sphysics
	prompts=["Frame Rate","Smooth Transitions"]
	values=["25.0","On"]
	enums=[nil,"On|Off"]
	results=UI.inputbox(prompts,values,enums,"Animation Options")
	return if not results
	smooth=true if results[1]=="On"
	smooth=false if results[1]=="Off"
end

export_dir=File.dirname(batch_file_path)+"\\"+File.basename(batch_file_path,".*")
Dir.mkdir(export_dir) unless FileTest.exist?(export_dir)
export_path=export_dir+"\\"+File.basename(batch_file_path,".*")+".igs" 

ie=IndigoExporter.new(export_path)
ie.physics=true if sphysics  #set the sketchyphysics flag as this modifies mesh exporting by setting the mesh axis to the center of the bounding box

model = ie.model
model_name=File.basename(ie.path,".igs")
return if model_name==""
tex_path=File.join(File.dirname(export_path),"TX_"+model_name)
ie.tex_path="TX_"+model_name

out = File.new(export_path,"w")
out.puts "<?xml version=\"1.0\" encoding=\"utf-8\"?>"
out.puts "<scenedata>"
mb=MeshBuilder.new
$g_su2in_count_tri=0
mb.get_meshes(Sketchup.active_model.entities,Geom::Transformation.new, true)

#export all materials
ie.export_default_mat(out,nil)
ie.model.materials.each {|mat| ie.export_material(IndigoMaterial.new(mat),out)}
ie.export_meshes(mb,out)
mb.spheres.each {|sphere| ie.export_sphere(sphere,out)}

p "------SkIndigo Export Run------"	
p "Faces #{mb.faces}"
p "Instances #{mb.component_instances.length}"
p "Material Meshes #{mb.mesh_materials.length}"
p "Component Meshes #{mb.component_meshes.length}"
p "Spheres #{mb.spheres.length}"
out.puts "</scenedata>"
out.close

ie.meshbuilder=mb  #storing the meshbuilder in the exporter class makes exporting sketchyphysics animation easier
#ie.export_animation(batch_file_path,File.dirname(export_path),results[0].to_f,smooth)
SU2IN.status_bar("Exporting textures")		
if FileTest.exist? (tex_path)
else
	Dir.mkdir(tex_path)
end
indigo_textures=[]

#export all textures collected during the material export process
status=ie.export_textures(ie.textures) if ie.textures.length>0
		
#Export all collected nkata
for path in ie.nkdata
	nk=NKdata.new(path)
	nk.export(tex_path)  #exports the nkdata to the textures directory
end

#Export all collected ies profiles
for path in ie.ies
	profile=IESProfile.new(path)
	profile.export(tex_path) if profile.valid?  #export the IES profiles to the textures directory
end

if !sphysics
	ie.export_animation(batch_file_path,File.dirname(export_path),results[0].to_f,smooth)
	UI.messagebox "Animation Exported Successfully."
else
	ie.batch_path=batch_file_path
	$indigo_animation_exporter=ie   #store exporter in a global variable that can be access by SketchyPhysics
end
	

end #export_animation

###### Export and Render ###########

def SU2IN::export(mode,textures,export_path,auto_render)
	
	$g_su2in_monochrome=nil
	is=IndigoRenderSettings.new
	indigo_path=SU2IN.get_indigo_path
	if indigo_path==nil
		UI.messagebox "indigo.exe not found.  Export aborted."
		return
	end
	if not export_path
		last_path=is.last_path  #returns the last path that the model was exported to
		if (last_path==nil) or (!FileTest.exist?(last_path))
			export_path=File.join(File.dirname(indigo_path),"default.igs")
		else
			export_path=last_path
		end
	end
	ie=IndigoExporter.new(export_path)
	
	model = ie.model
	model_name=File.basename(ie.path,".igs")
	return if model_name==""
	tex_path=File.join(File.dirname(export_path),"TX_"+model_name)
	ie.tex_path="TX_"+model_name
	
	renderingoptions=model.rendering_options
	render_mode=renderingoptions["RenderMode"]
	
	#TODO fix and test monochrome mode	
	if render_mode==5 and mode!=1		#tests for monochrome render mode (but not if using quick export)	
		materials = model.materials
    		translatednames = materials.collect {|m| m.display_name}
		names = materials.collect {|m| m.name}
		dropdowns=["Clay","Default"]
		dropdowns=dropdowns.push(translatednames)
		prompts=["Choose Material"]
		values=["Clay"]
		enums=[dropdowns.join("|")]
		results=inputbox prompts,values, enums,"Monochrome Render"
		return if not results
		$g_su2in_monochrome=results[0]
		$g_su2in_monochrome.gsub!(/[<>]/, '*')
		
	end

	ie.start=Time.new

	mat_path=File.join(File.dirname(ie.path),model_name+"-settings.igs")
	out_mat=File.new(mat_path,"w") #exporting settings (quick export mode)
	out_mat.puts "<?xml version=\"1.0\" encoding=\"utf-8\"?>"
	out_mat.puts "<scenedata>"
	ie.export_render_settings(out_mat)
	ie.export_tonemapping(out_mat)
	ie.export_camera(model.active_view,out_mat)
	ie.export_environment(out_mat)
	ie.export_default_mat(out_mat,nil)

	#export all materials
	model.materials.each {|mat| ie.export_material(IndigoMaterial.new(mat),out_mat)}
	
	ie.export_fog(out_mat) if model.rendering_options["DisplayFog"]
	out_mat.puts "</scenedata>"

	out_mat.close

	if mode==0			#normal export mode (exporting meshes)
		$g_su2in_count_tri=0
		selection=Sketchup.active_model.selection
		if selection.length>0
			result=UI.messagebox "Export Selected Entities Only?", MB_YESNOCANCEL
			if result==6   #yes
				ents=selection
			elsif result==7  #no
				ents=Sketchup.active_model.entities
			elsif result==2   #cancel
				return
			end
		else      #nothing selected
			ents=Sketchup.active_model.entities
		end
		out = File.new(export_path,"w")
		out.puts "<?xml version=\"1.0\" encoding=\"utf-8\"?>"
		out.puts "<scene>"
		out.puts "		<include>"
		out.puts "		<pathname>#{File.basename(mat_path)}</pathname>"
		out.puts "		</include>"
		mb=MeshBuilder.new
		mb.get_meshes(ents,Geom::Transformation.new, true)
		ie.export_meshes(mb,out)
		ie.export_instances(mb,out)
		mb.spheres.each {|sphere| ie.export_sphere(sphere,out)}
		p "------SkIndigo Export Run------"	
		p "Faces #{mb.faces}"
		p "Instances #{mb.component_instances.length}"
		p "Material Meshes #{mb.mesh_materials.length}"
		p "Component Meshes #{mb.component_meshes.length}"
		p "Spheres #{mb.spheres.length}"
		out.puts "</scene>"
		out.close
	end

	is.last_path=ie.path  #if exporting is successful, store the IGS path as an attribute
	
	if (textures)
		SU2IN.status_bar("Exporting textures")		
		if FileTest.exist? (tex_path)
		else
			Dir.mkdir(tex_path)
		end
		indigo_textures=[]
		#collect all textures in the model
		#for mat in model.materials
			#indigo_textures.push(IndigoTexture.new(mat.display_name)) if mat.texture!=nil
		#end
		#status=ie.export_textures(indigo_textures) if indigo_textures.length>0
			
		#export all textures collected during the material export process
		status=ie.export_textures(ie.textures) if ie.textures.length>0

		#Export all collected nkata
		for path in ie.nkdata
			nk=NKdata.new(path)
			nk.export(tex_path)  #exports the nkdata to the textures directory
		end

		#Export all collected ies profiles
		for path in ie.ies
			profile=IESProfile.new(path)
			profile.export(tex_path) if profile.valid?  #export the IES profiles to the textures directory
		end

		stext="All textures and model"	
	else
		stext="Model"
	end
	
	ie.end=Time.new
	elapsed=ie.end-ie.start
	time=" exported in "
	(time=time+"#{(elapsed/3600).floor}h ";elapsed-=(elapsed/3600).floor*3600) if (elapsed/3600).floor>0
	(time=time+"#{(elapsed/60).floor}m ";elapsed-=(elapsed/60).floor*60) if (elapsed/60).floor>0
	time=time+"#{elapsed.round}s. "
	p time
	SU2IN.status_bar(stext+time+" Triangles = #{$g_su2in_count_tri}")
	export_text="Model saved in file:\n"

	if not auto_render
		result=UI.messagebox (export_text + export_path + "\nWould you like to render now?"),MB_YESNO 
		auto_render=true if result==6
	end
		
#--------------Open Indigo for rendering
	if (auto_render) and (FileTest.exist?(indigo_path))
				
		command_line=create_batch_file(indigo_path,ie.path)
		command_line=command_line.gsub(/\\/,"\/")
		UI.openURL(command_line)
		
	end

end



def SU2IN::render_settings
	if not $g_skindigo_settings
		$g_skindigo_settings=IndigoSettingsEditor.new
	end
	$g_skindigo_settings.show
end


# ----------------------------------- About message
def SU2IN::about
UI.messagebox("SkIndigo 1.1.16 Released Feb 11 2009
Freeware SketchUp Exporter to Indigo 1.1.16
Author: Whaat\n\nBased on SU2KT written by Tomasz
SU2POV written by Didier Bur
and OGRE exporter by Kojack

Please visit Indigo's website and forums if you have questions about Indigo.
http://www.indigorenderer.com" , MB_MULTILINE , "About SkIndigo") 

end


#### - Send text to status bar - ####
def SU2IN::status_bar(stat_text)
	
	statbar = Sketchup.set_status_text stat_text
	
end

def SU2IN::point_to_vector(p)
	Geom::Vector3d.new(p.x,p.y,p.z)
end

def SU2IN::mat_query

table=""
model = Sketchup.active_model
materials = model.materials

materials.each do |m| 
        	
	im=IndigoMaterial.new(m)
  
	table+=m.display_name+" - "
	if im.emitter?
		table+=im.type.upcase+" (Emitter)\n"
	else
		table+=im.type.upcase+"\n"
	end
    next
end
      
       
    # Now display the results
	
	#header="MATERIAL NAME".ljust(40)
	#header+="TYPE\n"
	UI.messagebox table,MB_OK,"Indigo Material Types"

end


###############################################################

def SU2IN::get_indigo_path

path=File.dirname(__FILE__)+"\/indigo_1_1_16path.txt"

if FileTest.exist?(path)  #check if indigo_path.txt exists
	path_file=File.new(path,"r")
	indigo_path=path_file.read  #get the contents of indigo_path.txt file
	path_file.close
		
	if (FileTest.exist?(indigo_path)) and (File.basename(indigo_path)=="indigo.exe") #check if the path to indigo is valid
				
		return indigo_path
	else
		indigo_path=UI.openpanel("Locate indigo.exe","","*.exe")
		path_file=File.new(path,"w") if indigo_path
		path_file.write(indigo_path) if indigo_path
		path_file.close if indigo_path
		
	end
else
	
	indigo_path=UI.openpanel("Locate indigo.exe","","*.exe")
	path_file=File.new(path,"w") if indigo_path
	path_file.write(indigo_path) if indigo_path
	path_file.close if indigo_path
end

if (FileTest.exist?(indigo_path)) and (File.basename(indigo_path)=="indigo.exe") #check if the path to indigo is valid
	return indigo_path
else
	return nil
end

end
##############################################################
def SU2IN::get_indigo_console_path

path=SU2IN.get_indigo_path
return nil if not path

root=File.dirname(path)
c_path=File.join(root,"indigo_console.exe")
if FileTest.exist?(c_path)
	return c_path
else
	return nil
end

end

#################################
def SU2IN::pack_igm(igm_path)

return nil if !FileTest.exist?(igm_path)
p igm_path
icp=SU2IN.get_indigo_console_path
return nil if not icp
root=File.dirname(icp)

#create the output path for the PIGM file
out=File.basename(igm_path,".igm")
out+=".pigm"
out_dir=File.dirname(igm_path)
out=File.join(out_dir,out)

Dir.chdir(root) #changes the working directory to the indigo directoy
cmd="indigo_console.exe --pack \"#{igm_path}\" \"#{out}\""

status=system(cmd)  #executes the command

return nil if not status
UI.messagebox("IGM packed to #{out}")
return out

end

#############################################################
def SU2IN::unpack_pigm(pigm)   #returns the path of the igm that was unpacked

return nil if !FileTest.exist?(pigm)
icp=SU2IN.get_indigo_console_path
return nil if not icp
root=File.dirname(icp)
igm=File.basename(pigm,".pigm")
igm+=".igm"
out=File.join("unpacked",File.basename(pigm,".pigm"))
#out="unpacked"
Dir.chdir(root)  #changes the working directory to the indigo directoy
cmd="indigo_console.exe --unpack \"#{pigm}\" \"#{out}\""

status=system(cmd)   #executes the command

return nil if not status
pigm_root=File.dirname(pigm)
igm_root=File.join(root,out)
igm_dir=Dir.entries(igm_root)
igm=igm_dir.find {|f| f.split(".")[-1]=="igm"}
return nil if igm==nil  #could not find an igm file in the unpacked file
igm_path=File.join(igm_root,igm)
return igm_path

end

#############################################################
def SU2IN::quick_export

irs=IndigoRenderSettings.new
igs_path=irs.last_path
return if not igs_path
results=UI.messagebox("Refresh Textures?",MB_YESNO,"Quick Export")
return if not results
if results==6
	SU2IN.export(1,true,igs_path,true)
elsif results==7
	SU2IN.export(1,false,igs_path,true)
end

end

####################Autorun Batch File#########################

def SU2IN::create_batch_file(path,export_path)

image_name=Sketchup.active_model.get_attribute 'indigo07_settings','image_name'
custom_name=Sketchup.active_model.get_attribute 'indigo07_settings','custom_image_name',"Off"
low_priority=Sketchup.active_model.get_attribute 'indigo07_settings','low_priority',"On"
root=File.dirname(path)
if not FileTest.exist?(File.join(root,"renders"))
	Dir.mkdir(File.join(root,"renders"))
end
#batch_file_path=path[0..path.length-11]+"autorender.bat"
batch_file_path=File.join(File.dirname(path),"autorender.bat")
batch=File.new(batch_file_path,"w")
batch.puts path.split(":")[0]+":"
batch.puts "cd #{File.dirname(path)}"

if (custom_name=="On") and (image_name!="")
	image_name=File.join(root,"renders",(image_name+".png"))
	batch.puts "start \/low \/max indigo.exe \"#{export_path}\" -o \"#{image_name}\"" if low_priority=="On"
	batch.puts "start \/max indigo.exe \"#{export_path}\" -o \"#{image_name}\"" if low_priority=="Off"
else
	batch.puts "start \/low \/max indigo.exe \"#{export_path}\"" if low_priority=="On"
	batch.puts "start \/max indigo.exe \"#{export_path}\"" if low_priority=="Off"
end

batch.close
return batch_file_path

end


##################dummy instancing function#############

def SU2IN::dummy(object)

if object.class==Sketchup::Group
    return object.entities if object.name==""
    arr=object.name.split("_")
else
    arr=object.definition.name.split("_")
end
if (arr.last.upcase=="DUMMY") and (arr.length>1)
    arr.pop
    dummy_def_name=arr.join("_")
    if dummy_def_name
        def_list=Sketchup.active_model.definitions
        dummy_def=def_list[dummy_def_name]
    end
end
if dummy_def
    return dummy_def.entities
else
    if object.class==Sketchup::Group
        return object.entities
    else
        return object.definition.entities
    end
end

end #function end

##########################debug functions
def SU2IN::purge_mats

materials=Sketchup.active_model.materials
materials.each do |m|
	dicts=m.attribute_dictionaries
	dicts.delete("indigo07_materials")
	dicts.delete("uvsets")
next
end

end
#####################################

def SU2IN::purge_model

m=Sketchup.active_model
dicts=m.attribute_dictionaries
dicts.delete("indigo07_settings")
end

###########################copy a file to a different location
def SU2IN::copy_file(source,dest)

begin

in_file=File.new(source,"r")
in_data=in_file.read
in_file.close

out_file=File.new(dest,"w")
out_file.write(in_data)
out_file.close

rescue

	UI.messagebox("SkIndigo file IO error.")
end

end


#########################Function to check if current view is a photomatch view
def SU2IN::photomatch?(view)

pages=Sketchup.active_model.pages
return false if pages.count==0
page = pages.selected_page	 #gets the currently selected page
page_label=page.label
name_length=page.name.length
label_length=page_label.length

if label_length>name_length	#if using photomatch, label length will be greater than name length
	if page_label[name_length..label_length]==" (2D)"
		cam1=page.camera
                cam2=view.camera
                if (cam1.aspect_ratio==cam2.aspect_ratio) and (cam1.focal_length==cam2.focal_length) and (cam1.eye==cam2.eye) and (cam1.direction==cam2.direction) and (cam1.image_width==cam2.image_width) and (cam1.up==cam2.up)
			return true #current view is photomatch view
		end
	end
end

return false

end

def SU2IN::igm_rgb_gamma_convert(colour,in_gamma,out_gamma)

in_gamma=out_gamma if not in_gamma
return nil if not colour
rgb=colour.split(" ")
if rgb.length==3
	red=((rgb[0].to_f)**(in_gamma.to_f/out_gamma.to_f))
	green=((rgb[1].to_f)**(in_gamma.to_f/out_gamma.to_f))
	blue=((rgb[2].to_f)**(in_gamma.to_f/out_gamma.to_f))
	return [red,green,blue]
else
	return nil
end

end

def SU2IN::set_instancing(entities,instancing)

entities.each {|ent|
	e=nil
	if ent.class==Sketchup::ComponentInstance
		e=ent.definition
	elsif ent.class==Sketchup::Group
		e=ent.entities[0].parent
	end
	e.set_attribute('indigo07_settings','inst',instancing)
}

end

end ##########################################SU2IN Class end############################################


#---------------------------------------Custom Tool to select Focal distance----------------------
class FocusTool

def initialize
    @ip1 = nil
        
end

def activate
    @ip1 = Sketchup::InputPoint.new
    @ip = Sketchup::InputPoint.new
    self.reset(nil)
end

def deactivate(view)
    view.invalidate 
end

def onMouseMove(flags, x, y, view)
            
	@ip.pick view, x, y
        if( @ip != @ip1 )
           
            view.invalidate if( @ip.display? or @ip1.display? )
            @ip1.copy! @ip
                        
            view.tooltip = @ip1.tooltip
        end

end

def onLButtonDown(flags, x, y, view)
    	
        @ip1.pick view, x, y
        if( @ip1.valid? )

            	model=Sketchup.active_model		
		model.set_attribute 'indigo07_settings','fp',@ip1.position
		UI.messagebox ("New Focal Point set to #{@ip1.position}")
		                    
        end
    
    view.lock_inference
    Sketchup.active_model.select_tool nil
end


def draw(view)
    if( @ip1.valid? )
        if( @ip1.display? )
            @ip1.draw(view)
            @drawn = true
        end
        
    end
end

def onCancel(flag, view)
    self.reset(view)
end


# Reset the tool back to its initial state
def reset(view)
       
    Sketchup::set_status_text("Select Point on Focal Plane", SB_PROMPT)
    @ip1.clear
        
    if( view )
        view.tooltip = nil
        view.invalidate 
    end
  
end

end # class FocusTool

def focustool
    Sketchup.active_model.select_tool FocusTool.new
end


##########################################Context menus and Validation Procedures##################################
def selected_material
	ent = Sketchup.active_model.selection.first
	return nil if ent==nil
	$selected_material=ent.material if ent!=nil
	return nil if not $selected_material
	return $selected_material
end

def selected_component
	ent = Sketchup.active_model.selection.first
	return nil if ent==nil
	return nil if ent.class!=Sketchup::ComponentInstance
	return ent.definition
end

def validate_quick_export

igs_path=Sketchup.active_model.get_attribute 'indigo07_settings','export_path'
if  igs_path and FileTest.exist?(igs_path)
	return MF_ENABLED
else
	return MF_GRAYED
end

end





####################Advanced user functions#####################
class Indigo

def Indigo::adv

indigo_path=SU2IN.get_indigo_path
return if indigo_path==nil
inifile_path=File.dirname(indigo_path)
inifile_path+="\/inifile.xml"
if FileTest.exist?(inifile_path)
	UI.openURL(inifile_path)
else
	puts "inifile.xml not found"
end

end

def Indigo::ren

indigo_path=SU2IN.get_indigo_path
return if indigo_path==nil
renders_path=File.dirname(indigo_path)
renders_path+="\/renders"
if FileTest.exist?(renders_path)
	UI.openURL(renders_path) 
else
	puts "renders directory not found"
end

end

def Indigo::igs

export_path=Sketchup.active_model.get_attribute 'indigo07_settings','export_path'
return false if not export_path
mat_path=File.join(File.dirname(export_path),(File.basename(export_path,".igs") + "-settings.igs"))
if mat_path!=""
	if FileTest.exist?(mat_path)
		UI.openURL(mat_path)
	else
		puts "igs not found"
	end 
else
	if FileTest.exist?(export_path)
		UI.openURL(export_path) 
	else
		puts "igs not found"
	end
end

end

def Indigo::tm

indigo_path=SU2IN.get_indigo_path
return if indigo_path==nil
tm_path=File.dirname(indigo_path)
tm_path+="\/IndigoToneMapper.exe"
if FileTest.exist?(tm_path)
	UI.openURL(tm_path) 
else
	puts "IndigoToneMapper.exe not found"
end

end

def Indigo::web

UI.openURL("http:\/\/www2.indigorenderer.com\/joomla\/")

end

def Indigo::mdb

UI.openURL("http:\/\/www.elqx.com\/indmatdb\/")

end

def Indigo::res

indigo_path=SU2IN.get_indigo_path
low_priority=Sketchup.active_model.get_attribute 'indigo07_settings','low_priority',"On"
return if indigo_path==nil

igi_file=UI.openpanel("Locate Indigo Image File", "" , "*.igi")
return if igi_file==nil
igs_file=UI.openpanel("Locate Indigo Scene File","","*.igs")
return if igs_file==nil

batch_file_path=File.dirname(indigo_path)+"\/resume.bat"
batch=File.new(batch_file_path,"w")

batch.puts "start \/low \/max indigo.exe -r \"#{igi_file}\" \"#{igs_file}\"" if low_priority=="On"
batch.puts "start \/max indigo.exe -r \"#{igi_file}\" \"#{igs_file}\"" if low_priority=="Off"
batch.close

UI.openURL(batch_file_path)

end

def Indigo::scale=(val)
	Sketchup.active_model.set_attribute 'indigo07_settings','scale',val.to_f
end

def Indigo::scale
	Sketchup.active_model.get_attribute 'indigo07_settings','scale',1.0
end

end #class Indigo end



class SkindigoAppObserver <  Sketchup::AppObserver
 	def onOpenModel(m)
		if $smo
			timer=$smo.timer
			UI.stop_timer(timer) if timer
			$smo.mat_editor.close if $smo.mat_editor.visible?
		end
		$smo=nil
		$smo=SkindigoMatObserver.new
		if $g_skindigo_settings
			$g_skindigo_settings.dialog.close if $g_skindigo_settings.dialog.visible?
		end
		$g_skindigo_settings=nil	
		status=Sketchup.active_model.materials.add_observer($smo)
		$g_su2in_loaded_entities=nil if $g_su2in_loaded_entities

	end

	def onNewModel(m)

		if $smo
			timer=$smo.timer
			UI.stop_timer(timer) if timer
			$smo.mat_editor.close if $smo.mat_editor.visible?
		end
		$smo=nil  
		$smo=SkindigoMatObserver.new
		if $g_skindigo_settings
			$g_skindigo_settings.dialog.close if $g_skindigo_settings.dialog.visible?
		end
		$g_skindigo_settings=nil
		Sketchup.active_model.materials.add_observer($smo)
		$g_su2in_loaded_entities=nil if $g_su2in_loaded_entities
	end
	
	def onQuit(m)
				
		Sketchup.active_model.materials.remove_observer($smo) if $smo
		$smo=nil if $smo
		$g_skindigo_settings=nil if $g_skindigo_settings
		

	end
end


##################UV Class to Manage UV Sets####################
class UVS


def UVS::store_uvs(uvset)

face=0
case uvset
	when 0
		key="uv0"
	when 1
		key="uv1"
	when 2
		key="uv2"
	when 3
		key="uv3"
end

Sketchup.active_model.start_operation "Save UV set"

for et in $g_su2in_loaded_entities
	
	if (et[0].valid?) and (et[0].class==Sketchup::Face)
		
		polymesh=et[0].mesh 5
		uvs=polymesh.uvs 5
		for i in (0..uvs.length-1)
			uvs[i]=uvs[i].to_a  #converts the Point 3D objects to arrays so they won't be transformed
		end
		et[0].set_attribute 'uvs',key,uvs
	
	
	face=face+1
	Sketchup.set_status_text("Stored uvs for #{face} faces.")
	end
		
end

#UI.messagebox "UVs saved for #{face} faces."

Sketchup.active_model.commit_operation

end #function
##########################################load entities#####################
def UVS::load_mat_entities(mat)

Sketchup.active_model.start_operation "Load entities"

$g_su2in_loaded_entities=[]
entities=Sketchup.active_model.entities
load_entities(mat,entities,Geom::Transformation.new)

UI.messagebox "Loaded #{$g_su2in_loaded_entities.length} entities currently assigned material \"#{mat.display_name}\"."

Sketchup.active_model.commit_operation

end


##########################################load entities recursive######################
def UVS::load_entities(mat,object,trans)


if object.class == Sketchup::ComponentInstance
	entity_list=object.definition.entities
elsif object.class == Sketchup::Group
	entity_list=object.entities
else
	entity_list=object
end

Sketchup.set_status_text("Collected #{$g_su2in_loaded_entities.length} entities assigned material #{mat.display_name}")

for e in entity_list
		if (e.class == Sketchup::Group)
			
			if e.material == mat
				$g_su2in_loaded_entities.push([e,trans])
				Sketchup.set_status_text("Collected #{$g_su2in_loaded_entities.length} entities assigned material #{mat.display_name}")
			end
			UVS.load_entities(mat,e,trans*e.transformation)
			
		end
		if (e.class == Sketchup::ComponentInstance)
			if e.material == mat
				$g_su2in_loaded_entities.push([e,trans])
				Sketchup.set_status_text("Collected #{$g_su2in_loaded_entities.length} entities assigned material #{mat.display_name}")
			
			end
			UVS.load_entities(mat,e,trans*e.transformation)
							
		end
		if (e.class == Sketchup::Face)
			
			if e.material == mat
				$g_su2in_loaded_entities.push([e,trans])
				Sketchup.set_status_text("Collected #{$g_su2in_loaded_entities.length} entities assigned material #{mat.display_name}")
					
			end
			
		end
end

return nil

end #function

####################################switch the texture map#########################3

def UVS::switch_material(mat)

materials = Sketchup.active_model.materials
names = materials.collect {|m| m.name}
translatednames = materials.collect {|m| m.display_name}
    
# Display a dialog to pick a material

    prompts = ["Material Name"]
    values=[materials[0].display_name]
    enums = [translatednames.sort.join("|")]
    results = inputbox prompts, values, enums,("Assign all loaded entities to:")
    return if not results
	
current_mat=results[0]

# Get the selected Material

index = translatednames.index(current_mat)
material = index ? materials[names[index]] : nil

if( not material )
       UI.messagebox ("Could not find Material named") + " #{results[0]}"
       return
end

Sketchup.active_model.start_operation "Switch Material"
for et in $g_su2in_loaded_entities
	if et[0].valid?
		et[0].material=material 
	end
end

if material.texture!=nil
	prompts=["Select UV index"]
	values=[1]
	enums=[[1,2,3].join("|")]
	result = inputbox prompts, values, enums,("Select UV set")
	if result
		position_map(result[0],$g_su2in_loaded_entities)
	end
end

Sketchup.active_model.commit_operation

end


################################Function to position the material according to stored uvset########
def UVS::position_map(set,entities)

Sketchup.active_model.start_operation "Load UV set"

face=0
failed=0
 
case set
	
	when 0
		key="uv0"
	when 1
		key="uv1"
	when 2
		key="uv2"
	when 3
		key="uv3"
end

for et in entities
	if (et[0].valid?) and (et[0].class==Sketchup::Face)
		uvs=et[0].get_attribute 'uvs',key
		
		if uvs
			
			pos=[]
			polymesh=et[0].mesh 5
			polymesh.transform! et[1]
			polygons=polymesh.polygons
			poly_index=0
			begin
				for p in polygons[poly_index]
					point=polymesh.point_at(p.abs)
					if point
						pos.push(point) 
						pos.push(uvs[p.abs-1])
					end
				end

				et[0].position_material et[0].material, pos, true
				face=face+1
				Sketchup.set_status_text("Loaded uvs for #{face} faces")
			rescue  #this is required because SketchUp sometimes fails to position the texture properly
				poly_index=poly_index+1
				if polygons[poly_index]
					pos=[]
					retry  #try to postion texture again using next polygon in the face
				else
					failed=failed+1
				end
			end
	
			
		end
	end
end

if failed>0
	stext="Unable to load UVs for #{failed} faces.  Loaded UVs for #{face} faces."
else
	stext="Loaded UVs for #{face} faces."
end

UI.messagebox (stext)

Sketchup.active_model.commit_operation

end




########################Purge UV sets################
def UVS::purge_uvs

result=UI.messagebox "Would you like to purge all stored UV sets for the currently loaded entities?",MB_YESNO
return if result!=6

Sketchup.active_model.start_operation "Purge UV sets"

faces=0

for et in $g_su2in_loaded_entities
	if (et[0].valid?) and (et[0].class==Sketchup::Face)
		et[0].delete_attribute 'uvs'
		faces=faces+1
	end
end  


UI.messagebox "Purged UV sets for #{faces} faces."

Sketchup.active_model.commit_operation

end

####################################Explode Distorted Textures#########################
def UVS::explode_distorted_texture

face=Sketchup.active_model.selection.first
return if not face
return if face.class!=Sketchup::Face

Sketchup.active_model.start_operation "Explode Texture"
mat=face.material
materials=Sketchup.active_model.materials
new_mat=materials.add(mat.name)
new_name=new_mat.display_name+".jpg"

tw=Sketchup.create_texture_writer

if (mat.respond_to?(:texture) and mat.texture !=nil)
	status=tw.load face,true
else
	return nil
end

texture_path=UI.savepanel("Save Distorted Texture", "" ,new_name )

return if texture_path==nil		
if texture_path==texture_path.split(".")[0] #no extension given
	texture_path+=".jpg"
end


arr=[]

uvh=face.get_UVHelper true,false,tw

for p in (0..3)
	vert=face.vertices[p]
	pos=vert.position
	uvq = uvh.get_front_UVQ(pos)
	arr.push(pos)
	arr.push(uvq)
end

tw.write(face,true,texture_path)
new_mat.texture=(texture_path) if new_mat
face.position_material(new_mat,arr,true)

dict="indigo07_materials"
att=["type","exp","fres","ior","cau","precedence","sss","sssval","power","ole","bump_map","bump_value","temp","no_smooth","exp_map","expmap_value","clip_map"]

for a in att
	new_mat.set_attribute dict,a,(mat.get_attribute dict,a)
end

dict="indigo_blend"
att=[]
att=["matA","matB","blendfactor"]

for a in att
	new_mat.set_attribute dict,a,(mat.get_attribute dict,a)
end

new_mat.alpha=mat.alpha

Sketchup.active_model.commit_operation
UI.messagebox "Texture was exploded and applied to the selected face."

end


end #Class end

##########################new module for UV management
module SkIndigoUVS

def store_uvs(ents,uvset)

face=0
case uvset
	when 0
		key="uv0"
	when 1
		key="uv1"
	when 2
		key="uv2"
	when 3
		key="uv3"
end

Sketchup.active_model.start_operation "Save UV set"

for e in ents
	
	if (e.valid?) and (e.class==Sketchup::Face)
		
		polymesh=e.mesh 5
		uvs=polymesh.uvs 5
		for i in (0..uvs.length-1)
			uvs[i]=uvs[i].to_a  #converts the Point 3D objects to arrays so they won't be transformed
		end
		e.set_attribute 'uvs',key,uvs
	
	face=face+1
	Sketchup.set_status_text("Stored uvs for #{face} faces.")
	end
		
end

UI.messagebox "UVs saved for #{face} faces."

Sketchup.active_model.commit_operation

end #function

##############returns the uv mat helper material
def get_uv_mat()

name="SkIndigo UV Helper"

mats=Sketchup.active_model.materials
uv_mat=mats[name]
if uv_mat==nil
	uv_mat=mats.add(name)
end

return uv_mat

end

################
def switch_mat(ents,old_mat,new_mat,uv_set)

switched=[]
#mat_name=old_mat.name
#ents.each {|e|
	#if e.valid? and e.material==old_mat
		#switched.push(e)
	#end
#}

#switched.each {|e|
ents.each {|e|
	if e.material!=nil
		mat_name=e.material.name
	else
		mat_name=nil
	end
	e.material=new_mat
	e.set_attribute('indigo_uv','mat_name',mat_name)  #store the current material name as an attribute
	#e.back_material=old_mat  #save the old material by applying it the back face
}


end  #end switch mat

###################position a texture on a material from a stored UV set
def position_map(entities,set)

face=0
failed=0
return if set=="SU"  
key="uv"+set.to_s

for e in entities
	p e
	if (e.valid?) and (e.class==Sketchup::Face)
		
		uvs=e.get_attribute 'uvs',key    #gets the stored array of uv coordinates for this face for the given uv set
		p uvs
		if uvs
			pos=[]
			polymesh=e.mesh 5   #get a polygon mesh representation of the face
			polygons=polymesh.polygons  
			poly_index=0
			begin
				for p in polygons[poly_index]
					point=polymesh.point_at(p.abs)
					if point
						pos.push(point) 
						pos.push(uvs[p.abs-1])
					end
				end

				e.position_material e.material, pos, true
				face=face+1
				Sketchup.set_status_text("Loaded uvs for #{face} faces")
			rescue  #this is required because SketchUp sometimes fails to position the texture properly
				poly_index=poly_index+1
				if polygons[poly_index]
					pos=[]
					retry  #try to postion texture again using next polygon in the face
				else
					failed=failed+1
				end
			end
	
			
		end
	end
end

if failed>0
	stext="Unable to load
	UVs for #{failed} faces.  Loaded UVs for #{face} faces."
else
	stext="Loaded UVs for #{face} faces."
end

#UI.messagebox (stext)


end  #end position map

##############
def save_mat_texture(mat,path)   #mat is a SU material, path is the folder

Sketchup.active_model.start_operation("save_mat")
tw=Sketchup.create_texture_writer
entities = Sketchup.active_model.active_entities
helper_group=entities.add_group
if (mat.respond_to?(:texture) and mat.texture !=nil)
	helper_group.material=mat
	tw.load(helper_group)
	status = tw.write(helper_group, path)
end	
#entities.erase_entities helper_group
Sketchup.active_model.abort_operation
tw=nil
if status==0   #write successful so apply the image to the dialog
	return path
else
	return nil
end

end  

###########
def restore_old_mat(ents)

#p "restoring old mat"
materials=Sketchup.active_model.materials
status=true
ents.each {|e|
	old_mat_name=e.get_attribute('indigo_uv','mat_name') #retrieve stored material name
	if old_mat_name!=nil
		old_mat=materials[old_mat_name]
		if old_mat==nil
			status=false
		else
			p old_mat.name
			p e.material.name
			e.material=old_mat
			if old_mat.texture!=nil
				position_map([e],0)   #restore the old uv set
			end
		end
	else
		#e.material=nil  #set to default material
	end
}

return status

end

################
def purge_uvs(ents)

result=UI.messagebox "Would you like to purge all stored UV sets for the currently selected faces?",MB_YESNO
return if result!=6

Sketchup.active_model.start_operation "Purge UV sets"

faces=0

for e in ents
	if (e.valid?) and (e.class==Sketchup::Face)
		e.delete_attribute 'uvs'
		faces=faces+1
	end
end  


UI.messagebox "Purged UV sets for #{faces} faces."

Sketchup.active_model.commit_operation

end

end  #end UV module


##########################################Render Settings Editor Class
class IndigoSettingsEditor

def initialize
	@dlg=UI::WebDialog.new("SkIndigo Render Settings", false, "SkIndigoRenderSettings",500, 450, 370,100,true)
	@dlg.set_file(File.dirname(__FILE__)+'\SkIndigo\Settings.html')
	color = @dlg.get_default_dialog_color 
	@dlg.set_background_color(color)
	@irs=IndigoRenderSettings.new
	@dlg.add_action_callback("apply_settings") {|d,p|
			
		#extract checkbox and radio values
		params=p.split("|")
		save_igi=params[0].split("=")[1] 
		custom_name=params[1].split("=")[1]
		tm=params[2].split("=")[1]
		af=params[3].split("=")[1]
		env=params[4].split("=")[1]
		auto_threads=params[5].split("=")[1]
		low_priority=params[6].split("=")[1]
		watermark=params[7].split("=")[1]
		ad=params[8].split("=")[1]
		om=params[9].split("=")[1]
		rr=params[10].split("=")[1]
		
		model=Sketchup.active_model
		model.start_operation "Render Settings"

		@irs.watermark=true if (watermark=="true")
		@irs.watermark=false if (watermark=="false")
		@irs.save_igi=true if (save_igi=="true")
		@irs.save_igi=false if (save_igi=="false")
		@irs.custom_image_name=true if (custom_name=="true")
		@irs.custom_image_name=false if (custom_name=="false")
		@irs.tm=tm
		@irs.focal_point="auto" if (af=="true")
		@irs.environment=env
		@irs.auto_choose_threads=true if (auto_threads=="true")
		@irs.auto_choose_threads=false if (auto_threads=="false")
		@irs.low_priority=true if (low_priority=="true")
		@irs.low_priority=false if (low_priority=="false")
		@irs.aperture_diffraction=true if (ad=="true")
		@irs.aperture_diffraction=false if (ad=="false")
		@irs.use_obstacle_map=true if (om=="true")
		@irs.use_obstacle_map=false if (om=="false")
		@irs.render_region=true if (rr=="true") and (validate_render_region())
		@irs.render_region=false if (rr=="false")
		
		@irs.width=d.get_element_value("width")
		@irs.height=d.get_element_value("height")
		@irs.image_name=d.get_element_value("image_name")
		@irs.aperture=d.get_element_value("aperture")
		@irs.white_balance=d.get_element_value("wb")
		@irs.turbidity=d.get_element_value("turbidity")
		@irs.method=d.get_element_value("method")
		@irs.mncr=d.get_element_value("MNCR")
		@irs.image_save_period=d.get_element_value("savePeriod")
		@irs.halt=d.get_element_value("halt")
		@irs.halt_unit=d.get_element_value("haltUnit")
		@irs.num_threads=d.get_element_value("threads")
		#@irs.thumbnail_path=d.get_element_value("thumbPath")
		@irs.pre_scale=d.get_element_value("preScale")
		@irs.post_scale=d.get_element_value("postScale")
		@irs.burn=d.get_element_value("burn")
		@irs.iso=d.get_element_value("iso")
		@irs.shutter_speed=d.get_element_value("shutterSpeed")
		@irs.ev_adjust=d.get_element_value("exposure")
		@irs.exr=d.get_element_value("exr")
		@irs.exr_type=d.get_element_value("envMapType")
		@irs.exr_shift=d.get_element_value("envMapRotation")
		@irs.exr_width=d.get_element_value("envMapWidth")
		@irs.exr_gain=d.get_element_value("envMapGain")
		@irs.aperture_shape=d.get_element_value("apertureShape")
		@irs.blade_offset=d.get_element_value("bladeOffset")
		@irs.blade_curvature_radius=d.get_element_value("curvatureRadius")
		@irs.start_angle=d.get_element_value("startAngle")
		@irs.aperture_image=d.get_element_value("apertureImage")
		@irs.obstacle_map=d.get_element_value("obstacleMap")
		@irs.shift_up=d.get_element_value("shiftUp")
		@irs.shift_right=d.get_element_value("shiftRight")
				
		current_camera=model.active_view.camera
		old_aspect=current_camera.aspect_ratio
		old_aspect=1.0 if old_aspect==0.0
		f=current_camera.focal_length
		current_camera.aspect_ratio=(@irs.width.to_f)/(@irs.height.to_f)
		current_camera.focal_length=f/(current_camera.aspect_ratio/old_aspect)

		model.commit_operation

	} #end apply settings callback
	@dlg.add_action_callback("getViewSize") {|d,p|
		width=(Sketchup.active_model.active_view.vpwidth).to_s
		height=(Sketchup.active_model.active_view.vpheight).to_s
		cmd="document.getElementById('width').value=\"#{width}\""
		d.execute_script(cmd)
		cmd="document.getElementById('height').value=\"#{height}\""
		d.execute_script(cmd)
	} #end get View Size callback
	@dlg.add_action_callback("ValueChanged") {|d,p|
		pair=p.split("=")
		id=pair[0]
		value=pair[1]
		case id
			when "inifile"
				Indigo.adv   #opens inifile.xml for editing advanced indigo settings
			when "pickFocalPoint"
				focustool     #launches to focus tool
				setCheckbox("autofocus","false")
			when "envMapBrowser"
				exr=UI.openpanel "Select Environment Map", "", ""
				if exr
					exr.gsub!("\\","\/")
					setValue("exr",exr)
				end
			when "apertureImageBrowser"
				path=UI.openpanel "Select Aperture Map", "", "*.png"
				if path
					path.gsub!("\\","\/")
					setValue("apertureImage",path)
				end
			when "obstacleMapBrowser"
				path=UI.openpanel "Select Obstacle Map", "", "*.png"
				if path
					path.gsub!("\\","\/")
					setValue("obstacleMap",path)
				end
		end
	} # end Value Changed callback
	@dlg.add_action_callback("cancel_changes") {|d,p|
		getValuesFromSU()
	} 
	@dlg.add_action_callback("reset_camera") {|d,p|
		current_camera=Sketchup.active_model.active_view.camera
		current_aspect=current_camera.aspect_ratio
		if current_aspect!=0.0
			current_camera.aspect_ratio=0.0
			current_camera.image_width=0.0
			current_camera.focal_length=current_camera.focal_length*(current_aspect)
		end
	}   
	@dlg.add_action_callback("undo_changes") {|d,p|
		Sketchup.undo
		getValuesFromSU()
		model=Sketchup.active_model
		view=model.active_view
		width=@irs.width  
		height=@irs.height
		current_camera=model.active_view.camera
		old_aspect=current_camera.aspect_ratio
		old_aspect=1.0 if old_aspect==0.0
		f=current_camera.focal_length
		current_camera.aspect_ratio=(width.to_f)/(height.to_f)
		current_camera.focal_length=f/(current_camera.aspect_ratio/old_aspect)
	}
	@dlg.add_action_callback("select_region") {|d,p|
		validate_render_region()
		@irs.render_region=true
		Sketchup.active_model.select_tool SelectRegionTool.new
		setCheckbox("regionRenderCheckbox","true")
	}
	@dlg.add_action_callback("happy_easter") {|d,p|
		SU2IN.export_animation(false)
		#SU2IN.export_animation(true)   #sketchy physics testing
	} 
	
end #initialize

def show
	@dlg.show{getValuesFromSU();setExrWidth();setApertureVisible()}
end

def validate_render_region()
	if @irs.tm=="Reinhard"   #region rendering only works with camera or linear tonemapping
		UI.messagebox "Tonemapping has been set to 'Camera' for use with region rendering."
		@irs.tm="Camera"
		setRadioButton("cameraTonemapping","true")
	end
	return true
end

def setExrWidth()
	@dlg.execute_script("setExrWidthVisible()")
end

def select_region_tool()
	#Sketchup.active_model.select_tool(SelectRegionTool.new)
end

def setApertureVisible()
	@dlg.execute_script("setApertureAttributesVisible()")
end

def getValuesFromSU()
	
	#set checkboxes and radio buttons
	env=@irs.environment
	tm=@irs.tm
	
	if @irs.watermark? then setCheckbox("watermark","true")
	else setCheckbox("watermark","false")
	end
	if @irs.render_region? then setCheckbox("regionRenderCheckbox","true")
	else setCheckbox("regionRenderCheckbox","false")
	end
	if @irs.save_igi? then setCheckbox("saveigi","true")
	else setCheckbox("saveigi","false")
	end
	if @irs.custom_image_name? then setCheckbox("customName","true")
	else setCheckbox("customName","false")
	end
	if @irs.focal_point=="auto" then setCheckbox("autofocus","true")
	else setCheckbox("autofocus","false")
	end
	if env=="Sun and Sky" then setRadioButton("SunSky","true")
	elsif env=="Background" then setRadioButton("Background","true")
	elsif env=="Black" 
		setRadioButton("Background","true")
		setCheckbox("black","true")
	elsif env=="Environment Map" then setRadioButton("EnvironmentMap","true")
	end
	if tm=="Reinhard" then setRadioButton("Reinhard","true")
	elsif tm=="Camera" then setRadioButton("cameraTonemapping","true")
	end
	if @irs.auto_choose_threads? then setCheckbox("autoThreads","true")
	else setCheckbox("autoThreads","false")
	end
	if @irs.low_priority? then setCheckbox("lowPriority","true")
	else setCheckbox("lowPriority","false")
	end
	if @irs.aperture_diffraction? then setCheckbox("apertureDiffractionCheckbox","true")
	else setCheckbox("apertureDiffractionCheckbox","false")
	end
	if @irs.use_obstacle_map? then setCheckbox("obstacleCheckbox","true")
	else setCheckbox("obstacleCheckbox","false")
	end
	
	#Set other dialog input values
	setValue("width",(@irs.width))  
	setValue("height",(@irs.height)) 
	setValue("image_name",(@irs.image_name)) 
	setValue("aperture",(@irs.aperture))
	setValue("wb",(@irs.white_balance))
	setValue("method",(@irs.method))
	setValue("MNCR",(@irs.mncr))
	setValue("savePeriod",(@irs.image_save_period))
	setValue("halt",(@irs.halt))
	setValue("haltUnit",(@irs.halt_unit))
	setValue("exr",(@irs.exr))
	setValue("envMapType",(@irs.exr_type))
	setValue("envMapWidth",(@irs.exr_width))
	setValue("imagePath",(@irs.image_path))
	setValue("thumbPath",@irs.thumbnail_path)
	setValue("apertureShape",@irs.aperture_shape)
	setValue("bladeOffset",@irs.blade_offset)
	setValue("curvatureRadius",@irs.blade_curvature_radius)
	setValue("startAngle",@irs.start_angle)
	setValue("apertureImage", @irs.aperture_image)
	setValue("obstacleMap", @irs.obstacle_map)
	setValue("shiftUp",@irs.shift_up)
	setValue("shiftRight",@irs.shift_right)
	
	#Set Slider Values
	pre_scale=(@irs.pre_scale).to_f*10
	@dlg.execute_script("s.setValue(#{pre_scale.to_s})")
	post_scale=(@irs.post_scale).to_f*10
	@dlg.execute_script("s2.setValue(#{post_scale.to_s})")
	burn=(@irs.burn).to_f*10
	@dlg.execute_script("s3.setValue(#{burn.to_s})")
	iso=(@irs.iso)
	@dlg.execute_script("s5.setValue(#{iso})")
	shutterSpeed=(@irs.shutter_speed).to_f*10
	@dlg.execute_script("s6.setValue(#{shutterSpeed})")
	exposure=(@irs.ev_adjust)
	@dlg.execute_script("s7.setValue(#{exposure})")
	turbidity=(@irs.turbidity).to_f*10
	@dlg.execute_script("s8.setValue(#{turbidity.to_s})")
	envMapGain=(@irs.exr_gain)
	@dlg.execute_script("s9.setValue(#{envMapGain})")
	envMapRotation=(@irs.exr_shift)
	@dlg.execute_script("s10.setValue(#{envMapRotation})")
	threads=(@irs.num_threads)
	@dlg.execute_script("s11.setValue(#{threads})")
		
end #getValuesFromSU

def setValue(id,value)
	new_value=value.to_s
	cmd="document.getElementById('#{id}').value=\"#{new_value}\""
	@dlg.execute_script(cmd)
end

def setCheckbox(id,checked)
	cmd="document.getElementById('#{id}').checked=#{checked}"
	@dlg.execute_script(cmd)
end

def setRadioButton(id,checked)
	cmd="document.getElementById('#{id}').checked=\"#{checked}\""
	@dlg.execute_script(cmd)
end

def dialog   
	return @dlg
end

end #class

########################################Indigo Material Interface
class IndigoMaterial

include SkIndigoUVS

#These class variables are used as the material defaults
@@dict="indigo07_materials"  #do not change this dictionary (needed for backward compatibility)
@@type="Diffuse"
@@ior=1.52
@@cau=0.0
@@fres=1.0
@@sigma=0.5
@@power=100
@@ole=17.5
@@exp=1000
@@precedence=10
@@temp=5000
@@g_spectrum=1.0
@@no_smooth="No"
@@ies="No"
@@ies_path=""
@@sss="No"
@@sssval=0.0
@@phase_function="Uniform"
@@albedo_texture="SketchUp|Default|0.0|1.0|0.0|2.2"
@@blend_map="SketchUp|Default|0.0|1.0|0.0|1.0"
@@bump_map="None|Default|0.0|0.0|0.0|1.0"
@@exp_map="None|Default|0.0|1000|0.0|1.0"
@@clip_map="None|Default|0.0|1.0|0.0|1.0"
@@disp_map="None|Default|0.0|0.0|0.0|1.0"
@@emission_map="None|Default|0.0|0.0|0.0|2.2"
@@sigma_map="None|Default|0.0|0.0|0.0|1.0"
@@specular_map="SketchUp|Default|0.0|1.0|0.0|2.2"
@@base_emission=[255,255,255]
@@base_emission_gain=0.0
@@base_emission_spectrum="Blackbody"
@@layer=-1
@@thumbnail=""
@@max_subdiv=6
@@pixel_threshold=4.0
@@curvature_threshold=-1
@@sub_smooth=false
@@linked_igm=""

@@matA="None"
@@matB="None"
@@blendfactor=0.5
@@nkdata=File.join(File.dirname(SU2IN.get_indigo_path),"nkdata","Al.nk")
@@use_nkdata="No"

attr_reader :mat
				
def initialize(su_material)
	@mat=su_material
	#following code is for backward compatibility
	dicts=@mat.attribute_dictionaries
	return if not dicts
	if dicts["indigo_blend"]
		dict=dicts["indigo_blend"]
		self.blend_factor=dict["blendfactor"]
		self.a_name=dict["matA"]
		self.b_name=dict["matB"]
		dicts.delete(dict)
	end
	if dicts["indigo07_materials"]
		dict=dicts["indigo07_materials"]
		keys=dict.keys
		if keys.index("bump_value")
			b=dict["bump_value"]
			b=0.0 if not b
			dict.delete_key("bump_value")
			bm=self.bump_map
			bm.b=b
			self.bump_map=bm
		end
		if keys.index("expmap_value")
			b=dict["expmap_value"]
			b=1000 if not b
			dict.delete_key("expmap_value")
			em=self.exponent_map
			em.b=b
			self.exponent_map=em
		end
		#following code is due to deprecation of blackbody and rgb lights - now are converted to light-emitting materials
		t=self.type
		if (t=="Blackbody Light") or (t=="RGB Light")
			self.base_emission_spectrum="Blackbody" if t=="Blackbody Light"
			self.base_emission_spectrum="RGB" if t=="RGB Light"
			self.type="Diffuse"  #change the type to diffuse
			self.layer=0         #set the layer to 0 to ensure the material will emit light when rendering
		end
	end
	if dicts["uvsets"]
		dict=dicts["uvsets"]
		keys=dict.keys
		if keys.index("albedo")
			set=dict["albedo"]
			set="Default" if not set
			dict.delete_key("albedo")
			am=self.albedo_texture
			am.uv_set=set
			self.albedo_texture=am
		end
		if keys.index("bump")
			set=dict["bump"]
			set="Default" if not set
			dict.delete_key("bump")
			bm=self.bump_map
			bm.uv_set=set
			self.bump_map=bm
		end
		if keys.index("exponent")
			set=dict["exponent"]
			set="Default" if not set
			dict.delete_key("exponent")
			em=self.exponent_map
			em.uv_set=set
			self.exponent_map=em
		end
		if keys.index("blend")
			set=dict["blend"]
			set="Default" if not set
			dict.delete_key("blend")
			bm=self.blend_map
			bm.uv_set=set
			self.blend_map=bm
		end
		if keys.index("clip")
			set=dict["clip"]
			set="Default" if not set
			dict.delete_key("clip")
			cm=self.clip_map
			cm.uv_set=set
			self.clip_map=cm
		end
		dicts.delete(dict)
	end
	
end

####################Method to find a SU material based on display name
def IndigoMaterial.find(display_name) 
	materials=Sketchup.active_model.materials
	display_names = materials.collect {|m| m.display_name}
	names=materials.collect {|m| m.name}
	index=display_names.index(display_name)
	mat=index ? materials[names[index]] : nil  #get the SU material
	if mat
		return IndigoMaterial.new(mat)
	else
		return nil
	end
end

#####################################returns and existing material or creates a new material with the given texture image
def IndigoMaterial.find_texture_file(path)

filename=File.basename(path)
mats=Sketchup.active_model.materials
textures=mats.collect {|m| (m.texture ? File.basename(m.texture.filename) : nil)}
names=mats.collect {|m| m.display_name}
index=textures.index(filename)
if index
	return IndigoMaterial.new(mats[index])
else
	new_mat=mats.add(File.basename(filename,".*"))
	if FileTest.exist?(path)
		new_mat.texture=path
		UI.messagebox "New texture material created name #{new_mat.display_name}"
		return IndigoMaterial.new(new_mat)
	else
		UI.messagebox "Could not find or create material with texture #{filename}"
		return nil
	end
end

end

def name
	return display_name.gsub(/[<>]/, '*')  #replaces <> characters with *
end

def rgb
	return mat.color.red,mat.color.green,mat.color.blue
end
########################Attribute read and writer functions########################33
def type
	t=mat.get_attribute(@@dict,'type')  #check if the type has been set
	if not t
		if mat.alpha<1.0
			return "Specular"
		else
			return @@type
		end
	else
		return t
	end
end

def indigo_type
	t=self.type
	case t
	when "Diffuse"
		if mat.alpha==0 
			xml="diffuse_transmitter"
		else
			xml="diffuse"
		end
	when "Specular","Phong","Blend"
		xml=t.downcase
	when "Metals"
		xml="phong"
	when "Glossy Transparent"
		xml="glossy_transparent"
	when "Oren-Nayar"
		xml="oren_nayar"
	else
		xml=t
	end
end

def texture
	mat.texture
end

def texture=(value)
	mat.texture=(value)
end

def thumbnail
	mat.get_attribute(@@dict,'thumbnail',@@thumbnail)
end

def thumbnail=(path)
	mat.set_attribute(@@dict,'thumbnail',path)
end

def type=(value)
	mat.set_attribute(@@dict,'type',value)
end

def ior
	mat.get_attribute(@@dict,'ior',@@ior)
end

def ior=(value)
	mat.set_attribute(@@dict,'ior',value)
end

def fresnel_scale
	mat.get_attribute(@@dict,'fres',@@fres)
end

def fresnel_scale=(value)
	mat.set_attribute(@@dict,'fres',value)
end

def sigma
	mat.get_attribute(@@dict,'sigma',@@sigma)	
end

def sigma=(value)
	mat.set_attribute(@@dict,'sigma',value)
end

def cauchy_b_coeff
	mat.get_attribute(@@dict,'cau',@@cau)
end

def cauchy_b_coeff=(value)
	mat.set_attribute(@@dict,'cau',value)
end

def power_drawn
	mat.get_attribute(@@dict,'power',@@power)
end

def power_drawn=(value)
	mat.set_attribute(@@dict,'power',value)
end

def overall_luminous_efficacy
	mat.get_attribute(@@dict,'ole',@@ole)
end

def overall_luminous_efficacy=(value)
	mat.set_attribute(@@dict,'ole',value)
end
	
def exponent
	mat.get_attribute(@@dict,'exp',@@exp)
end

def exponent=(value)
	#mat.set_attribute(@@dict,'exp',value)
	em=self.exponent_map
	em.b=value
	self.exponent_map=em
end

def precedence
	mat.get_attribute(@@dict,'precedence',@@precedence)
end

def precedence=(value)
	mat.set_attribute(@@dict,'precedence',value)
end

def temperature
	mat.get_attribute(@@dict,'temp',@@temp)
end

def temperature=(value)
	mat.set_attribute(@@dict,'temp',value)
end

def g_spectrum
	mat.get_attribute(@@dict,'g_spectrum',@@g_spectrum)
end

def g_spectrum=(value)
	mat.set_attribute(@@dict,'g_spectrum',value)
end

def smooth?  #tas of version 1.1.1 this method returns whether subdivision smoothing is enabled (no longer used for normal smoothing)
	mat.get_attribute(@@dict,'sub_smooth',@@sub_smooth)
end

def smooth=(value)
	if value
		mat.set_attribute(@@dict,'sub_smooth',true)  #enables subdivision smoothing
	else
		mat.set_attribute(@@dict,'sub_smooth',false)  #disables subdivision smoothing
	end
end

def ies?
	use_ies=mat.get_attribute(@@dict,'ies',@@ies)
	return true if use_ies=="Yes"
	return false if use_ies=="No"
end

def ies=(value)
	if value
		mat.set_attribute(@@dict,'ies',"Yes")  #enable ies profile
	else
		mat.set_attribute(@@dict,'ies',"No")  #disables ies profile
	end
end

def use_nkdata?
	use_nkdata=mat.get_attribute(@@dict,'use_nkdata',@@use_nkdata)
	return true if use_nkdata=="Yes"
	return false if use_nkdata=="No"
end

def use_nkdata=(value)
	if value
		mat.set_attribute(@@dict,'use_nkdata',"Yes")
	else
		mat.set_attribute(@@dict,'use_nkdata',"No")
	end
end

def ies_profile
	path=mat.get_attribute(@@dict,'ies_path',@@ies_path)
	return IESProfile.new(path)
end

def ies_profile=(value)  #value is an IESProfile object
	mat.set_attribute(@@dict,'ies_path',value.path)
end

def linked_igm
	path=mat.get_attribute(@@dict,'linked_igm',@@linked_igm)
	return path
end

def linked_igm=(value)
	value=value.gsub(/\\/,"\/")
	mat.set_attribute(@@dict,'linked_igm',value)
end

def sss?
	use_sss=mat.get_attribute(@@dict,'sss',@@sss)
	return true if use_sss=="Yes"
	return false if use_sss=="No"
end

def sss=(value)
	if value
		mat.set_attribute(@@dict,'sss',"Yes")  #enable sub-surface scattering
	else
		mat.set_attribute(@@dict,'sss',"No")  #disables sub-surface scattering
	end
end

def sss_spectrum
	mat.get_attribute(@@dict,'sssval',@@sssval)
end

def sss_spectrum=(value)
	#TODO validation
	mat.set_attribute(@@dict,'sssval',value)
end	

def phase_function
	mat.get_attribute(@@dict,'phase_function',@@phase_function)
end

def phase_function=(value)
	mat.set_attribute(@@dict,'phase_function',value)
end

def albedo_texture?
	t=self.type
	case t
	when "Specular","Glossy Transparent","Blend","Thin Glass","RGB Light","Blackbody Light","Exit Portal","Linked IGM","Metals"
		return false
	else
		return texture?(self.albedo_texture)
	end
			
end

def albedo_shader?
	t=self.type
	case t
	when "Specular","Glossy Transparent","Blend","Thin Glass","RGB Light","Blackbody Light","Exit Portal","Linked IGM","Metals"
		return false
	else
		return self.albedo_texture.procedural?
	end
end


def albedo_texture
	tex=IndigoTexture.new(mat.get_attribute(@@dict,'albedo_map',@@albedo_texture))
	return tex
end

def albedo_texture=(tex)  
	mat.set_attribute(@@dict,'albedo_map',tex.to_s)	
end


def specular_map?
	t=self.type
	case t
	when "Metals"
		return texture?(self.specular_map)
	else
		return false
	end
			
end

def specular_shader?
	t=self.type
	case t
	when "Metals"
		return self.specular_map.procedural?
	else
		return false
	end
end


def specular_map
	tex=IndigoTexture.new(mat.get_attribute(@@dict,'specular_map',@@specular_map))
	return tex
end

def specular_map=(tex)  
	mat.set_attribute(@@dict,'specular_map',tex.to_s)	
end

def blend_map?
	t=self.type
	case t
	when "Blend"
		return texture?(self.blend_map)
	else
		return false
	end
end

def blend_shader?
	t=self.type
	case t
	when "Blend"
		return self.blend_map.procedural?
	else
		return false		
	end
end

def blend_map
	tex=IndigoTexture.new(mat.get_attribute(@@dict,'blend_map',@@blend_map))
	return tex
end

def blend_map=(tex)  
	mat.set_attribute(@@dict,'blend_map',tex.to_s)	
end

def bump_map
	tex=mat.get_attribute(@@dict,'bump_map',@@bump_map)
	return IndigoTexture.new(tex)
end

def bump_map=(tex)  #tex is an IndigoTexture object
	mat.set_attribute(@@dict,'bump_map',tex.to_s)	
end

def bump_map?
	t=self.type
	case t
	when "Blend","RGB Light","Blackbody Light","Exit Portal","Linked IGM"
		return false
	else
		return false if self.indigo_type=="diffuse_transmitter"
		return texture?(self.bump_map)
	end
end

def bump_shader?
	t=self.type
	case t
	when "Blend","RGB Light","Blackbody Light","Exit Portal","Linked IGM"
		return false
	else
		return false if self.indigo_type=="diffuse_transmitter"
		return self.bump_map.procedural?
	end
end

def disp_map
	tex=mat.get_attribute(@@dict,'disp_map',@@disp_map)
	return IndigoTexture.new(tex)
end

def disp_map=(tex)
	mat.set_attribute(@@dict,'disp_map',tex.to_s)
end

def disp_map?
	t=self.type
	case t
	when "RGB Light","Blackbody Light","Exit Portal","Linked IGM"
		return false
	else
		return texture?(self.disp_map)
	end
end

def disp_shader?
	t=self.type
	case t
	when "RGB Light","Blackbody Light","Exit Portal","Linked IGM"
		return false
	else
		return self.disp_map.procedural?
	end

end

def emitter?
	t=self.type
	case t
	when "Blend"
		return false
	else
		#gain=self.base_emission_gain
		#if gain.to_f>0.0 and self.layer!="-1"
		if self.layer!=(-1)
			return true
		else
			return false
		end
	end
end	


def base_emission  #returns a three element array representing the rgb color
	default=mat.color  #default base emission is the material color
	mat.get_attribute(@@dict,'base_emission',[default.red,default.green,default.blue])
end

def base_emission=(rgb)  #rgb is a three float array representing the rgb color
	mat.set_attribute(@@dict,'base_emission',rgb)
end

def base_emission_gain
	mat.get_attribute(@@dict,'base_emission_gain',@@base_emission_gain)
end

def base_emission_gain=(value)
	mat.set_attribute(@@dict,'base_emission_gain',value.to_f)
end

def base_emission_spectrum
	mat.get_attribute(@@dict,'base_emission_spectrum',@@base_emission_spectrum)
end

def base_emission_spectrum=(value)
	mat.set_attribute(@@dict,'base_emission_spectrum',value)
end

def emission_map
	tex=mat.get_attribute(@@dict,'emission_map',@@emission_map)
	return IndigoTexture.new(tex)
end

def emission_map=(tex)
	mat.set_attribute(@@dict,'emission_map',tex.to_s)
end

def emission_map?
	t=self.type
	case t
	when "Blend","RGB Light","Blackbody Light","Exit Portal","Linked IGM"
		return false
	else
		return texture?(self.emission_map)
	end
end

def emission_shader?
	t=self.type
	case t
	when "Blend","RGB Light","Blackbody Light","Exit Portal","Linked IGM"
		return false
	else
		return self.emission_map.procedural?
	end

end


def sigma_map
	tex=mat.get_attribute(@@dict,'sigma_map',@@sigma_map)
	return IndigoTexture.new(tex)
end

def sigma_map=(tex)
	mat.set_attribute(@@dict,'sigma_map',tex.to_s)
end

def sigma_map?
	t=self.type
	case t
	when "Diffuse","Specular","Phong","Glossy Transparent","Blend","Metals","Thin Glass","RGB Light","Blackbody Light","Exit Portal","Linked IGM"
		return false
	else
		return texture?(self.sigma_map)
	end
end

def sigma_shader?

	t=self.type
	case t
	when "Diffuse","Specular","Phong","Glossy Transparent","Blend","Metals","Thin Glass","RGB Light","Blackbody Light","Exit Portal","Linked IGM"
		return false
	else
		return self.sigma_map.procedural?
	end

end
	

def exponent_map
	tex=mat.get_attribute(@@dict,'exp_map',@@exp_map)
	return IndigoTexture.new(tex)
end

def exponent_map=(tex)
	mat.set_attribute(@@dict,'exp_map',tex.to_s)
end

def exponent_map?
	t=self.type
	case t
	when "Diffuse","Specular","Blend","Thin Glass","RGB Light","Blackbody Light","Exit Portal","Linked IGM"
		return false
	else
		return texture?(self.exponent_map)
	end
end

def exponent_shader?
	t=self.type
	case t
	when "Diffuse","Specular","Blend","Thin Glass","RGB Light","Blackbody Light","Exit Portal","Linked IGM"
		return false
	else
		return self.exponent_map.procedural?
	end

end

def clip_map
	tex=mat.get_attribute(@@dict,'clip_map',@@clip_map)
	return IndigoTexture.new(tex)
end

def clip_map=(tex)
	mat.set_attribute(@@dict,'clip_map',tex.to_s)
end

def clip_map?
	t=self.type
	case t
	when "RGB Light","Blackbody Light","Exit Portal","Linked IGM", "Thin Glass"
		return false
	else
		return texture?(self.clip_map)
	end
end

def clip_shader?
	t=self.type
	case t
	when "RGB Light","Blackbody Light","Exit Portal","Linked IGM", "Thin Glass"
		return false
	else
		return self.clip_map.procedural?
	end
end

def a_name
	mat.get_attribute(@@dict,'matA',@@matA)
end

def a_name=(value)
	mat.set_attribute(@@dict,'matA',value)
end

def b_name
	mat.get_attribute(@@dict,'matB',@@matB)
end

def b_name=(value)
	mat.set_attribute(@@dict,'matB',value)
end

def blend_factor
	mat.get_attribute(@@dict,'blendfactor',@@blendfactor)
end

def blend_factor=(value)
	mat.set_attribute(@@dict,'blendfactor',value)
end

def nk_data
	path=mat.get_attribute(@@dict,'nkdata', @@nkdata)
	return NKdata.new(path)
end

def nk_data=(value) #value is an NKdata ojbect
	mat.set_attribute(@@dict,'nkdata',value.path)  #stores the path to the nkdata
end

def alpha=(value)
	mat.alpha=(value)
end

def alpha
	mat.alpha
end

def display_name
	mat.display_name
end

def color
	mat.color
end

def color=(value)
	mat.color=(value)
end	

def max_subdiv
	mat.get_attribute(@@dict,'max_subdiv',@@max_subdiv)
end

def max_subdiv=(value)
	mat.set_attribute(@@dict,'max_subdiv',value)
end

def pixel_threshold
	mat.get_attribute(@@dict,'pixel_threshold',@@pixel_threshold)
end

def pixel_threshold=(value)
	mat.set_attribute(@@dict,'pixel_threshold',value)
end

def curvature_threshold
	#return -1  #this feature currently disabled
 	mat.get_attribute(@@dict,'curvature_threshold',@@curvature_threshold)
end

def curvature_threshold=(value)
	mat.set_attribute(@@dict,'curvature_threshold',value)
end

def layer
	mat.get_attribute(@@dict,'layer',@@layer)
end

def layer=(value)
	mat.set_attribute(@@dict,'layer',value.to_i)
end

def valid?
	materials=Sketchup.active_model.materials
	begin
		if materials[mat.name]
			return true
		else
			return false
		end
	rescue
		return false
	end
end

def color_picker?

if mat.display_name=="SkIndigo Color Picker"
	return true
end

return false

end

def uv_helper?

if mat.display_name=="SkIndigo UV Helper"
	return true
end

return false

end

def texture?(tex)

case tex.type
	when "SketchUp"
		return true if mat.texture!=nil
	when "External"
		return true #if tex.valid?
	else
		return false
end

end

end #Indigo material class end

######################
class IndigoColorPicker

@@picker_name="SkIndigo Color Picker"

def initialize(color)

mats=Sketchup.active_model.materials
picker_mat=mats[@@picker_name]

if picker_mat
	@picker_mat=picker_mat
else
	@picker_mat=mats.add(@@picker_name)
end
if @picker_mat
	@picker_mat.color=color
	mats.current=@picker_mat
end

end

######
def color

return @picker_mat.color

end

end  #end class color picker


################NKData class#####################
class NKdata

def initialize(path)
	@path=path
end

def valid?
	if (@path) and (FileTest.exist?(@path))
		return true
	else
		return false
	end
end

def to_s
	return @path.gsub(/\\/,"\/")
end

def path
	return @path
end

def path=(new_path)
	@path=new_path
end

def filename
	File.basename(@path)
end

def name
	File.basename(@path,".*")
end

def export(export_path)
	if (not valid?)
		UI.messagebox "NKdata path \"#{@path}\" is not valid."
		return
	else
		if FileTest.exist?(export_path)
			export_path=File.join(export_path,filename)
			nkdata=File.new(@path,"r")
			file_contents=nkdata.read
			nkdata.close
			export_file=File.new(export_path,"w")
			export_file.write(file_contents)
			export_file.close
		else
			UI.messagebox "Unable to write nkdata file to path #{export_path}"
		end
	end
end


end #class NKdata

################IESProfile class#####################
class IESProfile < NKdata

def export(export_path)
	if (not valid?)
		UI.messagebox "IES path is not valid."
		return
	else
		if FileTest.exist?(export_path)
			export_path=File.join(export_path,filename)
			ies_file=File.new(@path,"r")
			file_contents=ies_file.read
			ies_file.close
			export_file=File.new(export_path,"w")
			export_file.write(file_contents)
			export_file.close
		else
			UI.messagebox "Unable to write IES file to path #{export_path}"
		end
	end
end


end #class IESProfile

###################Indigo Texture Class################
class IndigoTexture

@@preview_uvset="default"   #this is the uvset name that will be exported for material previews

attr_reader :uv_set, :a, :b, :c, :exponent, :u_scale, :v_scale, :shader_code, :type, :path
attr_writer :uv_set, :a, :b, :c, :exponent, :u_scale, :v_scale, :shader_code, :type, :path

def initialize(attribute_string)    #The format of the attribute string must be "type|uv_set|a|b|c|exponent|shader_code|path"
	attributes=attribute_string.split("|")
	@type=attributes[0]
	case @type
	when "None","SketchUp","External","Shader"
		#do nothing
	when "SU"
		@type="SketchUp"
	else
		@type="None"
	end
	@uv_set=attributes[1] ? attributes[1]:"Default"
	@uv_set="Default" if @uv_set=="0"  #for backwards compatibility
	@a=attributes[2] ? attributes[2]:0.0
	@b=attributes[3] ? attributes[3]:1.0
	@c=attributes[4] ? attributes[4]:0.0
	@exponent=attributes[5] ? attributes[5]:1.0
	@shader_code=attributes[6] ? attributes[6]:"Enter Shader Code"
	@path=attributes[7] ? attributes[7]:""
end
	
def procedural?

	case type
		when "Fractal","Shader","Noise"
			return true
		else
			return false
	end
	
end

def shader_code
	case type
		when "Fractal"
			return "def eval(vec3 pos) vec3:vec3(add(mul(fbm(mul(getTexCoords(0),5.0),10),1.0),0.0))"
		when "Noise"
			return "def eval(vec3 pos) vec3:vec3(add(mul(noise(mul(getTexCoords(0),5.0)),1.0),0.0))"
		else
			return @shader_code
	end

end


def preview_uvset
	@@preview_uvset
end

def filename
	return 	File.basename(@path)
end

def export_filename
	illegal="\\\/:*?\"<>|"   #characters not allowed in filenames
	return filename
	#return @su_mat.name.delete(illegal)+".jpg"
end

def valid?
	case @type
		when "SketchUp"
			######
		when "External"
			if FileTest.exist?(@path)
				return true
			else
				return false
			end
	end
	
end

def to_s
	
[type, uv_set, a, b, c, exponent, shader_code, path].join("|")
		
end


end #end of class IndigoTexture


#######################################SkIndigo Material Editor############################3

class SkindigoMatObserver <  Sketchup::MaterialsObserver

include SkIndigoUVS

def initialize
	@model=Sketchup.active_model
	@default_ui="normal"
	@dict="indigo07_settings"
	@ui=@model.get_attribute(@dict,'ui',@default_ui)
	@start=nil
	@preset_dlg=nil
	@sm=nil   #the currently selected material
	@selection_stack=[Sketchup.active_model.materials.current]
	@mat_editor=UI::WebDialog.new("SkIndigo Material Editor", false, "SkIndigoMaterialEditor",270, 768, 1,1,true)
	fn=File.dirname(__FILE__)+'\SkIndigo\MaterialEditor.html'
	@mat_editor.set_file fn
	color = @mat_editor.get_default_dialog_color 
	@mat_editor.set_background_color(color)
	@mat_editor.set_on_close {@preset_dlg.close if (@preset_dlg) and (@preset_dlg.visible?)}
	#############Primary Event Handler Callback Function for Material Editor##################

	@mat_editor.add_action_callback("ValueChanged") {|d,p|
		pair=p.split("=")
		id=pair[0]           
		value=pair[1]
		type=sm.type
		case id
			when "AssignPresetButton"
				
				if @preset_dlg
					@preset_dlg.show{} unless @preset_dlg.visible?
					@preset_dlg.bring_to_front
					return
				end
					
				#Create the Preset Selection Dialog
				@preset_dlg=UI::WebDialog.new("Select Material Preset", false,"SkIndigoPresets", 300, 768, 272, 1, true)
				fn= File.dirname(__FILE__)+'\SkIndigo\presets.html'
				@preset_dlg.set_file fn
				color = @preset_dlg.get_default_dialog_color 
				@preset_dlg.set_background_color(color)
				@preset_dlg.add_action_callback("assign_preset") {|d,p|
					params=p.split("=")
					preset=params[0]
					use_thumb=params[1]
					if use_thumb=="true"
						new_thumbnail=File.join(File.dirname(__FILE__),"SkIndigo",preset+".jpg")
						sm.thumbnail=new_thumbnail
					end
					case preset
   						when "glass"
							apply_glass(sm)
						when "frostedGlass"
							apply_frosted_glass(sm)
						when "mirror"
							apply_mirror(sm)
						when "ceramic"
							apply_ceramic(sm)
						when "dullPlastic"
							apply_dull_plastic(sm)
						when "shinyPlastic"
							apply_shiny_plastic(sm)
						when "leather"
							apply_leather(sm)
						when "carPaint"
							apply_car_paint(sm)
						when "lampshade"
							apply_lampshade(sm)
						when "gold"
							apply_nkdata(sm,"Au.nk")
						when "tintedGlass"
							apply_tinted_glass(sm)
						when "water"
							apply_water(sm)
						when "lambertian"
							apply_lambertian(sm)
						when "incan100w"
							apply_100W(sm)
						when "fluor34wcool"
							apply_34WTFC(sm)
						when "fluor34wmid"
							apply_34WTFM(sm)
						when "fluor34wwarm"
							apply_34WTFW(sm)
					end
					getValuesFromSU()   #updates the material editor with new material values
					setVisibility()
						
				}
					
				@preset_dlg.show{}
					
					
			when "SwitchUI"
				if @ui=="normal" 				 
					@ui=@model.set_attribute(@dict,'ui',"simple")
				else	
					@ui=@model.set_attribute(@dict,'ui',"normal")
  				end
				
				setVisibility()
				getValuesFromSU()
					
			when "PreviewButton"
				if ((type=="Blackbody Light") or (type=="RGB Light") or (type=="Exit Portal"))
					UI.messagebox "#{type} materials are currently not supported by this feature."
				else
					path=SU2IN.get_indigo_path
					return if not path
					thumbnail_path=IndigoRenderSettings.new().thumbnail_path
					if not FileTest.exist?(thumbnail_path)
						UI.messagebox "Thumbnail path not found. Preview aborted."
						return
					end
					mat_name=sm.mat.display_name.delete("<>")		
					new_thumbnail=File.join(thumbnail_path,mat_name+".png")
					File.delete(new_thumbnail) if FileTest.exist?(new_thumbnail)
					sm.thumbnail=new_thumbnail
					preview_material(sm,value)
					if @timer
						UI.stop_timer(@timer)
					end
					cmd="document.getElementById(\"PreviewImage\").src=\"#{new_thumbnail}\";"
					d.execute_script(cmd)
					
					@timer=UI.start_timer(2,true) {getValuesFromSU()}
				end
			when "SaveIGMButton"
				if ((type=="Blackbody Light") or (type=="RGB Light") or (type=="Exit Portal") or (type=="Linked IGM"))
					UI.messagebox "#{type} materials are currently not supported by this feature."
			
				else
					igm=UI.savepanel("Save IGM", "",((sm.display_name.delete("<>"))+".igm"))
					return if igm==nil
					file_name=File.basename(igm,".*")
					igm=File.join(File.dirname(igm),file_name+".igm")
					result=UI.messagebox("Would you like to pack this IGM? (Recommended)",MB_YESNO)
					if result==6
						pack=true
					else
						pack=false
					end		
					IndigoExporter.new(igm).export_igm(sm,pack)
				end
			when "LoadIGMButton"
				UI.messagebox("Sorry, this feature is currently disabled.  However, you can still use IGM or PIGM materials by changing the material type to Linked IGM.")
				
				#igm=UI.openpanel "Load IGM", "", ""
				#return if igm==nil
				#if (FileTest.exist?(igm))
				#	f_name=File.basename(igm)
				#	if f_name.split(".")[-1]=="pigm"  #loading a PIGM file
				#		igm=SU2IN.unpack_pigm(igm)
				#		return if igm==nil
				#		Dir.chdir(File.dirname(igm))  #set the working directory to the unpacked igm file
				#	end
				#	result=load_igm(igm,sm)
				#	#TODO error reporting
				#end
				#refreshTextureList()
				#refreshBlendList()
				#getValuesFromSU()
				#setVisibility()    
			when "type"
				sm.type=value
				sm.alpha=0.2 if value=="Thin Glass"
				setVisibility()
			when "layer"
				sm.layer=value
			when "ior"
				sm.ior=value
			when "cau"
				sm.cauchy_b_coeff=value
			when "exp"
				sm.exponent=value
			when "precedence"
				sm.precedence=value
			when "temp"
				sm.temperature=value
			when "power"
				sm.power_drawn=value
			when "ole"
				sm.overall_luminous_efficacy=value
			when "g_spectrum"
				sm.g_spectrum=value
			when "sssval"
				sm.sss_spectrum=value
			when "fres"
				sm.fresnel_scale=value
			when "sigma"
				sm.sigma=value
			when "subSmoothingCheckbox"
				sm.smooth=true if value=="true"
				sm.smooth=false if value=="false"
			when "EnableIESCheckbox"
				sm.ies=true if value=="true"
				sm.ies=false if value=="false"
			when "SSSCheckbox"
				sm.sss=true if value=="true"
				sm.sss=false if value=="false"
			when "EnableNKdataCheckbox"
				sm.use_nkdata=true if value=="true"
				sm.use_nkdata=false if value=="false"
			when "UniformPF"
				sm.phase_function="Uniform"
			when "Henyey-GreensteinPF"
				sm.phase_function="Henyey-Greenstein"
			when "bbES" #blackbody emission spectrum
				sm.base_emission_spectrum="Blackbody"
			when "rgbES" #rgb emission specrum
				sm.base_emission_spectrum="RGB"
			when "albedo_map"
				tex=sm.albedo_texture
				tex.type=value
				sm.albedo_texture=tex
			when "specular_map"
				tex=sm.specular_map
				tex.type=value
				sm.specular_map=tex
			when "blend_map"
				tex=sm.blend_map
				tex.type=value
				sm.blend_map=tex
			when "bump_map"
				tex=sm.bump_map   #get the current bump map
				tex.type=value        #assign the SU material name to the texture object
				sm.bump_map=tex   #assign the updated texture object back to the selected material
			when "exp_map"
				tex=sm.exponent_map   
				tex.type=value       
				sm.exponent_map=tex
			when "clip_map"
				tex=sm.clip_map   
				tex.type=value       
				sm.clip_map=tex
			when "disp_map"
				tex=sm.disp_map
				tex.type=value
				sm.disp_map=tex
			when "emission_map"
				tex=sm.emission_map
				tex.type=value
				sm.emission_map=tex
			when "sigma_map"
				tex=sm.sigma_map
				tex.type=value
				sm.sigma_map=tex
			when "bump_value"
				tex=sm.bump_map   
				tex.b=value       
				sm.bump_map=tex
			when "expmap_value"
				tex=sm.exponent_map   
				tex.b=value       
				sm.exponent_map=tex
			when "dispmap_value"
				tex=sm.disp_map
				tex.b=value
				sm.disp_map=tex
			when "emission_value"
				tex=sm.emission_map
				tex.b=value
				sm.emission_map=tex
			when "sigma_value"
				tex=sm.sigma_map
				tex.b=value
				sm.sigma_map=tex			
			when "advancedAlbedoMap"
				tex=sm.albedo_texture
				ite=IndigoTextureEditor.new(tex,sm) unless tex.procedural?
				ite=IndigoShaderEditor.new(tex,sm) if tex.procedural?
				sm.albedo_texture=tex
				refreshTextureList()
				getValuesFromSU()
			when "advancedSpecularMap"
				tex=sm.specular_map
				ite=IndigoTextureEditor.new(tex,sm) unless tex.procedural?
				ite=IndigoShaderEditor.new(tex,sm) if tex.procedural?
				sm.specular_map=tex
				refreshTextureList()
				getValuesFromSU()
			when "advancedBumpMap"
				tex=sm.bump_map
				ite=IndigoTextureEditor.new(tex,sm) unless tex.procedural?
				ite=IndigoShaderEditor.new(tex,sm) if tex.procedural?
				sm.bump_map=tex
				refreshTextureList()
				getValuesFromSU()
			when "advancedDispMap"
				tex=sm.disp_map
				ite=IndigoTextureEditor.new(tex,sm) unless tex.procedural?
				ite=IndigoShaderEditor.new(tex,sm) if tex.procedural?
				sm.disp_map=tex
				refreshTextureList()
				getValuesFromSU()
			when "advancedExponentMap"
				tex=sm.exponent_map
				ite=IndigoTextureEditor.new(tex,sm) unless tex.procedural?
				ite=IndigoShaderEditor.new(tex,sm) if tex.procedural?
				sm.exponent_map=tex
				refreshTextureList()
				getValuesFromSU()
			when "advancedClipMap"
				tex=sm.clip_map
				ite=IndigoTextureEditor.new(tex,sm) unless tex.procedural?
				ite=IndigoShaderEditor.new(tex,sm) if tex.procedural?
				sm.clip_map=tex
				refreshTextureList()
				getValuesFromSU()
			when "advancedBlendMap"
				tex=sm.blend_map
				ite=IndigoTextureEditor.new(tex,sm) unless tex.procedural?
				ite=IndigoShaderEditor.new(tex,sm) if tex.procedural?
				sm.blend_map=tex
				refreshTextureList()
				getValuesFromSU()
			when "advancedEmissionMap"
				tex=sm.emission_map
				ite=IndigoTextureEditor.new(tex,sm) unless tex.procedural?
				ite=IndigoShaderEditor.new(tex,sm) if tex.procedural?
				sm.emission_map=tex
				refreshTextureList()
				getValuesFromSU()
			when "advancedSigmaMap"
				tex=sm.sigma_map
				ite=IndigoTextureEditor.new(tex,sm) unless tex.procedural?
				ite=IndigoShaderEditor.new(tex,sm) if tex.procedural?
				sm.sigma_map=tex
				refreshTextureList()
				getValuesFromSU()
			when "matA"
				sm.a_name=value
			when "matB"
				sm.b_name=value
			when "blendfactor"
				#sm.blend_factor=value
				tex=sm.blend_map
				tex.b=value
				sm.blend_map=tex
			when "nkdata"
				sm.nk_data=NKdata.new(value)
			when "ies_path"
				sm.ies_profile=IESProfile.new(value)
			when "metalsList"
				root=File.dirname(SU2IN.get_indigo_path)
				nkdata=File.join(root,"nkdata",value+".nk")
				nk=NKdata.new(nkdata)
				sm.nk_data=nk
				sm.use_nkdata=true
				setCheckbox("EnableNKdataCheckbox","true")
				setValue("nkdata",nk.to_s)
			when "nkdataBrowse"
				path=UI.openpanel "Load NKdata", "", "*.nk"
				if path
					nkdata=NKdata.new(path)
					sm.nk_data=nkdata
					setValue("nkdata",nkdata.to_s)
				end
			when "iesBrowse"
				path=UI.openpanel "Load IES Profile", "", "*.ies"
				if path
					ies=IESProfile.new(path)
					sm.ies_profile=ies
					setValue("ies_path",ies)
				end
			when "igmBrowseButton"
				path=UI.openpanel "Link IGM/PIGM", "", ""
				igm=nil
				if path
					name=File.basename(path)
					if name.split(".")[-1]=="pigm"
						igm=SU2IN.unpack_pigm(path)
						if igm==nil  #problems unpacking file
							UI.messagebox("PIGM file could not be unpacked.")
							return
						end
					elsif name.split(".")[-1]=="igm"
						igm=path
					end
				end
				if igm
					igm=igm.gsub(/\\/,"\/")
					sm.linked_igm=igm
					setValue("igm",igm)
					result=UI.messagebox("Load texture for UV mapping?",MB_YESNO)
					if result==6  #yes
						#igm_dir=(File.dirname(igm)).gsub(/\//,"\\")
						tex_path=UI.openpanel("Load texture","","")
						if tex_path
							sm.texture=tex_path  #set the SU texture to the new texture
						end
					end
				end
			when "slider-1"  #reflection slider
				if (type!="RGB Light") and (type!="Blackbody Light")
					type=getTypeFromSliders()
					sm.type=type
				end
				if value=="0"
					ior="1.0"
				elsif value=="100"
					ior="1000"
				else
					ior=to_ior(value)
				end
				sm.ior=ior
			when "slider-2" #roughness slider
				type=sm.type
				if (type!="RGB Light") and (type!="Blackbody Light")
					type=getTypeFromSliders()
					sm.type=type
				end
				exp=to_exp(value)
				sm.exponent=exp
			when "slider-3" #power slider
				power=to_power(value)
				sm.power_drawn=power
			when "emitterCheckbox"
				if value=="true"
					sm.layer="0"  #set the layer to 0 to make the material an emitter
					sm.base_emission_spectrum="RGB"
					#setCheckbox("transparentCheckbox","false")
				else
					type=getTypeFromSliders()
					sm.type=type
				end
			when "transparentCheckbox"
				rough=d.get_element_value("roughness-value")
				if value=="true"
					if rough=="0"
						sm.type="Specular"
					else
						sm.type="Glossy Transparent"
					end
					#setCheckbox("emitterCheckbox","false")
				else
					if rough=="100"
						sm.type="Diffuse"
					else
						sm.type="Phong"
					end
				end
			when "maxSubdiv"
				sm.max_subdiv=value
			when "pixelThreshold"
				sm.pixel_threshold=value
			when "curveThreshold"
				sm.curvature_threshold=value
			when "matAButton"
				mata=d.get_element_value("matA")
				if mata!="None"
					@selection_stack.push(self.sm)
					self.sm=IndigoMaterial.find(mata)
					Sketchup.active_model.materials.current=sm.mat
					getValuesFromSU()
					setVisibility()
				end
			when "matBButton"
				matb=d.get_element_value("matB")
				if matb!="None"
					@selection_stack.push(self.sm)
					self.sm=IndigoMaterial.find(matb)
					Sketchup.active_model.materials.current=sm.mat
					getValuesFromSU()
					setVisibility()
				end
			when "backButton"
				valid=false
				#p @selection_stack
				while not valid
					unless @selection_stack.empty?
						self.sm=@selection_stack.pop()
						if self.sm.valid? 
							valid=true
							Sketchup.active_model.materials.current=sm.mat
						end
					else
						valid=true
					end
				end
				getValuesFromSU()
				setVisibility()
			when "baseEmissionColorBox"
				current=Sketchup.active_model.materials.current
				if current
					cp=IndigoMaterial.new(current)
					if cp.color_picker?  #if the color picker is the current material
						col=cp.color.to_a
						sm.base_emission=[col[0],col[1],col[2]]
						setColorBox(id,[col[0],col[1],col[2]])
					else
						old_col=sm.base_emission
						cp=IndigoColorPicker.new(old_col)
					end
				end
			when "baseEmissionGain"
				sm.base_emission_gain=value.to_f
				
					
		end #case id

		ite=nil   #indigo texture editor
		
		} #end of Valuechanged callback function

	@mat_editor.add_action_callback("RefreshPreview") {|d,p| getThumbnail}
	@mat_editor.add_action_callback("SetVisibility") {|d,p| setVisibility()}
	@mat_editor.add_action_callback("showThumbnail"){|d,p|
		thumb_dlg=UI::WebDialog.new("SkIndigo Thumbnail", false,"SkIndigoThumbnail", 295, 320, 450, 125, true)
		thumb_dlg.set_html "<img src=\"#{p}\" style=\"cursor:pointer\" title=\"Double-click to load custom thumbnail\"ondblclick=\"window.location='skp:loadThumbnail';\">"
		thumb_dlg.add_action_callback("loadThumbnail") {|d,p|
			new_thumb=UI.openpanel("Load Thumbnail", nil,nil)
			if ((new_thumb) and (FileTest.exist?(new_thumb)))
				sm.thumbnail=new_thumb
				getThumbnail()
			end}
		thumb_dlg.show{}
	}				
		
		
end #initialize

def sm
	@sm
end

def timer
	@timer
end
	
def sm=(new_mat)
	@sm=new_mat
end

def refreshTextureList()

	#function disabled
	return

	cmd="clearTextureLists()"
	@mat_editor.execute_script(cmd)
	texture_list=getTextures()
	select_ids=["albedo_map","bump_map","exp_map","clip_map","disp_map","sigma_map","emission_map"]
	select_ids.each do |id|
		texture_list.each do |tex|
			cmd="createMapOption(\"#{id}\",\"#{tex}\")"
			@mat_editor.execute_script(cmd)
		next
		end
	next
	end
end

def refreshBlendList()
	cmd="clearBlendLists()"
	@mat_editor.execute_script(cmd)
	blend_list=getBlendList()
	select_ids=["matA","matB"]
	select_ids.each do |id|
		blend_list.each do |tex|
			cmd="createMapOption(\"#{id}\",\"#{tex}\")"
			@mat_editor.execute_script(cmd)
		next
		end
	next
	end
end
	
def onMaterialSetCurrent(mats,mat)
	#p @timer
	if @timer
		UI.stop_timer(@timer)
	end
	new_mat=IndigoMaterial.new(mat)
	unless new_mat.color_picker? or new_mat.uv_helper?
		self.sm=IndigoMaterial.new(mat)
		#@selection_stack.push(self.sm)
		if @mat_editor.visible?
			refreshTextureList()
			refreshBlendList()
			getValuesFromSU()
			setVisibility()
			
		end

		if @start
			finish=Time.new
			if (finish-@start)<0.25     #check if user double-clicked a material in the Paint Bucket
				@mat_editor.show {refreshTextureList();refreshBlendList();getValuesFromSU();setVisibility()} 
				#@mat_editor.bring_to_front
				#@mat_editor.show{}
			else
				@start=Time.new
			end
		else
			@start=Time.new
		end
	end

end

def show_editor
	if @timer
		UI.stop_timer(@timer)
	end
	if sm!=nil
		if @mat_editor.visible?
			refreshTextureList();refreshBlendList();getValuesFromSU();setVisibility()
		else
			@mat_editor.show {refreshTextureList();refreshBlendList();getValuesFromSU();setVisibility()}
			#@mat_editor.close
			#@mat_editor.show{}
		end
	else
		UI.messagebox "Please select a material using the Paint Bucket."
	end
end
	

def getThumbnail
	thumb=sm.thumbnail
	#p thumb
	if FileTest.exist?(thumb)
		thumb.gsub!(/\\/,"\/")
		cmd="document.images[\"PreviewImage\"].src=\"nopreview.png\""  #This is required so that new image is not updated from the cache
		@mat_editor.execute_script(cmd)
		cmd="document.images[\"PreviewImage\"].src=\"file:\/\/#{thumb}\""
		@mat_editor.execute_script(cmd)
	else
		if sm.texture!=nil
			tex=File.basename(sm.texture.filename)
			tex_path=ENV['temp']+"\\#{tex}"
			p tex_path
			tex_path=save_mat_texture(sm.mat,tex_path)
			tex_path.gsub!(/\\/,"\/")
			cmd="document.images[\"PreviewImage\"].src=\"nopreview.png\""  #This is required so that new image is not updated from the cache
			@mat_editor.execute_script(cmd)
			cmd="document.images[\"PreviewImage\"].src=\"file:\/\/#{tex_path}\""
		else
			cmd="document.images[\"PreviewImage\"].src=\"nopreview.png\""
		end
		@mat_editor.execute_script(cmd)
	end
			
end


def getValuesFromSU()
	getThumbnail()
	type=sm.type
	bm=sm.bump_map
	em=sm.exponent_map
	cm=sm.clip_map
	at=sm.albedo_texture
	dm=sm.disp_map
	sim=sm.sigma_map
	emm=sm.emission_map
	spm=sm.specular_map
	
	blm=sm.blend_map
	root=File.dirname(SU2IN.get_indigo_path)


	###########################################Update the material editor dialog box
	setValue("MaterialName",sm.display_name)
	setValue("type",sm.type)
	setValue("layer",sm.layer)
	setValue("ior",sm.ior)
	#setValue("exp",sm.exponent)
	#setValue("fres",sm.fresnel_scale)
	#setValue("sigma",sm.sigma)
	setValue("precedence",sm.precedence)
	setValue("cau",sm.cauchy_b_coeff)
	setValue("power",sm.power_drawn)
	setValue("ole",sm.overall_luminous_efficacy)
	setValue("temp",sm.temperature)
	setValue("nkdata",sm.nk_data.to_s)
	setValue("ies_path",sm.ies_profile.to_s)
	setValue("g_spectrum",sm.g_spectrum)
	setValue("sssval",sm.sss_spectrum)
	setValue("albedo_map",at.type)
	setValue("specular_map",spm.type)
	setValue("blend_map",blm.type)
	setValue("bump_map",bm.type)
	setValue("bump_value",bm.b)
	setValue("disp_map",dm.type)
	setValue("dispmap_value",dm.b)
	setValue("exp_map",em.type)
	setValue("expmap_value",em.b)
	setValue("sigma_map",sim.type)
	setValue("sigma_value",sim.b)
	setValue("emission_map",emm.type)
	setValue("emission_value",emm.b)
	setValue("clip_map",cm.type)
	setValue("matA",sm.a_name)
	setValue("matB",sm.b_name)
	#setValue("blendfactor",sm.blend_factor)
	setValue("blendfactor",blm.b)
	setValue("maxSubdiv",sm.max_subdiv)
	setValue("pixelThreshold",sm.pixel_threshold)
	setValue("curveThreshold",sm.curvature_threshold)
	setValue("igm",sm.linked_igm)
	#setValue("baseEmissionGain",sm.base_emission_gain)
	setColorBox("baseEmissionColorBox",sm.base_emission)
	setColorBox("PreviewImage",sm.mat.color.to_a)
	
	
	if sm.sss? then	setCheckbox("SSSCheckbox","true")
	else setCheckbox("SSSCheckbox","false")
	end
	if  sm.smooth? then setCheckbox("subSmoothingCheckbox","true")
		else setCheckbox("subSmoothingCheckbox","false")
	end
	if sm.ies? then setCheckbox("EnableIESCheckbox","true")
	else setCheckbox("EnableIESCheckbox","false")
	end
	if sm.use_nkdata? then setCheckbox("EnableNKdataCheckbox","true")
	else setCheckbox("EnableNKdataCheckbox","false")
	end
	if sm.phase_function=="Uniform" then setRadioButton("UniformPF","true")
	else setRadioButton("Henyey-GreensteinPF","true")
	end
	if sm.base_emission_spectrum=="Blackbody" then setRadioButton("bbES","true")
	else setRadioButton("rgbES","true")
	end

	# update simple ui values
	if @ui=="simple"
		if type=="Diffuse"
			s_value="0"
			s2_value="100"
		elsif type=="Specular"
			s_value=to_reflection(sm.ior)
			s2_value="0"
		else
			s_value=to_reflection(sm.ior)
			s2_value=to_roughness(sm.exponent_map.b)
		end
		s3_value=to_power_slider(sm.power_drawn)
		cmd="s.setValue(#{s_value})"
		@mat_editor.execute_script(cmd)
		
		cmd="s2.setValue(#{s2_value})"
		@mat_editor.execute_script(cmd)
		
		cmd="s3.setValue(#{s3_value})"
		@mat_editor.execute_script(cmd)
	end
	if (type=="Specular") or (type=="Glossy Transparent") then setCheckbox("transparentCheckbox","true")
	else setCheckbox("transparentCheckbox","false")
	end
	if (sm.emitter?) then setCheckbox("emitterCheckbox","true")
	else setCheckbox("emitterCheckbox","false")
	end
				
end

def setVisibility()
	type=sm.type
	if @ui=="simple"
		cmd="setSimpleUIVisible()"
		@mat_editor.execute_script(cmd)
		return
	end
	case type
		when "Diffuse"
			@mat_editor.execute_script("setDiffuseVisible()")
		when "Phong"
			@mat_editor.execute_script("setPhongVisible()")
		when "Specular"
			@mat_editor.execute_script("setSpecularVisible()")
		when "Glossy Transparent"
			@mat_editor.execute_script("setGlossyTransparentVisible()")
		when "Blend"
			@mat_editor.execute_script("setBlendVisible()")
		when "Metals","Al","Cr","Cu","Au","Ag","Ti","W","Li","Ni","Pt"
			@mat_editor.execute_script("setMetalsVisible()")
		when "Thin Glass"
			@mat_editor.execute_script("setThinGlassVisible()")
		when "Oren-Nayar"
			@mat_editor.execute_script("setOrenNayarVisible()")
		when "Linked IGM"
			@mat_editor.execute_script("setLinkedIGMVisible()")
		when "RGB Light"
			@mat_editor.execute_script("setRGBLightVisible()")
		when "Blackbody Light"
			@mat_editor.execute_script("setBlackbodyLightVisible()")
		when "Exit Portal"
			@mat_editor.execute_script("setExitPortalVisible()")
	end
	@mat_editor.execute_script("setEfficacyVisible()")   #disables efficacy if ies profile is enabled
end 
		
def setValue(id,value)
	new_value=value.to_s
	cmd="document.getElementById('#{id}').value=\"#{new_value}\""
	@mat_editor.execute_script(cmd)
end
def setCheckbox(id,checked)
	cmd="document.getElementById('#{id}').checked=#{checked}"
	@mat_editor.execute_script(cmd)
end
def setRadioButton(id,checked)
	cmd="document.getElementById('#{id}').checked=\"#{checked}\""
	@mat_editor.execute_script(cmd)
end
def setColorBox(id,color)
	r=color[0]
	g=color[1]
	b=color[2]
	cmd="document.getElementById('#{id}').style.backgroundColor=\"rgb(#{r},#{g},#{b})\""
	@mat_editor.execute_script(cmd)
end
def getTextures()  #Returns array of all materials with textures
	texture_list=["None","SU"]
	materials=Sketchup.active_model.materials
	materials.each do |m|
	if (m.respond_to?(:texture) and m.texture !=nil)
		texture_list.push(m.display_name)
	end
	next
	end
	texture_list+=["Custom Shader"]
	return texture_list
end
def getBlendList() #Returns array of all valid materials for blending 
	materials=Sketchup.active_model.materials
	blend_list=["None"]
	for mat in materials
		type=IndigoMaterial.new(mat).type
		if ((type) !="Blackbody Light") and ((type)!="RGB Light") and ((type)!="Exit Portal")
			blend_list.push(mat.display_name) if mat!=sm.mat
		end
	end 
	return blend_list
end

##############################Material Presets

def apply_lambertian(material)
material.type="Diffuse"
material.alpha=1.0
material.layer=-1
end

def apply_glass(material)
material.type="Specular"
material.ior=1.52
material.cauchy_b_coeff=0.0
material.sss=false
material.alpha=0.0
material.layer=-1
end

def apply_water(material)
material.type="Specular"
material.ior=1.33
material.cauchy_b_coeff=0.0
material.sss=true
material.sss_spectrum="0.0007 0.002 0.0026"
material.color=[26, 230, 246]
material.alpha=0.02
material.phase_function="Uniform"
material.layer=-1
end

def apply_frosted_glass(material)
material.type="Glossy Transparent"
material.exponent=100
material.ior=1.52
material.cauchy_b_coeff=0.0
material.sss=false
material.alpha=0.0
material.layer=-1
end

def apply_mirror(material)
material.type="Specular"
material.ior=20.0
material.cauchy_b_coeff=0.0
material.sss=false
material.alpha=1.0
material.layer=-1
end

def apply_ceramic(material)
material.type="Phong"
material.exponent=5000
material.fresnel_scale=1.0
material.ior=1.52
material.alpha=1.0
material.layer=-1
end

def apply_dull_plastic(material)
material.type="Phong"
material.exponent=300
material.fresnel_scale=1.0
material.ior=1.33
material.alpha=1.0
material.layer=-1
end

def apply_shiny_plastic(material)
material.type="Phong"
material.exponent=10000
material.fresnel_scale=1.0
material.ior=1.22
material.alpha=1.0
material.layer=-1
end

def apply_leather(material)
material.type="Phong"
material.exponent=50
material.fresnel_scale=1.0
material.ior=1.58
material.alpha=1.0
material.layer=-1
end

def apply_car_paint(material)
material.type="Phong"
material.exponent=30000
material.fresnel_scale=1.0
material.ior=1.72
material.alpha=1.0
material.layer=-1
end

def apply_tinted_glass(material)
material.type="Specular"
material.ior=1.52
material.cauchy_b_coeff=0.0
material.sss=false
material.alpha=0.1
material.layer=-1
end

def apply_nkdata(material,file_name)
root=File.dirname(SU2IN.get_indigo_path)
return if not root
nkdata=File.join(root,"nkdata",file_name)
nkdata.gsub!(/\\/,"\/")
nk=NKdata.new(nkdata)
material.type="Metals"
material.nk_data=nk
material.use_nkdata=true
material.layer=-1
end

def apply_lampshade(material)
material.type="Diffuse"
material.alpha=0.5
material.layer=-1
end

def apply_100W(material)
material.layer=0 if material.layer==-1
material.power_drawn=100.0
material.overall_luminous_efficacy=17.5
material.temperature=2800
material.base_emission_spectrum="Blackbody"
@mat_editor.execute_script("document.getElementById('emitterTable').style.display='inline'")
end

def apply_60W(material)
material.layer=0 if material.layer==-1
material.power_drawn=60.0
material.overall_luminous_efficacy=14.0
material.base_emission_spectrum="Blackbody"
@mat_editor.execute_script("document.getElementById('emitterTable').style.display='inline'")
end

def apply_7WCFW(material)
material.layer=0 if material.layer==-1
material.power_drawn=7.0
material.overall_luminous_efficacy=50.0
material.base_emission_spectrum="Blackbody"
@mat_editor.execute_script("document.getElementById('emitterTable').style.display='inline'")
end

def apply_34WTFC(material)
material.layer=0 if material.layer==-1
material.power_drawn=34.0
material.overall_luminous_efficacy=50.0
material.temperature=6000
material.base_emission_spectrum="Blackbody"
@mat_editor.execute_script("document.getElementById('emitterTable').style.display='inline'")
end

def apply_34WTFM(material)
material.layer=0 if material.layer==-1
material.power_drawn=34.0
material.overall_luminous_efficacy=50.0
material.temperature=4500
material.base_emission_spectrum="Blackbody"
@mat_editor.execute_script("document.getElementById('emitterTable').style.display='inline'")
end

def apply_34WTFW(material)
material.layer=0 if material.layer==-1
material.power_drawn=34.0
material.overall_luminous_efficacy=50.0
material.temperature=3000
material.base_emission_spectrum="Blackbody"
@mat_editor.execute_script("document.getElementById('emitterTable').style.display='inline'")
end

###################calibration of simple UI sliders
def to_ior(value)
	value=value.to_f
	specular=0.001*Math.exp(value*0.0692)
	new_ior=-(Math.sqrt(specular)+1)/(Math.sqrt(specular)-1)
	new_ior=(new_ior*1000).round.to_f/1000    #round the value to three decimal places
	return new_ior.to_s
end
def to_exp(value)
	value=value.to_i
	exp=1000000*Math.exp(-0.14*value)
	exp=exp.round
	return exp.to_s
end
def to_reflection(value)
	value=value.to_f
	specular=((value-1)/(value+1))**2
	if specular<=0.0
		reflection=0
	else
		reflection=Math.log(1000*specular)/0.0692
		reflection=100 if reflection>100
	end
	return reflection.to_s
end
def to_roughness(value)
	value=value.to_f
	rough=Math.log(value/1000000)/(-0.14)
	rough=100 if rough>100
	rough=0 if rough<0
	return rough.to_s
end
def to_power(value)
	value=value.to_i
	power=value*10
	return power.to_s
end
def to_power_slider(value)
	value=value.to_f
	power_slider=value/10
	power_slider=100 if power_slider>100
	power_slider=1 if power_slider<1
	power_slider=power_slider.to_i
	return power_slider.to_s
end
def getTypeFromSliders()
	current_type=sm.type
	ref=@mat_editor.get_element_value("reflection-value").to_i
	rough=@mat_editor.get_element_value("roughness-value").to_i
	opacity=sm.alpha
	if (current_type=="Blackbody Light") or (current_type=="RGB Light") or (current_type=="Metals") or (current_type=="Exit Portal") or (current_type=="Thin Glass") or (current_type=="Blend")
		return current_type
	elsif (current_type=="Specular") or (current_type=="Glossy Transparent")
		if rough==0
			type="Specular"
		else
			type="Glossy Transparent"
		end
	else
		if (rough==100) and (ref==0)
			type="Diffuse"
		else
			type="Phong"
		end
	end
	return type

end

def mat_editor    #material editor accessor function
	@mat_editor
end

def preset_dlg
	@prset_dlg
end

#################################################Material Preview
def preview_material(mat,preview_model)

case preview_model
	when "Sphere"
		preview_file="IMPsphere.igs"
	when "Cube"
		preview_file="IMPcube.igs"
	when "Monkey"
		preview_file="IMPmonkey.igs"
	when "Indigo"
		preview_file="IMPmatdb.igs"
	when "Custom"
		preview_file="IMPcustom.igs"
end

path=SU2IN.get_indigo_path
return if not path
irs=IndigoRenderSettings.new

indigo_dir=File.dirname(path)
thumbnail_path=irs.thumbnail_path
if (not FileTest.exist?(thumbnail_path))
	UI.messagebox "Thumbnail path not found. Preview aborted."
	return
end

		
preview_path=File.join(indigo_dir,"SUpreviews")
preview_igs_path=File.join(preview_path,preview_file)

if not FileTest.exist?(preview_igs_path)
	UI.messagebox "Preview IGS file not found in #{preview_igs_path}"
	return
end

tex_path=File.join(preview_path,"textures")

if not FileTest.exist? (tex_path)
	Dir.mkdir(tex_path)
end
ie=IndigoExporter.new(preview_path+"\\previewmats.igs")
#ie.tex_path=tex_path
ie.tex_path="textures"
ie.preview_material=mat

#Write the new material preview file
out=File.new(preview_path+"\\previewmats.igs","w")
#out = File.new(preview_path+"\\previewmats.igs",File::CREAT|File::TRUNC|File::RDWR, 0644)
out.puts "<scenedata>"
status=ie.export_material(mat,out)
out.puts "</scenedata>"
out.close

ie.export_textures(ie.textures)                     #exports the textures that were stored during the material export process
for nk_path in ie.nkdata					#exports the nkdata that was collected during the material export process
	nk=NKdata.new(nk_path)
	nk.export(tex_path)  #exports the nkdata to the textures directory
end

batch_file_path=File.join(indigo_dir,"autorender.bat")
batch=File.new(batch_file_path,"w")

batch.puts path.split(":")[0]+":"
batch.puts "cd #{File.dirname(path)}"

batch.puts "start \/low indigo.exe \"#{preview_igs_path}\" -o \"#{File.join(thumbnail_path,(mat.mat.display_name.delete("<>")+".png"))}\""

batch.close

batch_file_path=batch_file_path.gsub(/\\/,"\/")

UI.openURL(batch_file_path)

end #function end


############################XML Parsing Method
def parse(tag,string)

data=string.split("<"+tag+">")[1]
data=string.split("<"+tag+">")[2] if tag=="rgb"  #this is used to parse the rgb values from an rgb spectrum element

if data
	data=data.split("<\/"+tag+">")[0]
	return nil if not data
else
	return nil
end

return data

end

##################################Function to acquire array of media from IGM file##################
def get_media(data)

media_arr=[]
media=data.split("<medium>")
if media.length>1 #we have at least one medium
	for i in (1..media.length-1)
		media_data=media[i].split("</medium>")[0]
		medium_name=parse("name",media_data) if media_data
		media_arr.push(medium_name) if medium_name
		media_arr.push(media_data) if media_data
	end
else
	return nil
end

return media_arr

end

##################################Function to acquire array of materials from IGM file##################
def get_materials(data)

material_arr=[]
materials=data.split("<material>")

if materials.length>1 #we have at least one material
	for i in (1..materials.length-1)
		material_data=materials[i].split("</material>")[0]
		material_arr.push(material_data) if material_data
	end
else
	return nil
end

return material_arr

end

##################################Function to Load IGM Files##################
def load_igm(igm,mat)

model=Sketchup.active_model
model.start_operation "Load IGM"
mats=model.materials
media=[]
materials=[]
null_mat=[]
num_materials=0
tex_path=File.dirname(igm)
igm_file=File.new(igm,"r")
md=igm_file.read
igm_file.close
material_data=parse("materialdata",md)
material_data=md if not material_data
version=parse("version",material_data)

unsupported=["epidermis","dermis","peak","blackbody","regular_tabulated"]
unsupported.each {|att|
	found=parse(att,material_data)
	if found   #found an unsupported indigo attribute
		UI.messagebox("This material contains material attributes that are not supported by SkIndigo and cannot be loaded.  To use this material, create a Linked IGM material that is linked to this IGM file.")
		return
	end
}

media=get_media(material_data) #returns array media in the IGM file
materials=get_materials(material_data) #returns array of all materials in the IGM file

for material in materials
	dm=disp_map=oren_nayar=srs=gs_uniform_value=gs_rgb_value=hg=material_name=specular=transparent=imn=diffuse=colour=diffuse_transmitter=phong=ior=exponent=fresnel=nk_data=glossy_transparent=blend=a_name=b_name=blend_factor=medium=precedence=basic=cauchy=acs=acs_uniform=acs_uniform_value=acs_rgb_value=sss=scs=scs_uniform=scs_uniform_value=scs_rgb_value=albedo=albedo_path=bump_map=bump_map_path=bump_map_b=exp_map=exp_map_path=exp_map_b=blend_map=blend_map_path=bump_name=bump_mat=bump_value=exp_name=exp_mat=expmap_value=nil
	num_materials=num_materials+1
	nk_data=material_name=parse("name",material)

	#First check if the material is a null material
	if material.include?("null_material")
		null_mat.push(material_name)
		next
	end 
	unless (materials.length)==num_materials  #create a new SU material for each material found except when this is the last material in the list
		im=IndigoMaterial.new(mats.add(material_name.gsub(/\*/,"~")))
		UI.messagebox "New material created named #{material_name}."
	else
		im=mat
	end
	
	specular=parse("specular",material) #found a specular material
	if specular
		im.type="Specular"
		transparent=parse("transparent",specular)
		im.alpha=1.0 if transparent=="false"
		imn=parse("internal_medium_name",specular)
	end
	
	diffuse=parse("diffuse",material) #found a diffuse material
	if diffuse
		im.type="Diffuse"
		colour=parse("rgb",diffuse)
		colour=parse("colour",diffuse) if not colour
		colour_gamma=parse("gamma",diffuse)
		colour_gamma=2.2 if not colour_gamma
		colour=SU2IN.igm_rgb_gamma_convert(colour,colour_gamma.to_f,2.2)
		im.alpha=1.0
	end
	
	diffuse_transmitter=parse("diffuse_transmitter",material)  #found a diffuse transmiter material
	if diffuse_transmitter
		im.type="Diffuse"
		im.alpha=0.0
		colour=parse("rgb",diffuse_transmitter)
		colour=parse("colour",diffuse) if not colour #backward compatible
		colour_gamma=parse("gamma",diffuse_transmitter)
		colour_gamma=2.2 if not colour_gamma
		colour=SU2IN.igm_rgb_gamma_convert(colour,colour_gamma.to_f,2.2)
	end
	
	phong=parse("phong",material)  #found a phong material
	if phong
		im.type="Phong"
		im.alpha=1.0
		nk_data=parse("nk_data",phong)
		if nk_data
			im.type="Metals"
			######current IGM spec is to only use nkdata located in root indigo directory
			path=File.dirname(SU2IN.get_indigo_path)  #the root indigo directory
			nkpath=File.join(path,nk_data)   #this may have to change depending on the final IGM spec
			nk=NKdata.new(nkpath)
			if (not nk.valid?)
				UI.messagebox "Could not find nkdata file #{File.basename(nk_data)} in indigo nkdata folder.  Please manually load nkdata."
			else
				im.nk_data=nk
				im.use_nkdata=true
			end
		end
		srs=parse("specular_reflectivity_spectrum",phong)
		if srs
			im.type="Metals"
			im.use_nkdata=false
		end
		colour=parse("rgb",phong)
		colour=parse("diffuse",phong) if not colour  #backward compatible
		colour_gamma=parse("gamma",phong)
		colour_gamma=2.2 if not colour_gamma
		colour=SU2IN.igm_rgb_gamma_convert(colour,colour_gamma.to_f,2.2)
		im.exponent=parse("exponent",phong)
		if im.type=="Phong"   #these attributes are not necessary to parse if the specular reflectivity element or nkdata is present (Metals)
			im.ior=parse("ior",phong)
			im.fresnel_scale=parse("fresnel_scale",phong)
		end
	end
	
	glossy_transparent=parse("glossy_transparent",material)  #found a glossy transparent material
	if glossy_transparent
		im.type="Glossy Transparent"
		imn=parse("internal_medium_name",glossy_transparent)
		im.exponent=parse("exponent",glossy_transparent)
	end
	
	blend=parse("blend",material)  #found a blend material
	if blend
		im.type="Blend"
		im.alpha=1.0
		#Set any null materials found in a blend material to none
		a_name=parse("a_name",blend)
		if a_name
			im.a_name=a_name.gsub(/\*/,"~")
			im.a_name="None" if null_mat.index(a_name)
		end
		b_name=parse("b_name",blend)
		if b_name
			im.b_name=b_name.gsub(/\*/,"~")
			im.b_name="None" if null_mat.index(b_name)
		end
		im.blend_factor=parse("blend_factor",blend)
	end
	
	oren_nayar=parse("oren_nayar",material)   #found an oren-nayar material
	if oren_nayar
		im.type="Oren-Nayar"
		im.sigma=parse("sigma",oren_nayar)
		colour=parse("rgb",oren_nayar)
		colour=parse("colour",oren_nayar) if not colour
		colour_gamma=parse("gamma",oren_nayar)
		colour_gamma=2.2 if not colour_gamma
		colour=SU2IN.igm_rgb_gamma_convert(colour,colour_gamma.to_f,2.2)
		im.alpha=1.0
	end
	
	#parse and import the properties of the associated medium
	if (specular) or (glossy_transparent)
		medium_index=media.index(imn)
		medium=media[medium_index+1] if medium_index
		if medium
			im.precedence=parse("precedence",medium)
			basic=parse("basic",medium)
			if basic
				im.ior=parse("ior",basic)
				im.cauchy_b_coeff=parse("cauchy_b_coeff",basic)
				acs=parse("absorption_coefficient_spectrum",basic)
				if acs
					acs_uniform=parse("uniform",acs)
					if acs_uniform
						acs_uniform_value=parse("value",acs_uniform)
					end
					acs_rgb_value=parse("rgb",acs)
					if acs_rgb_value
						acs_gamma=parse("gamma",acs)
						acs_gamma=1.0 if not acs_gamma
						acs_rgb_value=SU2IN.igm_rgb_gamma_convert(acs_rgb_value,acs_gamma.to_f,1.0)
					end
				end
			end
			sss=parse("subsurface_scattering",medium)
			if sss
				im.sss=true
				scs=parse("scattering_coefficient_spectrum",sss)
				if scs
					scs_uniform=parse("uniform",scs)
					if scs_uniform
						im.sss_spectrum=parse("value",scs_uniform)
					end
					scs_rgb_value=parse("rgb",scs)
					if scs_rgb_value
						scs_gamma=parse("gamma",scs)
						scs_gamma=1.0 if not scs_gamma
						scs_rgb_value=SU2IN.igm_rgb_gamma_convert(scs_rgb_value,scs_gamma.to_f,1.0)
						im.sss_spectrum=scs_rgb_value.join(" ")
					end
				end
				hg=parse("henyey_greenstein",sss)
				if hg
					im.phase_function="Henyey-Greenstein"
					gs_uniform=parse("uniform",hg)
					if gs_uniform
						im.g_spectrum=parse("value",gs_uniform)
					end
					gs_rgb_value=parse("rgb",hg)
					if gs_rgb_value
						gs_gamma=parse("gamma",hg)
						gs_gamma=1.0 if not gs_gamma
						gs_rgb_value=SU2IN.igm_rgb_gamma_convert(gs_rgb_value,gs_gamma.to_f,1.0)
						im.g_spectrum=gs_rgb_value.join(" ")
					end
				else
					im.phase_function="Uniform"
				end
				
			end

		end #if medium

	end #if specular or glossy transparent

	albedo=parse("albedo_texture",material)
	if albedo
		albedo_path=parse("path",albedo)
		if FileTest.exist?(File.join(tex_path,albedo_path))
			im.texture=albedo_path
			UI.messagebox "Material texture set to #{File.basename(albedo_path)}"
		else
			UI.messagebox "Albedo texture #{albedo_path} not found."
		end
		ab=im.albedo_texture
		ab.a=parse("a",albedo) if parse("a",albedo)
		ab.b=parse("b",albedo) if parse("b",albedo)
		ab.c=parse("c",albedo) if parse("c",albedo)
		ab.exponent=parse("exponent",albedo) if parse("exponent",albedo)
		im.albedo_texture=ab
	end
	bump_map=parse("bump_map",material)
	if bump_map
		bump_map_path=parse("path",bump_map)
		tex_name=IndigoMaterial.find_texture_file(File.join(tex_path,bump_map_path))
		bm=im.bump_map
		bm.su_mat_name=tex_name.display_name if tex_name
		UI.messagebox "Bump map set to #{tex_name.display_name}" if tex_name
		bm.a=parse("a",bump_map) if parse("a",bump_map)
		bm.b=parse("b",bump_map) if parse("b",bump_map)
		bm.c=parse("c",bump_map) if parse("c",bump_map)
		bm.exponent=parse("exponent",bump_map) if parse("exponent",bump_map)
		im.bump_map=bm
	end
	exp_map=parse("exponent_map",material)
	if exp_map
		exp_map_path=parse("path",exp_map)
		tex_name=IndigoMaterial.find_texture_file(File.join(tex_path,exp_map_path))
		em=im.exponent_map
		em.su_mat_name=tex_name.display_name if tex_name
		UI.messagebox "Exponent map set to #{tex_name.display_name}" if tex_name
		em.a=parse("a",exp_map) if parse("a",exp_map)
		em.b=parse("b",exp_map) if parse("b",exp_map)
		em.c=parse("c",exp_map) if parse("c",exp_map)
		em.exponent=parse("exponent",exp_map) if parse("exponent",exp_map)
		im.exponent_map=em
	end
	disp_map=parse("displacement_map",material)
	if disp_map
		disp_map_path=parse("path",disp_map)
		tex_name=IndigoMaterial.find_texture_file(File.join(tex_path,disp_map_path))
		dm=im.disp_map
		dm.su_mat_name=tex_name.display_name if tex_name
		UI.messagebox "Displacement map set to #{tex_name.display_name}" if tex_name
		dm.a=parse("a",disp_map) if parse("a",disp_map)
		dm.b=parse("b",disp_map) if parse("b",disp_map)
		dm.c=parse("c",disp_map) if parse("c",disp_map)
		dm.exponent=parse("exponent",disp_map) if parse("exponent",disp_map)
		im.disp_map=dm
	end
	blend_map=parse("blend_map",material)
	if blend_map
		blend_map_path=parse("path",blend_map)
		if FileTest.exist?(File.join(tex_path,blend_map_path))
			im.texture=blend_map_path
			UI.messagebox "Material texture set to #{File.basename(blend_map_path)}"
		else
			UI.messagebox "Blend map #{blend_map_path} not found."
		end
		p tex_path
		p blend_map_path
		bm=im.blend_map
		bm.a=parse("a",blend_map) if parse("a",blend_map)
		bm.b=parse("b",blend_map) if parse("b",blend_map)
		bm.c=parse("c",blend_map) if parse("c",blend_map)
		bm.exponent=parse("exponent",blend_map) if parse("exponent",blend_map)
		im.blend_map=bm
	end


#######Extract and set RGB Values#############
if (colour) and (im.texture==nil) 			#We have a Diffuse or Phong material
	red=(colour[0]*255).round
	green=(colour[1]*255).round
	blue=(colour[2]*255).round
	im.color=[red,green,blue]
	UI.messagebox "SketchUp RGB values set to :R=#{red} G=#{green} B=#{blue}"
		
end #end if colour

#######Extract and set opacity values#########
if (transparent=="true") or im.type=="Glossy Transparent"				#We have a material with an internal medium so extract the absorptivity
begin
	if acs_rgb_value
		rgb_ab=acs_rgb_value
		red_ab=rgb_ab[0]
		green_ab=rgb_ab[1]
		blue_ab=rgb_ab[2]
		opacity=(Math.sqrt([red_ab,green_ab,blue_ab].max*10)).round
		opacity=99 if opacity>99
		opacity=1 if opacity<1
		red=((1-(10*red_ab)/(opacity**2))*255).round
		red=0 if red<0
		red=255 if red>255
		blue=((1-(10*blue_ab)/(opacity**2))*255).round
		blue=0 if blue<0
		blue=255 if blue>255
		green=((1-(10*green_ab)/(opacity**2))*255).round
		green=0 if green<0
		green=255 if green>255
		set_alpha=opacity.to_f/100
		im.alpha=set_alpha
		im.color=[red,green,blue]
		UI.messagebox "Input Absorption Coefficient Spectrum (gamma=#{acs_gamma}):\nR=#{red_ab} G=#{green_ab} B=#{blue_ab}\nSketchUp opacity set to #{opacity}\nSketchUp RGB set to #{red} #{green} #{blue}\nExported Absorption Coefficient Spectrum (gamma=1.0):\nR=#{"%.4f" %((1-red.to_f/255)*opacity*opacity/10)} G=#{"%.4f" %((1-green.to_f/255)*opacity*opacity/10)} B=#{"%.4f" %((1-blue.to_f/255)*opacity*opacity/10)}"
		
	elsif acs_uniform_value
		
		opacity=Math.sqrt(acs_uniform_value.to_f*10).round
		opacity=99 if opacity>99
		opacity=1 if opacity<1
		new_color=((1-(10*acs_uniform_value.to_f)/(opacity**2))*255).round
		new_color=0 if new_color<0
		new_color=255 if new_color>255
		set_alpha=opacity.to_f/100
		im.alpha=set_alpha
		im.color=[new_color,new_color,new_color]
		UI.messagebox "Input Absorption Coefficient Spectrum:Uniform=#{acs_uniform_value}\nSketchUp opacity set to #{opacity}\nSketchUp RGB set to #{new_color} #{new_color} #{new_color}\nExported Absorption Coefficient Spectrum:R=#{"%.4f" %((1-new_color.to_f/255)*opacity*opacity/10)} G=#{"%.4f" %((1-new_color.to_f/255)*opacity*opacity/10)} B=#{"%.4f" %((1-new_color.to_f/255)*opacity*opacity/10)}"
		
	end		
	
rescue
	UI.messagebox "Error setting opacity and RGB values.  Check IGM file for errors."
	raise
end #end error handle

end #end if transparent

end #end for mat in materials

model.commit_operation

end #end load igm

	
end #material editor class


#################################Texture Editor Class#############################
class IndigoTextureEditor

include SkIndigoUVS

def initialize(texture,material)   #tex is an IndigoTexture object - material is an IndigoMaterial object
	@tex=texture
	@mat=material
	@su_mat=@mat.mat
	@irs=IndigoRenderSettings.new
	@thumb=getThumbnail()
	@dlg=UI::WebDialog.new("SkIndigo Texture Editor", true, "SkIndigoTextureEditor",303,292,419,243,true) #width,height,left,top
	@dlg.set_file(File.dirname(__FILE__)+'\SkIndigo\TextureEditor.html')
	@temp_texture_path=ENV['temp']+'\texture_editor.jpg'
	color = @dlg.get_default_dialog_color 
	@dlg.set_background_color(color)
	@dlg.add_action_callback("send_to_mapper") {|d,p|
		apply_settings(d)
		case @tex.type
			when "External"
				unless @tex.valid?
					UI.messagebox("You must first select a valid texture map.")
					break
				end
			when "SketchUp"
				if @su_mat.texture==nil
					UI.messagebox("You must first apply a texture to this material.")
					return
				end
			when "None"
				UI.messagebox("You must first load a texture.")
				return
		end
		uv_set=@tex.uv_set
		if uv_set=="Default"
			result=UI.messagebox("By positioning this texture using the SketchUp UV set, you have chosen to apply this texture to the current material.  Continue?",MB_YESNO)
			if result==6 #yes
				@su_mat.texture=ENV['temp']+'\texture_editor.jpg' if @tex.type=="SketchUp"
				@su_mat.texture=@tex.path if @tex.type=="External"
				d.close()
				return
			else
				return
			end
		end
		uv_mat=get_uv_mat()
		uv_mat.set_attribute('indigo_uv','current_set',@tex.uv_set.to_i)
		case @tex.type
			when "External"
				#uv_mat.texture=save_mat_texture(@su_mat,@temp_texture_path)  #store the currently applied texture of the material
				#@su_mat.texture=@tex.path
				uv_mat.texture=@tex.path
			when "SketchUp"
				uv_mat.texture=ENV['temp']+'\texture_editor.jpg'
				#uv_mat.texture=save_mat_texture(@su_mat,@temp_texture_path)
				#@su_mat.texture=@temp_texture_path
		end
		#ents=Sketchup.active_model.active_entities
		#faces=ents.find_all {|e| e.material==@su_mat}
		ents=Sketchup.active_model.selection
		faces=ents.find_all {|e| e.class==Sketchup::Face}
		if faces.length==0
			UI.messagebox("You must first select at least one face for positioning this texture.")
			return
		end
		Sketchup.active_model.start_operation("Position Map")
		#store_uvs(faces,0)  #save current uvs so they can be restored later
		switch_mat(faces,@mat.mat,uv_mat,@tex.uv_set.to_i)
		#try to load the stored uv set if the material has a texture
		if uv_mat.texture!=nil
			position_map(faces,uv_set)
		end
		d.close()
		UI.messagebox("UV set #{@tex.uv_set} loaded.")
		Sketchup.active_model.commit_operation
	}
	@dlg.add_action_callback("apply_settings") {|d,p|
		apply_settings(d)
		d.close
	}
	@dlg.add_action_callback("update_thumbnail") {|d,p|
		textures=@irs.get_model_textures
		current_tex=d.get_element_value("TexturePath")
		new_thumb=textures.find {|path| File.basename(path)==current_tex}
		if new_thumb
			@thumb=new_thumb
			setThumbnail()
		end
	}
	@dlg.add_action_callback("cancel_changes") {|d,p| d.close}
	@dlg.add_action_callback("create_new_texture") {|d,p|
		filename=UI.openpanel("Load New Texture", nil,nil)
		return if not filename
		case @tex.type
			when "SketchUp"
				@mat.mat.texture=filename
			when "External","None"
				@tex.path=filename
				@tex.type="External"
				@irs.store_texture(filename)
				add_map_option(File.basename(filename))
		end
		@thumb=getThumbnail()
		getValuesFromSU()
	}
	@dlg.add_action_callback("refresh_thumbnail") {|d,p|
		@thumb=@dlg.get_element_value("TextureName")
		#p @thumb
	}
	@dlg.show_modal {getModelTextures();getValuesFromSU();setVisibility()}
end

def apply_settings(d) #d is the dialog

@tex.a=d.get_element_value("aValue")
@tex.b=d.get_element_value("bValue")
@tex.c=d.get_element_value("cValue")
@tex.exponent=d.get_element_value("textureExponent")
@tex.uv_set=d.get_element_value("uvset")
path=d.get_element_value("TexturePath")
textures=@irs.get_model_textures
current_tex=d.get_element_value("TexturePath")
new_tex=textures.find {|path| File.basename(path)==current_tex}
@tex.path=new_tex
#@tex.path=d.get_element_value("TexturePath")
#@tex.u_scale=d.get_element_value("uscale")
#@tex.v_scale=d.get_element_value("vscale")

end

def show
	@dlg.show_modal
end

def setVisibility()
	type=@tex.type
	case type
		when "None","SketchUp"
			@dlg.execute_script("setSketchUpVisible()")
		when "External"
			@dlg.execute_script("setExternalVisible()")
	end
end

def getModelTextures()

@model_textures=@irs.get_model_textures
@model_textures.each {|path|
	#add_map_option(path)
	add_map_option(File.basename(path))
}
end

def add_map_option(path)
	path=path.gsub(/\\/,"\/")
	cmd="createMapOption(\"TexturePath\",\"#{path}\")"
	@dlg.execute_script(cmd)
end

def getValuesFromSU()
	tex_path=@tex.path.gsub(/\\/,"\/")
	setValue("TexturePath",File.basename(tex_path)) #if @tex.type=="External"
	setValue("TextureName",@mat.display_name) if @tex.type=="SketchUp"
	setValue("TextureName","") if @tex.type=="None"
	setValue("aValue",@tex.a)
	setValue("bValue",@tex.b)
	setValue("cValue",@tex.c)
	setValue("textureExponent",@tex.exponent)
	setValue("uvset",@tex.uv_set)
	setThumbnail()
	
end

def setThumbnail()

if @thumb
	@thumb.gsub!(/\\/,"\/")
	cmd="document.images[\"TextureImage\"].src=\"nopreview.png\""  #this is required so the preview is refreshed
	@dlg.execute_script(cmd)
	#p @thumb
	cmd="document.images[\"TextureImage\"].src=\"file:\/\/#{@thumb}\""
	@dlg.execute_script(cmd)
end

end

def setValue(id,value)
	new_value=value.to_s
	cmd="document.getElementById('#{id}').value=\"#{new_value}\""
	@dlg.execute_script(cmd)
end

def getThumbnail()
	case @tex.type
		when "None"
			return nil
		when "External"
			return @tex.path
		when "SketchUp"
			mat=@mat.mat  
			status=nil
			thumb=ENV['temp']+'\texture_editor.jpg'   #set the exported texture path to the user's temp directory
			return save_mat_texture(mat,thumb)
	end
end


end #indigo texture editor class



#################################Shader Editor Class#############################
class IndigoShaderEditor

def initialize(texture,material)   #tex is an IndigoTexture object - material is an IndigoMaterial object
	@tex=texture
	@mat=material
	@dlg=UI::WebDialog.new("SkIndigo Shader Editor", true, "SkIndigoShaderEditor",303,292,419,243,true) #width,height,left,top
	@dlg.set_file(File.dirname(__FILE__)+'\SkIndigo\ShaderEditor.html')
	color = @dlg.get_default_dialog_color 
	@dlg.set_background_color(color)
	@dlg.add_action_callback("apply_settings") {|d,p|
		@tex.shader_code=d.get_element_value("shaderCode")
		d.close
	}
	@dlg.add_action_callback("cancel_changes") {|d,p| d.close}
	@dlg.show_modal {getValuesFromSU()}
end

def show
	@dlg.show_modal
end

def getValuesFromSU()
	code=@tex.shader_code
	#the following substitutions are necessary due to a strange issue with html textarea elements and newline characters
	code.gsub!(/\n/,"\\n")
	code.gsub!(/\r/,"\\r")
	setValue("shaderCode",code)
end

def setValue(id,value)
	new_value=value.to_s
	cmd="document.getElementById('#{id}').value=\"#{new_value}\""
	@dlg.execute_script(cmd)
end

end #indigo texture editor class

#################################Texture Editor Class#############################
class ColorPicker

def initialize(sucolor)   #color is a Sketchup color object
	
	@rgb=sucolor
	@dlg=UI::WebDialog.new("Color Picker", true, "SkIndigoColorPicker",303,292,419,243,true) #width,height,left,top
	@dlg.set_file(File.dirname(__FILE__)+'\SkIndigo\colorpicker\demo.htm')
	color = @dlg.get_default_dialog_color 
	@dlg.set_background_color(color)
	@dlg.add_action_callback("apply") {|d,p|
		r=@dlg.get_element_value("pickerrval")
		g=@dlg.get_element_value("pickergval")
		b=@dlg.get_element_value("pickerbval")
		@rgb=Sketchup::Color.new(r.to_i,g.to_i,b.to_i)
		d.close
	}
	@dlg.add_action_callback("cancel") {|d,p| d.close}
	@dlg.show_modal {setColor(sucolor)}
	#@dlg.show
end

def show
	@dlg.show_modal{setColor(@rgb)}
end

def setColor(sucolor)  #sucolor is a SketchUp color object
	r=sucolor.red
	b=sucolor.blue
	g=sucolor.green
	cmd="picker.setValue([#{r}, #{g}, #{b}], false); ;"
	@dlg.execute_script(cmd)
end

def getColor()
	@rgb
end

end #color picker
#######################Indigo Exporter Class#####################
class IndigoExporter

attr_reader :preview_material, :indigo_version, :path, :exported_mats, :model, :irs, :start, :end, :tex_path, :nkdata, :textures, :meshlights, :ies, :meshbuilder, :batch_path, :physics
attr_writer :tex_path, :path, :preview_material, :start, :end, :meshbuilder, :batch_path, :physics

def initialize(path)
	@path=path      #the path of the file that the Exporter will write to
	#@tex_path=File.dirname(path)   #the directory that the Exporter will write textures to
	@tex_path=""   #the directory that the Exporter will write textures to
	@exported_mats=[]
	@nkdata=[]
	@textures=[]
	@ies=[]
	@meshlights=0
	@null_exported=false
	@preview_material=nil
	@indigo_version="1.0.9"
	@model=Sketchup.active_model
	@materials=@model.materials
	@irs=IndigoRenderSettings.new
	@scale=0.0254
	@null_exported=false
	@instance_mat=nil
	@igm=false
	@frame=0  #the current animation export frame
	@meshbuilder=nil
	@physics=nil
end

def reset_materials
	@exported_mats=[]
end

def settings
	return @irs
end


#############################################Material Exporter######################
def export_material(mat,out)

	if mat.type=="Blend"   #Check if A material and B material exist and export them first
		write_null_mat(out) if ((mat.a_name=="None") or (mat.b_name=="None"))
		a_mat=IndigoMaterial.find(mat.a_name)
		b_mat=IndigoMaterial.find(mat.b_name)
		export_material(a_mat,out) if a_mat
		export_material(b_mat,out) if b_mat
	end

	if not @exported_mats.index(mat.name)
		write_mat(mat,out)
		@exported_mats.push(mat.name)
	end

end
#####################Material Writer############################
def write_mat(mat,out)

@tex_index=0
export_name=mat.name
export_name="previewmaterial" if mat==preview_material
export_name="Default" if @instance_mat                  #this allows instances to use different materials - blend materials may not work with this
result=mat.rgb 			#get the color of the SketchUp material
export_name="C_"+export_name+"_C" if mat.clip_map? or mat.clip_shader?
opacity=mat.alpha
type=mat.type

albedo_tex=nil 			
bump_map=nil
exponent_map=nil
sigma_map=nil
disp_map=nil
emission_map=nil
blend_map=nil
specular_map=nil

albedo_shader=nil
bump_shader=nil
exponent_shader=nil
sigma_shader=nil
disp_shader=nil
blend_shader=nil
emission_shader=nil
specular_shader=nil


	if (type=="Specular") or (type=="Glossy Transparent")
		alpha_factor=opacity*opacity*1000
		sss_spectrum=mat.sss_spectrum.to_s.split(' ')
		if sss_spectrum[0] and sss_spectrum[1] and sss_spectrum[2]
			rgb_spectrum=true
		else
			rgb_spectrum=false
		end
		g_spectrum=mat.g_spectrum.to_s.split(' ')
		if g_spectrum[0] and g_spectrum[1] and g_spectrum[2]
			g_rgb_spectrum=true
		else
			g_rgb_spectrum=false
		end

		#Export the medium
		medium_name=export_name+"_medium"
		out.puts "		<medium>"
		out.print "			<name>#{medium_name}</name>\n"
		out.print "			<precedence>#{mat.precedence}</precedence>\n"
		out.print "			<basic>\n"
		out.print "				<ior>#{mat.ior}</ior>\n"
		out.print "				<cauchy_b_coeff>#{mat.cauchy_b_coeff}</cauchy_b_coeff>\n"
		out.puts "				<absorption_coefficient_spectrum>"
		out.puts "					<rgb>"
		out.print "						<rgb>" + "%.4f" %((1.0-result[0]/255.0)*alpha_factor) + " "+ "%.4f" %((1.0-result[1]/255.0)*alpha_factor) + " "+ "%.4f" %((1.0-result[2]/255.0)*alpha_factor) + "</rgb>\n"
		out.print "						<gamma>1.0</gamma>\n"
		out.print "					</rgb>\n"
		out.print "				</absorption_coefficient_spectrum>\n"

		if mat.sss?
			out.print "				<subsurface_scattering>\n"
			out.print "					<scattering_coefficient_spectrum>\n"
		
			if rgb_spectrum==true
				out.print "						<rgb>\n"
				out.print "							<rgb>#{sss_spectrum[0]} #{sss_spectrum[1]} #{sss_spectrum[2]}</rgb>\n"
				out.print "							<gamma>1.0</gamma>\n"
				out.print "						</rgb>\n"
			else
				out.print "						<uniform>\n"
				out.print "							<value>#{sss_spectrum[0]}</value>\n"
				out.print "						</uniform>\n"
			end

			out.print "					</scattering_coefficient_spectrum>\n"
			out.print "					<phase_function>\n"
			if mat.phase_function=="Uniform"
				out.print "						<uniform/>\n"
			else
				out.puts "						<henyey_greenstein>"
				out.puts "							<g_spectrum>"
				if g_rgb_spectrum
					out.print "							<rgb>\n"
					out.print "								<rgb>#{g_spectrum[0]} #{g_spectrum[1]} #{g_spectrum[2]}</rgb>\n"
		  			out.print "								<gamma>1.0</gamma>\n"
					out.print "							</rgb>\n"
				else
					out.print "							<uniform>\n"
					out.print "								<value>#{g_spectrum[0]}</value>\n"
					out.print "							</uniform>\n"
				end
				out.puts "							</g_spectrum>"
				out.puts "						</henyey_greenstein>"
			end

			out.print "					</phase_function>\n"
			out.print "				</subsurface_scattering>\n"
			
		end
		out.print "			</basic>\n"
		out.print "		</medium>\n"
	
	end     #Finished exporting the medium

	##Material Export Starts Here
	
	case type
	
	when "Linked IGM"
		ligm=mat.linked_igm
		if not FileTest.exist?(ligm)
			UI.messagebox("Could not find linked igm material #{ligm}")
			return
		end
		ligm_file=File.new(ligm,"r")
		md=ligm_file.read
		ligm_file.close
		materials=$smo.get_materials(md)   #returns an array of all the materials found in the IGM file.  The material needed is the last material defined in the file.
		mat_xml=materials[-1]  #gets the last material in the array of materials found
		linked_name=$smo.parse("name",mat_xml)   #gets the name of the material found in the IGM file.
		out.puts "<include>"
		out.puts "	<pathname>#{ligm}</pathname>"
		out.puts "</include>"
		out.puts "<alias_material>"
		out.puts "	<current_name>#{linked_name}</current_name>"
		out.puts "	<new_name>#{export_name}</new_name>"
		out.puts "</alias_material>"
	when "Diffuse","Specular","Phong","Metals","Oren-Nayar","Glossy Transparent","Blend"
		####export blended diffuse transmitters
		if type=="Diffuse" or type=="Phong"
			if (opacity<1.0) and (opacity>0.0)
				export_blended_diffuse_transmitter(mat,export_name,out)
				export_clip_map(mat,out,export_name)  if mat.clip_map? or mat.clip_shader? #exports the clip map
				@exported_mats.push(mat)  #keep track of all exported materials
				return
			end
		end
		out.puts "			<material>"
		out.puts "			<name>#{export_name}</name>"
		indigo_type=mat.indigo_type
		out.puts "		<#{indigo_type}>"
		unless type=="Blend"
			if mat.emitter?
				out.puts "			<layer>#{mat.layer}</layer>" if !(@igm)
			end
		end
		if type=="Specular" or type=="Glossy Transparent"
			if type=="Specular"
				out.print " 			<transparent>true</transparent>\n" if opacity<1.0
				out.print "			<transparent>false</transparent>\n" if opacity==1.0
			end
			out.print "			<internal_medium_name>#{medium_name}</internal_medium_name>\n"
		end

		#export all of the texture xml and collect the indices
		albedo_tex=export_texture(mat,mat.albedo_texture,out) if mat.albedo_texture?
		specular_map=export_texture(mat,mat.specular_map,out) if mat.specular_map?
		blend_map=export_texture(mat,mat.blend_map,out) if mat.blend_map? 			
		bump_map=export_texture(mat,mat.bump_map,out)  if mat.bump_map?
		exponent_map=export_texture(mat,mat.exponent_map,out) if mat.exponent_map?
		sigma_map=export_texture(mat,mat.sigma_map,out) if mat.sigma_map?
		disp_map=export_texture(mat,mat.disp_map,out)  if mat.disp_map? #and (!mat.clip_map?) #don't export the displacement map if this material has a clip map, export it with the blend material
		emission_map=export_texture(mat,mat.emission_map,out) if mat.emission_map?

		#collect all of the shaders
		albedo_shader=mat.albedo_texture.shader_code if mat.albedo_shader?
		specular_shader=mat.specular_map.shader_code if mat.specular_shader?
		blend_shader=mat.blend_map.shader_code if mat.blend_shader?
		bump_shader=mat.bump_map.shader_code if mat.bump_shader?
		exponent_shader=mat.exponent_map.shader_code if mat.exponent_shader?
		sigma_shader=mat.sigma_map.shader_code if mat.sigma_shader?
		disp_shader=mat.disp_map.shader_code if mat.disp_shader? #and (!mat.clip_map?)
		emission_shader=mat.emission_map.shader_code if mat.emission_shader?
		

		if type=="Blend"
			matA=mat.a_name
			matB=mat.b_name
   			translatednames = Sketchup.active_model.materials.collect {|m| m.display_name}
			indexA = translatednames.index(matA)
			indexB = translatednames.index(matB)
			if (indexA==nil and matA!="None")
				UI.messagebox ("Error: Blend material tried to use non-existent material named") + " #{matA}"
			end
			if (indexB==nil and matB!="None")
				UI.messagebox ("Error: Blend material tried to use non-existent material named") + " #{matB}"
			end
			matA=matA.gsub(/[<>]/, '*')
			matB=matB.gsub(/[<>]/, '*')
							
			out.print "				<a_name>#{matA}</a_name>\n"
			out.print "				<b_name>#{matB}</b_name>\n"
			out.puts "				<blend>"
			if blend_map
				export_texture_index(blend_map,out)
			elsif blend_shader
				export_shader(blend_shader,out)
			else
				out.puts "		<constant>#{mat.blend_map.b}</constant>"
			end
			out.puts "				</blend>"
		end
		
		if type=="Diffuse" or type=="Oren-Nayar" or type=="Phong"
			#out.puts "			<random_triangle_colours>true</random_triangle_colours>" if type=="Diffuse"
			out.puts "			<albedo>" unless type=="Phong"
			out.puts "			<diffuse_albedo>" if type=="Phong"
			if albedo_tex
				export_texture_index(albedo_tex,out)
			elsif albedo_shader
				export_shader(albedo_shader,out)
			else
				export_rgb_spectrum(out,result) if not albedo_tex
			end
			out.puts "			</albedo>" unless type=="Phong"
			out.puts "			</diffuse_albedo>" if type=="Phong"
		end
		
		out.puts "			<ior>#{mat.ior}</ior>" if type=="Phong"
		
		if type=="Metals"
			nkdata=mat.nk_data    #returns an NKdata object
			if mat.use_nkdata?
				out.puts "				<nk_data>#{File.join(File.dirname(@path),tex_path,nkdata.filename)}</nk_data>" if not @igm
				out.puts "				<nk_data>nkdata\\#{nkdata.filename}</nk_data>" if @igm
				@nkdata.push(nkdata.path) if (not @nkdata.index(nkdata.path))    #copies stores the nkdata path for future export
			else
				out.puts "			<specular_reflectivity>"
				if specular_map
					export_texture_index(specular_map,out)
				elsif specular_shader
					export_shader(specular_shader,out)
				else
					export_rgb_spectrum(out,result) if not specular_map
				end
				out.puts "			</specular_reflectivity>"
			end
		end 
		if type=="Oren-Nayar"
			out.puts "			<sigma>"
			if sigma_map
				export_texture_index(sigma_map,out)
			elsif sigma_shader
				export_shader(sigma_shader,out)
			else
				out.puts "		<constant>#{mat.sigma_map.b}</constant>"
			end
			out.puts "			</sigma>"
		end
		if type=="Phong" or type=="Glossy Transparent" or type=="Metals"
			out.puts "			<exponent>"
			if exponent_map
				export_texture_index(exponent_map,out)
			elsif exponent_shader
				export_shader(exponent_shader,out)
			else
				out.puts "		<constant>#{mat.exponent_map.b}</constant>"
			end
			out.puts "			</exponent>"
		end
		
		
		####export the common texture attributes
		if bump_map or bump_shader
			out.puts "			<bump>"
			export_texture_index(bump_map,out) if bump_map
			export_shader(bump_shader,out) if bump_shader
			out.puts "			</bump>"
		end
		if disp_map or disp_shader
			out.puts "			<displacement>"
			export_texture_index(disp_map,out) if disp_map
			export_shader(disp_shader,out) if disp_shader
			out.puts "			</displacement>"
		end
		if mat.emitter?
			
			#gain=mat.base_emission_gain
			#color=color.collect {|val| val*gain}
			out.puts "			<base_emission>"
			if mat.base_emission_spectrum=="Blackbody"
				out.puts "				<constant>"
				out.puts "					<blackbody>"
				out.puts "						<temperature>#{mat.temperature}</temperature>"
				out.puts "						<gain>1.0</gain>" if not @preview_material
				out.puts "						<gain>0.00005</gain>" if @preview_material
				out.puts "					</blackbody>"
				out.puts "				</constant>"
			else
				color=mat.base_emission
				export_rgb_spectrum(out,color)
			end
			out.puts "			</base_emission>"
		end
		if emission_map or emission_shader
			out.puts "			<emission>"
			export_texture_index(emission_map,out) if emission_map
			export_shader(emission_shader,out) if emission_shader
			out.puts "			</emission>"
		end
			
		out.puts "		</#{indigo_type}>"
		out.print " 		</material>\n"
		
		export_clip_map(mat,out,export_name)  if mat.clip_map? or mat.clip_shader? #exports the clip map

	when "Thin Glass"

		mat_A="SP_"+export_name+"_SP"
		mat_B="NULL_"+export_name+"_NULL"
				
		out.puts "		<material>"
		out.print "			<name>#{mat_A}</name>\n"
		out.print "			<phong>\n"
		bump_map=export_texture(mat,mat.bump_map,out)  if mat.bump_map?
		out.puts  "				<diffuse_albedo>"
		export_rgb_spectrum(out,result)
		out.puts "				</diffuse_albedo>"
		out.puts "				<ior>1000</ior>\n"
		out.puts "				<exponent>"
		out.puts "				<constant>1000000</constant>"
		out.puts "				</exponent>"
			
		if bump_map
			out.puts "			<bump>"
			export_texture_index(bump_map,out)
			out.puts "			</bump>"
		end
		
		out.print " 			</phong>\n"
		out.print " 		</material>\n"

		#Export Transmittance Layer
		out.puts "		<material>"
		out.print "			<name>#{mat_B}</name>\n"
		out.print "			<null_material/>\n"
		out.print "		</material>\n"

		#Export Blended Material
		@tex_index=0    #reset the texture index variable since we are now exporting a new material
		out.puts "		<material>"
		out.print "			<name>#{export_name}</name>\n"
		out.print "			<blend>\n"

		disp_map=export_texture(mat,mat.disp_map,out)  if mat.disp_map? and (!mat.clip_map?) #don't export the displacement map if this material has a clip map, export it with the blend material
		
		out.print "				<a_name>#{mat_B}</a_name>\n" 
		out.print "				<b_name>#{mat_A}</b_name>\n" 
		out.puts "				<blend>"
		out.puts "				<constant>#{mat.alpha}</constant>"
		out.puts "				</blend>"

		if disp_map
			out.puts "			<displacement>"
			export_texture_index(disp_map,out)
			out.puts "			</displacement>"
		end

		out.print "			</blend>\n"
		out.print "		</material>\n"
		
	end  #end case type
	
	@exported_mats.push(mat)  #keep track of all exported materials


end  #end material writer

#############################
def export_blended_diffuse_transmitter(mat,export_name,out)

type=mat.type   
result=mat.rgb 	
mat_a="DT_"+export_name+"_DT"
mat_b="D_"+export_name+"_D"
out.puts "		<material>"
out.print "			<name>#{mat_b}</name>\n"
out.print "			<#{mat.indigo_type}>\n" 
if mat.emitter?
	out.puts "			<layer>#{mat.layer}</layer>" if !(@igm)
end

#export all of the texture xml and collect the indices
albedo_tex=export_texture(mat,mat.albedo_texture,out) if mat.albedo_texture?		
bump_map=export_texture(mat,mat.bump_map,out)  if mat.bump_map?
exponent_map=export_texture(mat,mat.exponent_map,out) if mat.exponent_map?
disp_map=export_texture(mat,mat.disp_map,out)  if mat.disp_map?
emission_map=export_texture(mat,mat.emission_map,out) if mat.emission_map?

#collect all of the shaders
albedo_shader=mat.albedo_texture.shader_code if mat.albedo_shader?
bump_shader=mat.bump_map.shader_code if mat.bump_shader?
exponent_shader=mat.exponent_map.shader_code if mat.exponent_shader?
disp_shader=mat.disp_map.shader_code if mat.disp_shader?
emission_shader=mat.emission_map.shader_code if mat.emission_shader?
		
out.puts  "				<albedo>" if type=="Diffuse"
out.puts "				<diffuse_albedo>" if type=="Phong"
if albedo_tex
	export_texture_index(albedo_tex,out)
elsif albedo_shader
	export_shader(albedo_shader,out)
else
	export_rgb_spectrum(out,result) if not albedo_tex
end
out.puts "			</albedo>" unless type=="Phong"
out.puts "			</diffuse_albedo>" if type=="Phong"
out.puts "			<ior>#{mat.ior}</ior>" if type=="Phong"

if type=="Phong"
	out.puts "			<exponent>"
	if exponent_map
		export_texture_index(exponent_map,out)
	elsif exponent_shader
		export_shader(exponent_shader,out)
	else
		out.puts "		<constant>#{mat.exponent_map.b}</constant>"
	end
	out.puts "			</exponent>"
end

####export the common texture attributes
if bump_map or bump_shader
	out.puts "			<bump>"
	export_texture_index(bump_map,out) if bump_map
	export_shader(bump_shader,out) if bump_shader
	out.puts "			</bump>"
end
if disp_map or disp_shader
	out.puts "			<displacement>"
	export_texture_index(disp_map,out) if disp_map
	export_shader(disp_shader,out) if disp_shader
	out.puts "			</displacement>"
end
if mat.emitter?
	color=mat.base_emission
	gain=mat.base_emission_gain
	color=color.collect {|val| val*gain}
	out.puts "			<base_emission>"
	export_rgb_spectrum(out,color)
	out.puts "			</base_emission>"
end
if emission_map or emission_shader
	out.puts "			<emission>"
	export_texture_index(emission_map,out) if emission_map
	export_shader(emission_shader,out) if emission_shader
	out.puts "			</emission>"
end
			
out.puts "		</#{mat.indigo_type}>"
out.puts "		</material>"

#Blend the material with a diffuse transmitter material

@tex_index=0  #we are exporting a new material so reset the texture index			
out.puts "		<material>"
out.print "			<name>#{mat_a}</name>\n"
out.print "			<diffuse_transmitter>\n"
if mat.emitter?
	out.puts "			<layer>#{mat.layer}</layer>" if !(@igm)
end
#export all of the texture xml and collect the indices
albedo_tex=disp_map=emission_map=nil
albedo_shader=disp_shader=emission_shader=nil

albedo_tex=export_texture(mat,mat.albedo_texture,out) if mat.albedo_texture?		
disp_map=export_texture(mat,mat.disp_map,out)  if mat.disp_map?
emission_map=export_texture(mat,mat.emission_map,out) if mat.emission_map?

#collect all of the shaders
albedo_shader=mat.albedo_texture.shader_code if mat.albedo_shader?
disp_shader=mat.disp_map.shader_code if mat.disp_shader?
emission_shader=mat.emission_map.shader_code if mat.emission_shader?

out.puts  "				<albedo>"
if albedo_tex
	export_texture_index(albedo_tex,out)
elsif albedo_shader
	export_shader(albedo_shader,out)
else
	export_rgb_spectrum(out,result) if not albedo_tex
end
out.puts "			</albedo>"
if disp_map or disp_shader
	out.puts "			<displacement>"
	export_texture_index(disp_map,out) if disp_map
	export_shader(disp_shader,out) if disp_shader
	out.puts "			</displacement>"
end
if mat.emitter?
	color=mat.base_emission
	gain=mat.base_emission_gain
	color=color.collect {|val| val*gain}
	out.puts "			<base_emission>"
	export_rgb_spectrum(out,color)
	out.puts "			</base_emission>"
end
if emission_map or emission_shader
	out.puts "			<emission>"
	export_texture_index(emission_map,out) if emission_map
	export_shader(emission_shader,out) if emission_shader
	out.puts "			</emission>"
end
out.print "			</diffuse_transmitter>\n"
out.print "		</material>\n"

#Export the blended diffuse transmitter

out.puts "		<material>"
out.print "			<name>#{export_name}</name>\n"
out.print "			<blend>\n"
out.print "				<a_name>#{mat_a}</a_name>\n" #transmitter component
out.print "				<b_name>#{mat_b}</b_name>\n" #normal diffuse component 	
out.puts "				<blend>"
out.puts "					<constant>#{mat.alpha}</constant>"
out.puts "				</blend>"
out.print "			</blend>\n"
out.puts "		</material>"

end

####################################Write the Texture Information#################
def export_texture(indigo_mat,tex,out)

	illegal="\\\/:*?\"<>|"   #characters not allowed in filenames
	su_mat=indigo_mat.mat  #get the SU material that we are exporting
	case tex.type
		when "SketchUp"
			tex_path=su_mat.display_name.delete(illegal)+".jpg"   #the texture filename will be the name of the SketchUp material.  This avoids conflicts since different sketchup materials can have the same texture filename
		when "External"
			tex_path=tex.path
	end
	uvs=tex.uv_set
	uvs="default" if uvs=="Default" 
	out.puts "				<texture>"
	out.print "					<uv_set>"
	if @igm or @preview_material
		out.print "#{tex.preview_uvset}"
	else
		out.print "#{uvs}"
	end
	out.print "</uv_set>\n"
	
	if @igm
		out.print "					<path>#{File.basename(tex_path)}</path>\n"   #the path for the texture is the file basename when exporting an IGM
	else
		out.puts "					<path>#{File.join(@tex_path,tex_path)}</path>" if tex.type=="SketchUp"
		out.puts "					<path>#{tex_path}</path>" if tex.type=="External"
	end
	
	out.puts "					<a>#{tex.a}</a>"
	out.puts "					<b>#{tex.b}</b>"
	out.puts "					<c>#{tex.c}</c>"
	out.print "					<exponent>#{tex.exponent}</exponent>\n"
	out.puts "				</texture>"
	@textures.push([su_mat,tex])  #keep track of all the exported textures
	tex_index=@tex_index
	@tex_index+=1
	return tex_index  #return the current index of this texture in the current material
	
end

#########################
def export_texture_index(index,out)

	out.puts "				<texture>"
	out.puts "					<texture_index>#{index}</texture_index>"
	out.puts "				</texture>"

end

#########################
def export_shader(shader_code,out)

	out.puts "				<shader>"
	out.puts "					<shader>"
	out.puts "					#{shader_code}"
	out.puts "					</shader>"
	out.puts "				</shader>"

end

#############################Write Procedural Fractral Brownian Motion########
def write_fbm(tex,mat,out)
	out.puts "				<fbm>"
	out.puts "					<u_scale>#{tex.u_scale}</u_scale>"
	out.puts "					<v_scale>#{tex.v_scale}</v_scale>"
	out.puts "				</fbm>"
end
	
####################################Albedo Map Export#############################
def export_albedo_map(mat,out)
	@tex_index.push("albedo")
	albedo_texture=mat.albedo_texture
	out.print "				<texture>\n"
	write_texture(albedo_texture,mat,out)
	out.print " 				</texture>\n"
end

###################################Blend Map Export#############################
def export_blend_map(mat,out)
	@tex_index.push("blend")
	blend_map=mat.blend_map
	out.print "				<blend_map>\n"
	write_texture(blend_map,mat,out)
	out.print " 				</blend_map>\n"
end

###################################Emitter Map Export#############################
def export_emitter_map(mat,out)
	#@tex_index.push("emission")
	emitter_map=mat.albedo_texture
	export_texture(mat,emitter_map,out)
end

###################################Emission Map Export#############################
def export_emission_map(mat,out)
	@tex_index.push("emission")
	emission_map=mat.emission_map
	out.print "				<texture>\n"
	write_texture(emission_map,mat,out)
	out.print " 				</texture>\n"
end

###################################Sigma Map Export#############################
def export_sigma_map(mat,out)
	@tex_index.push("sigma")
	sigma_map=mat.sigma_map
	out.print "				<texture>\n"
	write_texture(sigma_map,mat,out)
	out.print " 				</texture>\n"
end

####################################Bump Map Export#############################
def export_bump_map(mat,out)
	@tex_index.push("bump")
	bump_map=mat.bump_map
	if not bump_map.valid?   
		UI.messagebox ("Could not find bump map for material named") + " #{mat.mat.display_name}"  
		return
	end
	out.print "				<texture>\n"
	write_texture(bump_map,mat,out)
	out.print " 				</texture>\n"
end

####################################Displacement Map Export#############################
def export_disp_map(mat,out)
	@tex_index.push("displacement")
	dm=mat.disp_map
	if not dm.valid?   
		UI.messagebox ("Could not find displacement map for material named") + " #{mat.mat.display_name}"  
		return
	end
	out.print "				<texture>\n"
	write_texture(dm,mat,out)
	out.print " 				</texture>\n"
end

####################################Exponent Map Export#############################
def export_exponent_map(mat,out)
	@tex_index.push("exponent")
	exponent_map=mat.exponent_map
	if not exponent_map.valid?   
		UI.messagebox ("Could not find exponent map for material named") + " #{mat.mat.display_name}"  
		return
	end
	out.print "				<texture>\n"
	write_texture(exponent_map,mat,out)
	out.print " 				</texture>\n"
end
####################################Clip Map Export
def export_clip_map(mat,out,clipped_name)

	@tex_index=0    #reset the texture index variable since we are now exporting a new material
	clip_index=nil
	disp_index=nil
	mat_name=mat.name
	mat_name="previewmaterial" if mat==preview_material
	clip_map=mat.clip_map
	#if not clip_map.valid?
		#UI.messagebox ("Could not find clip map for material named") + " #{mat.mat.display_name}"  
		#return
	#end	
	write_null_mat(out) if (not @null_exported)
	out.print "		<material>\n"
	out.print "			<name>#{mat_name}</name>\n"
	out.print "			<blend>\n"
	out.print "				<a_name>#{clipped_name}</a_name>\n"
	out.print "				<b_name>None</b_name>\n"
	clip_index=export_texture(mat,clip_map,out) if mat.clip_map?
	
	#disp_index=export_texture(mat,mat.disp_map,out) if mat.disp_map?
	out.puts "				<blend>"
	export_texture_index(clip_index,out) if mat.clip_map?
	export_shader(mat.clip_map.shader_code,out) if mat.clip_shader?
	out.puts "				</blend>"
	#if disp_index
		#out.puts "			<displacement>"
		#export_texture_index(disp_index,out)
		#out.puts "			</displacement>"
	#end
	
	out.print "			</blend>\n"
	out.print "		</material>\n"

end

###############################################Write Textures########################
def export_textures(textures)   #function takes an array of an array of SU materials and IndigoTexture objects
	
	Sketchup.active_model.start_operation("Export Textures")
	illegal="\\\/:*?\"<>|"   #characters not allowed in filenames
	exported=[]
	tw=Sketchup.create_texture_writer
	entities = @model.active_entities
	helper_group=entities.add_group
	#p textures.length
for t in textures
	mat=t[0]  #get the SU material that references this texture
 	tex=t[1]  #get the IndigoTexture object

	case tex.type
		when "SketchUp"  #export the texture to the textures directory
			if (mat.respond_to?(:texture) and mat.texture !=nil)
				export_filename=mat.display_name.delete(illegal)+".jpg"
				helper_group.material=mat
				if not exported.index(export_filename)    #check if this texture has already been exported
					export_path=File.join(File.dirname(@path),tex_path,export_filename)
					tw.load(helper_group)   #load the texture if it has not yet been loaded
					status=tw.write(helper_group,export_path)
					exported.push(export_filename)     #keep track of all of the exported texture filenames
				end
			end		
		when "External"   #copy the file to the textures directory if we are exporting an IGM
			#p @igm
			if @igm and (not exported.index(export_filename))
				#p "copying file"
				export_filename=File.basename(tex.path)
				export_path=File.join(File.dirname(@path),tex_path,export_filename)
				#p export_path
				read_file=File.new(tex.path,"rb")
				contents=read_file.read
				read_file.close()
				write_file=File.new(export_path,"wb")
				write_file.write(contents)
				write_file.close()
				exported.push(export_filename)   #keep track of all of the exported texture filenames
			end
	end

end

#entities.erase_entities helper_group
Sketchup.active_model.abort_operation
tw=nil

end


###############Write the Null Material
def write_null_mat(out)
	if not @null_exported
		out.puts "		<material>"
		out.print "			<name>None</name>\n"
		out.print "			<null_material/>\n"
		out.print "		</material>\n"
		@null_exported=true
	end
end

############################################IGM Exporter
def export_igm(mat,pack)

	out=File.new(path,"w")
	#@tex_path=File.dirname(path)
	@tex_path=""
	@igm=true
	out.puts "<?xml version=\"1.0\" encoding=\"utf-8\"?>"
	out.puts "<scenedata>"
	
	begin
		export_material(mat,out)
	rescue
		out.close
		UI.messagebox "Errors occured while exporting the IGM file."
		@igm=false
		raise
	end
	out.puts "</scenedata>"
	out.close
	
	begin
		export_textures(@textures)  #export textures collected during the material export process
	rescue
		UI.messagebox "Errors occured while exporting the material's textures."
		raise
	end
	
	@igm=false	
	#######the IGM spec does not require exporting of nkdata files to the IGM path
	#begin
		#for data in @nkdata
			#nk=NKdata.new(data)
			#nk.export(File.dirname(@path))  #exports the nkdata to the textures directory
		#end
	#rescue
		#UI.messagebox "Errors occured while exporting the material's nkdata."
		#raise
	#end
	
	if pack   #the user wishes to pack the material
		status=SU2IN.pack_igm(path)
		if status==nil
			UI.messagebox("Unable to pack IGM file.")
		end
	else
		UI.messagebox "Material saved to #{path}"
	end

end

#########################################Camera export
def export_camera(v,out)

aperture=@irs.aperture
ap_shape=@irs.aperture_shape
focal_point=@irs.focal_point
exr_shift=@irs.exr_shift.to_f
env=@irs.environment
shutterSpeed=1/(@irs.shutter_speed.to_f)

h = v.vpheight   #get the dimensions of the viewport
w = v.vpwidth
user_camera = v.camera
f=user_camera.focal_length
user_eye = user_camera.eye
user_y = user_camera.yaxis #camera up vector
user_z = user_camera.zaxis #camera forward vector
sensor_width=user_camera.image_width.to_f/1000

####testing exr shifting (now deprecated as of 1.1.16)
#yvector=Geom::Vector3d.new 0,0,1
#if (exr_shift!=0.0) and (env=="Environment Map")
#	@exrshift=Geom::Transformation.rotation user_eye, yvector, -(exr_shift*3.1415926535/180.0)
#	user_y.transform! @exrshift 
#	user_z.transform! @exrshift
#end

if SU2IN.photomatch?(v)  #check if the current view is photomatched
	aspect=user_camera.aspect_ratio     #view will have a set aspect ratio if in photo match mode
	if sensor_width==0.0                
		sensor_distance=(f.to_f/aspect)/1000
		sensor_width=0.036
	else
		sensor_distance=f.to_f/1000
	end
else
	sensor_width=0.036 if sensor_width==0.0
	old_aspect=user_camera.aspect_ratio
	if old_aspect==0.0  #if aspect ratio is not set, set it to the viewport aspect ratio
		old_aspect=(w.to_f)/(h.to_f)
		sensor_distance=(f.to_f/old_aspect)/1000
	else
		sensor_distance=f.to_f/1000
	end
	aspect=old_aspect
end

stop=aperture.split("\/")[1].to_f
ap_radius=sensor_distance/(stop*2)

#Convert the stored focal point to a focus distance
if focal_point!="auto"
	vector=user_eye - focal_point if focal_point
	focus_distance=vector.length*@scale
else
	focus_distance=2.0
end

out.puts "		<camera>"
out.puts "			<pos>" + "%.4f" %(user_eye.x*@scale)+ " "+ "%.4f" % (user_eye.y*@scale) + " " + "%.4f" %(cz=user_eye.z*@scale)+ "</pos>"
out.puts "			<up>" + "%.4f" %(user_y.x)+ " "+ "%.4f" % (user_y.y) + " " + "%.4f" %(user_y.z)+ "</up>"
out.puts "			<forwards>" + "%.4f" %(user_z.x)+ " "+ "%.4f" % (user_z.y) + " " + "%.4f" %(user_z.z)+ "</forwards>"
out.puts "			<aperture_radius>" + "%.4f" %(ap_radius)+"</aperture_radius>"
out.puts "			<focus_distance>"+ "%.4f" %(focus_distance)+"</focus_distance>"
out.puts "			<aspect_ratio>" + "%.4f" %(aspect) + "</aspect_ratio>"
out.puts "			<sensor_width>#{sensor_width}</sensor_width>"
out.puts "			<lens_sensor_dist>" + "%.4f" %(sensor_distance)+"</lens_sensor_dist>"
out.puts "			<white_balance>#{@irs.white_balance}</white_balance>"
out.puts "			<autofocus/>" if focal_point=="auto"
out.puts "			<exposure_duration>#{shutterSpeed}</exposure_duration>"
out.puts "			<aperture_shape>"
case ap_shape
	when "circular"
		out.puts "				<circular/>"
	when "image"
		out.puts "				<image>"
		out.puts "					<path>#{@irs.aperture_image}</path>"
		out.puts "				</image>"
	else
		out.puts "				<generated>"
		out.puts "					<num_blades>#{ap_shape}</num_blades>"
		out.puts "					<blade_offset>#{@irs.blade_offset}</blade_offset>"
		out.puts "					<blade_curvature_radius>#{@irs.blade_curvature_radius}</blade_curvature_radius>"
		out.puts "					<start_angle>#{@irs.start_angle.to_f*3.14159/180}</start_angle>"
		out.puts "				</generated>"
	
end
out.puts "			</aperture_shape>"
if (FileTest.exist?(@irs.obstacle_map)) and (@irs.use_obstacle_map?)
	out.puts "			<obstacle_map>"
	out.puts "				<path>#{@irs.obstacle_map}</path>"
	out.puts "			</obstacle_map>"
end

out.puts "			<lens_shift_up_distance>#{@irs.shift_up.to_f/1000.0}</lens_shift_up_distance>"

out.puts "			<lens_shift_right_distance>#{@irs.shift_right.to_f/1000.0}</lens_shift_right_distance>" 							
out.puts "		</camera>"


end

###################################Export Render Settings
def export_render_settings(out)

case @irs.method
	when "MLT"
		met=true
		bidir=false
		hybrid=false
		alpha=false
	when "PT"
		met=false
		bidir=false
		hybrid=false
		alpha=false
	when "Hybrid"
		met=false
		bidir=false
		hybrid=true
		alpha=false
	when "Bidir MLT"
		met=true
		bidir=true
		hybrid=false
		alpha=false
	when "Bidir PT"
		met=false
		bidir=true
		hybrid=false
		alpha=false
	when "Bidir Hybrid"
		met=false
		bidir=true
		hybrid=true
		alpha=false
	when "Alpha"
		met=true
		bidir=true
		hybrid=false
		alpha=true
end

width=@irs.width.to_i
height=@irs.height.to_i
view=Sketchup.active_model.active_view
current_camera=view.camera
old_aspect=current_camera.aspect_ratio

if old_aspect==0.0 
	old_aspect=view.vpwidth.to_f/view.vpheight.to_f
	height=(width.to_f/old_aspect).to_i    #set the height to match the aspect ratio of the viewport
	#width=(height.to_f*old_aspect).to_i    #set the width to match the aspect ratio of the viewport
	
end

if SU2IN.photomatch?(Sketchup.active_model.active_view)   
	current_aspect=current_camera.aspect_ratio   #this is the aspect ratio of the photomatch
	aspect=width.to_f/height.to_f
	if (current_aspect-aspect).abs>0.01  #check if rendered image aspect ratio matches photomatch aspct ratio
		height=(width/current_aspect).to_i   #set the height to match the aspect ratio of the photo
		UI.messagebox "Image dimensions set to #{width}x#{height} to match photo aspect ratio."
	end
end

out.puts "		<renderer_settings>"
out.puts "			<width>#{width}</width>"
out.puts "			<height>#{height}</height>"
out.puts "			<max_num_consec_rejections>#{@irs.mncr.to_i}</max_num_consec_rejections>"
out.puts "			<bidirectional>true</bidirectional>" if bidir
out.puts "			<bidirectional>false</bidirectional>" if not bidir
out.puts "			<metropolis>true</metropolis>" if met
out.puts "			<metropolis>false</metropolis>" if not met
out.puts "			<hybrid>true</hybrid>" if hybrid
out.puts "			<hybrid>false</hybrid>" if not hybrid
out.puts "			<halt_time>#{@irs.halt}</halt_time>" if @irs.halt_unit=="sec"
out.puts "			<halt_samples_per_pixel>#{@irs.halt}</halt_samples_per_pixel>" if @irs.halt_unit=="spp"
out.puts "			<image_save_period>#{@irs.image_save_period}</image_save_period>"
out.puts "			<auto_choose_num_threads>true</auto_choose_num_threads>" if @irs.auto_choose_threads?
out.puts "			<auto_choose_num_threads>false</auto_choose_num_threads>" if !@irs.auto_choose_threads?
out.puts "			<num_threads>#{@irs.num_threads}</num_threads>" if !@irs.auto_choose_threads?
out.puts "			<save_igi>true</save_igi>" if @irs.save_igi?
out.puts "			<save_igi>false</save_igi>" if !@irs.save_igi?
out.puts "			<watermark>true</watermark>" if @irs.watermark?
out.puts "			<watermark>false</watermark>" if !@irs.watermark?
out.puts "			<aperture_diffraction>#{@irs.aperture_diffraction?}</aperture_diffraction>"
out.puts "			<render_foreground_alpha>true</render_foreground_alpha>" if alpha
out.puts "			<render_foreground_alpha>false</render_foreground_alpha>" if not alpha
#out.puts "			<post_process_diffraction>false</post_process_diffraction>"    #this feature currently disabled
if @irs.render_region?
	region=@irs.region
	if (region[1].to_i>0) and (region[3].to_i>0)
		out.puts "			<render_region>"
		out.puts "				<x1>#{[region[0].to_i,width].min}</x1>"
		out.puts "				<y1>#{[region[2].to_i,height].min}</y1>"
		out.puts "				<x2>#{[region[1].to_i,width].min}</x2>"
		out.puts "				<y2>#{[region[3].to_i,height].min}</y2>"
		out.puts "			</render_region>"
	end
end
out.puts "		</renderer_settings>"

end

#################################################Export Tonemapping
def export_tonemapping(out)

out.puts "		<tonemapping>"
case @irs.tm
	when "Reinhard"
		out.puts "			<reinhard>"
		out.puts "				<pre_scale>#{@irs.pre_scale}</pre_scale>"
		out.puts "				<post_scale>#{@irs.post_scale}</post_scale>"
		out.puts "				<burn>#{@irs.burn}</burn>"
		out.puts "			</reinhard>"
	when "Linear"
		out.puts "			<linear>"
		out.puts "				<scale>#{@irs.linearScale}</scale>"
		out.puts "			</linear>"
	when "Camera"
		out.puts "			<camera>"
		out.puts "				<film_iso>#{@irs.iso}</film_iso>"
		out.puts "				<ev_adjust>#{@irs.ev_adjust}</ev_adjust>"
		out.puts "				<response_function_path>data/camera_response_functions/dscs315.txt</response_function_path>"
		out.puts "			</camera>"
			
end
out.puts "		</tonemapping>"

end

#################################Export Environment
def export_environment(out)

case @irs.environment
	when "Sun and Sky"
		si = Sketchup.active_model.shadow_info
		v = si["SunDirection"]
		out.puts "		<skylight>"
		out.puts "			<sundir>"+ "%.4f" % (v.x) + " " + "%.4f" % (v.y) + " " + "%.4f" % (v.z) + "</sundir>"
		out.puts "			<turbidity>#{@irs.turbidity}</turbidity>"
		out.puts "		</skylight>"

	when "Background"
		bg_gain=200000                 #calibrated gain of background spectrum to balance meshlights of common efficacy scale
		result=Sketchup.active_model.rendering_options["BackgroundColor"]
		if result
			red=result.red*bg_gain
			green=result.green*bg_gain
			blue=result.blue*bg_gain
		else
			red=0.0
			green=0.0
			blue=0.0
		end
		out.puts "		<background>"
		out.puts "			<spectrum>"
		out.puts "				<rgb>"
		out.print "					<rgb>#{red} #{green} #{blue}</rgb>\n"
		out.print "					<gamma>2.2</gamma>\n"
		out.puts "				</rgb>"
		out.puts "			</spectrum>"
		out.puts "		</background>"
	when "Environment Map"
		envmap_angle=@irs.exr_shift.to_f
		UI.messagebox "Warning:No Environment Map has been set." if @irs.exr==""
		out.puts "<background_settings>"
		out.puts "	<background_material>"
		out.puts "	<material>"
		out.puts "	<name>background</name>"
		
		out.puts "	<diffuse>"
		out.puts "	<layer>0</layer>"
		out.puts "		<texture>"
		out.puts "			<uv_set>default</uv_set>"
		out.puts "			<path>#{@irs.exr}</path>"
		out.puts "			<exponent>1.0</exponent>"
		out.puts "			<tex_coord_generation>"
		out.puts "				<spherical>"
		out.puts "					<rotation>"
		out.puts "						<axis_rotation>"
		out.puts "							<axis>0 0 1</axis>"
		out.puts "							<angle>#{envmap_angle.degrees}</angle>"
		out.puts "						</axis_rotation>"
		out.puts "					</rotation>"
		out.puts "				</spherical>"
		out.puts "			</tex_coord_generation>"
		out.puts "		</texture>"
		out.puts "			<base_emission>"
		out.puts "				<constant>"
		out.puts "					<blackbody>"
		out.puts "						<temperature>5000</temperature>"
		out.puts "						<gain>0.001</gain>"
		out.puts "					</blackbody>"
		out.puts "				</constant>"
		out.puts "			</base_emission>"
		out.puts "			<emission>"
		out.puts "				<texture>"
		out.puts "					<texture_index>0</texture_index>"
		out.puts "				</texture>"
		out.puts "			</emission>"
		out.puts "		</diffuse>"
		out.puts "	</material>"
		out.puts "</background_material>"
		out.puts "<emission_scale>"
		out.puts "	<material_name>background_material</material_name>"
		out.puts "	<measure>luminance</measure>"
		out.puts "	<value>#{@irs.exr_gain}</value>"
		out.puts "</emission_scale>"
		out.puts "</background_settings>"

end #end case

end

##############################################Export RGB Spectrum
def export_rgb_spectrum(out,result)

out.puts "				<constant>"
out.puts "					<rgb>"
out.puts "						<rgb>" + "%.4f" %((result[0]/255.0)) + " "+ "%.4f" % ((result[1]/255.0)) + " "+ "%.4f" % ((result[2]/255.0)) + "</rgb>"
out.puts "						<gamma>2.2</gamma>"
out.puts "					</rgb>"
out.puts "				</constant>"

end

###############################################Export Default Material
def export_default_mat(out,mat)

if not mat 
	colour = Sketchup.active_model.rendering_options["FaceFrontColor"]
	result=colour.red,colour.green,colour.blue
	result=[216,216,216] if @monochrome=="Clay"
	out.puts "		<material>"
	out.print "			<name>Default</name>\n"
	out.print "			<diffuse>\n"
	out.puts  "				<albedo>"
	export_rgb_spectrum(out,result)
	out.puts "				</albedo>"
	out.puts "			</diffuse>"
	out.print " 		</material>\n"
else							#this will export any material as the default material (useful for instancing)
	@instance_mat=mat				#keeps track of the last instanced material
	write_mat(IndigoMaterial.new(mat),out)
end

end

##################################################Export Clay Material
def export_clay(out)
	
out.puts "		<material>"
out.print "			<name>Clay</name>"
out.print "			<diffuse>"
out.puts  "				<albedo_spectrum>"
export_rgb_spectrum(out,[218.0,218.0,218.0])
out.puts "				</albedo_spectrum>"
out.print "			</diffuse>"
out.print " 	</material>"

end

##############################################Fog Export
def export_fog(out)

options=model.rendering_options
model_extents=model.bounds
eye=model.active_view.camera.eye
model_extents.add eye #ensures that the camera is inside the fog sphere
center=model_extents.center

cx=center.x*@scale
cy=center.y*@scale
cz=center.z*@scale

depth=model_extents.depth*@scale
height=model_extents.height*@scale
width=model_extents.width*@scale

d=depth
d=height if height>depth
d=width if (width>height) and (width>depth)

r=d/2 #fog sphere radius

fog_end=options["FogEndDist"]
fog_end=fog_end*@scale
fog_color=options["FogColor"]
alpha_factor=1

sss=2.772/fog_end  #distance at which light intensity is halved is 0.693/scattering coefficient

out.puts "		<medium>"
out.print "			<name>Fog_medium</name>\n"
out.print "			<precedence>2</precedence>\n"
out.print "			<basic>\n"
out.print "				<ior>1.0</ior>\n"
out.print "				<cauchy_b_coeff>0.0</cauchy_b_coeff>\n"
out.puts "				<absorption_coefficient_spectrum>"
out.puts "					<rgb>"
out.print "						<rgb>#{(1.0-fog_color.red/255.0)*alpha_factor} #{(1.0-fog_color.green/255.0)*alpha_factor} #{(1.0-fog_color.blue/255.0)*alpha_factor}</rgb>\n"
out.print "						<gamma>1.0</gamma>\n"
out.print "					</rgb>\n"
out.print "				</absorption_coefficient_spectrum>\n"
out.print "				<subsurface_scattering>\n"
out.print "					<scattering_coefficient_spectrum>\n"
out.print "						<uniform>\n"
out.print "							<value>#{sss}</value>\n"
out.print "						</uniform>\n"
out.print "					</scattering_coefficient_spectrum>\n"
out.print "					<phase_function>\n"
out.print "						<uniform/>\n"
out.print "					</phase_function>\n"
out.print "				</subsurface_scattering>\n"
out.print "			</basic>\n"
out.print "		</medium>\n"
out.print "		<material>\n"
out.print " 		<name>Fog</name>\n"
out.print " 		<specular>\n"
out.print " 			<transparent>true</transparent>\n"
out.print "			<internal_medium_name>Fog_medium</internal_medium_name>\n"
out.print " 		</specular>\n"
out.print " 		</material>\n"

out.puts "		<sphere>"
out.puts "			<center>#{cx} #{cy} #{cz}</center>"
out.puts "			<radius>#{r}</radius>"
out.puts "			<material_name>Fog</material_name>"
out.puts "		</sphere>"

end

###########################################Export Sphere Primitivies
def export_sphere(sphere,out)

inst=sphere[0]

sphere_mat=inst.material
if sphere_mat
	sphere_mat=IndigoMaterial.new(inst.material)
	sphere_mat_name=sphere_mat.name
else
	sphere_mat_name="Default"
end

box=inst.bounds
center=box.center #get the sphere in world coordinates
cx=center.x*@scale
cy=center.y*@scale
cz=center.z*@scale

r=box.height*@scale/2 #set radius of sphere equal to the half the height of its bounding box

out.puts "	<sphere>"
out.puts "		<center>#{cx} #{cy} #{cz}</center>"
out.puts "		<radius>#{r}</radius>"
out.puts "		<material_name>#{sphere_mat_name}</material_name>"
out.puts "	</sphere>"

end

end  #End IndigoExporter class


#####################################################Indigo Render Settings Interface Class

class IndigoRenderSettings

#Defaults
@@mncr=500
@@method="Bidir MLT"
@@halt=-1
@@halt_unit="sec"
@@aperture="f\/22"
@@image_save_period=120
@@white_balance="E"
@@environment="Sun and Sky"
@@turbidity=2.0
@@threads=1
@@focal_point="auto"
@@save_igi="On"
@@watermark="Off"
@@auto_choose_threads="On"
@@custom_image_name="Off"
@@low_priority="On"
@@tm="Reinhard"
@@exr=""
@@exr_type="Lat_Long"
@@exr_width=640
@@exr_shift=0.0
@@exr_gain=1000
@@pre_scale=4.5
@@post_scale=1.0
@@burn=6.0
@@iso=100
@@shutter_speed=30
@@ev_adjust=0.0
@@aperture_shape="circular"
@@num_blades=3
@@blade_offset=0.3
@@blade_curvature_radius=0.5
@@start_angle=0.0
@@aperture_image=""
@@obstacle_map=""
@@aperture_diffraction="Off"
@@use_obstacle_map="Off"
@@region="0.0|0.0|0.0|0.0"  #x1,x2,y1,y2
@@render_region="Off"
@@shift_up=0
@@shift_right=0
@@model_textures=[]   #array to store paths of user textures for easier re-selection

def initialize
	@model=Sketchup.active_model
	@view=@model.active_view
	@dict="indigo07_settings"
	@path=SU2IN.get_indigo_path
end

def IndigoRenderSettings.default_thumbnail_path
	path=SU2IN.get_indigo_path
	if FileTest.exist?(path)
		preview_path=File.join(File.dirname(path))
		if not FileTest.exist?(preview_path)
			default_thumb_path=""
		else
			default_thumb_path=File.join(preview_path,"thumbnails")
			if not FileTest.exist?(default_thumb_path)
				Dir.mkdir(default_thumb_path)
			end
			default_thumb_path.gsub!(/\\/,"\/")
		end
	else
		default_thumb_path=""
	end
	return default_thumb_path
end

def indigo_path
	return @path
end

def mncr
	@model.get_attribute(@dict,'mncr',@@mncr)
end

def mncr=(value)
	@model.set_attribute(@dict,'mncr',value)
end

def aperture
	@model.get_attribute(@dict,'aperture',@@aperture)
end

def aperture=(value)
	@model.set_attribute(@dict,'aperture',value)
end

def method
	@model.get_attribute(@dict,'method',@@method)
end

def method=(value)
	@model.set_attribute(@dict,'method',value)
end	

def width
	@model.get_attribute(@dict,'w',@view.vpwidth/2).to_i
end

def width=(value)
	@model.set_attribute(@dict,'w',value)
end

def height
	@model.get_attribute(@dict,'h',@view.vpheight/2).to_i
end

def height=(value)
	@model.set_attribute(@dict,'h',value)
end

def halt
	@model.get_attribute(@dict,'halt',@@halt)
end

def halt=(value)
	@model.set_attribute(@dict,'halt',value)
end

def image_save_period
	@model.get_attribute(@dict,'isp',@@image_save_period)
end

def image_save_period=(value)
	@model.set_attribute(@dict,'isp',value)
end

def white_balance
	@model.get_attribute(@dict,'wb',@@white_balance)
end

def white_balance=(value)
	@model.set_attribute(@dict,'wb',value)
end

def environment
	@model.get_attribute(@dict,'env',@@environment)
end

def environment=(value)
	@model.set_attribute(@dict,'env',value)
end

def turbidity
	@model.get_attribute(@dict,'tur',@@turbidity)
end

def turbidity=(value)
	@model.set_attribute(@dict,'tur',value)
end

def num_threads
	t=@model.get_attribute(@dict,'threads',@@threads)
	t=@model.set_attribute(@dict,'threads',1) if t=="Low Priority"   #backward compatibility with old versions
	return t
end

def num_threads=(value)
	@model.set_attribute(@dict,'threads',value)
end

def focal_point
	@model.get_attribute(@dict,'fp',@@focal_point)
end

def focal_point=(value)
	@model.set_attribute(@dict,'fp',value)
end

def save_igi?
	igi=@model.get_attribute(@dict,'save_igi',@@save_igi)
	return true if igi=="On"
	return false if igi=="Off"
end

def save_igi=(value)
	if value
		@model.set_attribute(@dict,'save_igi',"On")  
	else
		@model.set_attribute(@dict,'save_igi',"Off")  
	end
end

def watermark?
	wm=@model.get_attribute(@dict,'watermark',@@watermark)
	return true if wm=="On"
	return false if wm=="Off"
end

def watermark=(value)
	if value
		@model.set_attribute(@dict,'watermark',"On")  
	else
		@model.set_attribute(@dict,'watermark',"Off") 
	end
end

def auto_choose_threads?
	act=@model.get_attribute(@dict,'auto_threads',@@auto_choose_threads)
	return true if act=="On"
	return false if act=="Off"
end

def auto_choose_threads=(value)
	if value
		@model.set_attribute(@dict,'auto_threads',"On")  
	else
		@model.set_attribute(@dict,'auto_threads',"Off") 
	end
end

def custom_image_name?
	cin=@model.get_attribute(@dict,'custom_image_name',@@custom_image_name)
	return true if cin=="On"
	return false if cin=="Off"
end

def custom_image_name=(value)
	if value
		@model.set_attribute(@dict,'custom_image_name',"On")  
	else
		@model.set_attribute(@dict,'custom_image_name',"Off") 
	end
end

def low_priority?
	lp=@model.get_attribute(@dict,'low_priority',@@low_priority)
	return true if lp=="On"
	return false if lp=="Off"
end

def low_priority=(value)
	if value
		@model.set_attribute(@dict,'low_priority',"On")  
	else
		@model.set_attribute(@dict,'low_priority',"Off") 
	end
end

def tm
	@model.get_attribute(@dict,'tm',@@tm)
end

def tm=(value)
	@model.set_attribute(@dict,'tm',value)
end
	
def image_name
	model_filename = File.basename(@model.path,".skp")
	model_filename="untitled" if model_filename==""
	@model.get_attribute(@dict,'image_name',model_filename)
end

def image_name=(value)
	@model.set_attribute(@dict,'image_name',value)
end	

def halt_unit
	@model.get_attribute(@dict,'halt_unit',@@halt_unit)
end

def halt_unit=(value)
	@model.set_attribute(@dict,'halt_unit',value)
end

def exr
	@model.get_attribute(@dict,'exr',@@exr)
end

def exr=(value)
	@model.set_attribute(@dict,'exr',value)
end

def exr_type
	@model.get_attribute(@dict,'exr_type',@@exr_type)
end

def exr_type=(value)
	@model.set_attribute(@dict,'exr_type',value)
end

def exr_width
	@model.get_attribute(@dict,'exr_width',@@exr_width)
end

def exr_width=(value)
	@model.set_attribute(@dict,'exr_width',value)
end

def exr_gain
	@model.get_attribute(@dict,'exr_gain',@@exr_gain)
end

def exr_gain=(value)
	@model.set_attribute(@dict,'exr_gain',value)
end

def exr_width=(value)
	@model.set_attribute(@dict,'exr_width',value)
end

def pre_scale
	@model.get_attribute(@dict,'pre_scale',@@pre_scale)
end

def pre_scale=(value)
	@model.set_attribute(@dict,'pre_scale',value)
end

def post_scale
	@model.get_attribute(@dict,'post_scale',@@post_scale)
end

def post_scale=(value)
	@model.set_attribute(@dict,'post_scale',value)
end

def burn
	@model.get_attribute(@dict,'burn',@@burn)
end

def burn=(value)
	@model.set_attribute(@dict,'burn',value)
end	

def iso
	@model.get_attribute(@dict,'iso',@@iso)
end

def iso=(value)
	@model.set_attribute(@dict,'iso',value)
end	
	
def shutter_speed
	@model.get_attribute(@dict,'shutterSpeed',@@shutter_speed)
end

def shutter_speed=(value)
	@model.set_attribute(@dict,'shutterSpeed',value)
end

def ev_adjust
	@model.get_attribute(@dict,'exposure',@@ev_adjust)
end

def ev_adjust=(value)
	@model.set_attribute(@dict,'exposure',value)
end

def exr_shift
	@model.get_attribute(@dict,'exr_shift',@@exr_shift)
end

def exr_shift=(value)
	@model.set_attribute(@dict,'exr_shift',value)
end

def image_path
	if @path
		return File.join(File.dirname(@path),"renders").gsub!(/\\/,"\/")
	else
		return nil
	end
end

def thumbnail_path
	#thumb_path=@model.get_attribute(@dict,'thumb_path',IndigoRenderSettings.default_thumbnail_path)
	path=File.dirname(SU2IN.get_indigo_path)
	thumb_path=File.join(path,"SUthumbnails")
	if path
		Dir.mkdir(thumb_path) if not FileTest.exist?(thumb_path)
		thumb_path.gsub!(/\\/,"\/")
		return thumb_path
	else
		return nil
	end          
end

def thumbnail_path=(value)
	@model.set_attribute(@dict,'thumb_path',value)
end

def last_path
	@model.get_attribute(@dict,'export_path')
end

def last_path=(value)
	@model.set_attribute(@dict,'export_path',value)
end

def aperture_shape
	@model.get_attribute(@dict,'ap_shape',@@aperture_shape)
end

def aperture_diffraction?
	ad=@model.get_attribute(@dict,'ap_diff',@@aperture_diffraction)
	return true if ad=="On"
	return false if ad=="Off"
end

def aperture_diffraction=(value)
	if value
		@model.set_attribute(@dict,'ap_diff',"On")  
	else
		@model.set_attribute(@dict,'ap_diff',"Off") 
	end
end

def use_obstacle_map?
	om=@model.get_attribute(@dict,'use_om',@@use_obstacle_map)
	return true if om=="On"
	return false if om=="Off"
end

def use_obstacle_map=(value)
	if value
		@model.set_attribute(@dict,'use_om',"On")  
	else
		@model.set_attribute(@dict,'use_om',"Off") 
	end
end

def aperture_shape=(value)
	@model.set_attribute(@dict,'ap_shape',value)
end

def blade_offset
	@model.get_attribute(@dict,'blade_offset',@@blade_offset)
end

def blade_offset=(value)
	@model.set_attribute(@dict,'blade_offset',value)
end

def blade_curvature_radius
	@model.get_attribute(@dict,'blade_curvature_radius',@@blade_curvature_radius)
end

def blade_curvature_radius=(value)
	@model.set_attribute(@dict,'blade_curvature_radius',value)
end

def start_angle
	@model.get_attribute(@dict,'start_angle',@@start_angle)
end

def start_angle=(value)
	@model.set_attribute(@dict,'start_angle',value)
end

def aperture_image
	@model.get_attribute(@dict,'aperture_image',@@aperture_image)
end

def aperture_image=(value)
	@model.set_attribute(@dict,'aperture_image',value)
end

def obstacle_map
	@model.get_attribute(@dict,'obstacle_map',@@obstacle_map)
end

def obstacle_map=(value)
	@model.set_attribute(@dict,'obstacle_map',value)
end

def render_region?
	rr=@model.get_attribute(@dict,'render_region',@@render_region)
	return true if rr=="On"
	return false if rr=="Off"
end

def render_region=(value)
	if value
		@model.set_attribute(@dict,'render_region',"On")
	else
		@model.set_attribute(@dict,'render_region',"Off") 
	end
end

def region=(value)
	reg=value.join("|")
	@model.set_attribute(@dict,'region',reg)
end

def region
	reg=@model.get_attribute(@dict,'region',@@region)
	return reg.split("|")
end

def shift_up
	@model.get_attribute(@dict,'shift_up',@@shift_up)
end

def shift_up=(value)
	@model.set_attribute(@dict,'shift_up',value)
end

def shift_right
	@model.get_attribute(@dict,'shift_right',@@shift_right)
end

def shift_right=(value)
	@model.set_attribute(@dict,'shift_right',value)
end

def store_texture(path)
	#p "storing #{path}"
	model_textures=self.get_model_textures
	model_textures.push(path)
	@model.set_attribute(@dict,'model_textures',model_textures)
end

def get_model_textures
	model_textures=@model.get_attribute(@dict,'model_textures',@@model_textures)
	valid_model_textures=model_textures.find_all {|path| FileTest.exist?(path)}  #make sure the files are valid
	@model.set_attribute(@dict,'model_textures',valid_model_textures)
	return valid_model_textures
end

end #class 

class Sketchup::ComponentDefinition

def indigo_instance?
	#return true
	instanced=self.get_attribute 'indigo07_settings','inst',false	
	return instanced
end

end


##################################Mesh Builder#############################
class MeshBuilder

attr_reader :faces, :mesh_materials, :component_meshes, :component_instances, :spheres
def initialize

@parent_mat=[]
@component_meshes=[]
@component_instances=[]
@mesh_materials={}
@faces=0
@spheres=[]
	
end

##################################
def get_meshes_backup(object, trans, inst)

if object.class == Sketchup::ComponentInstance   #todo test for possible bug with non-visible indigo instances
	text="Component: " + object.definition.name
	if (object.definition.indigo_instance?) and (inst) 
		unless @component_meshes.find {|i| i[0]==object.definition}
			mb=MeshBuilder.new
			mb.get_meshes(object,Geom::Transformation.new, false)
			@component_meshes.push([object.definition,mb.mesh_materials])
			@faces+=mb.faces
			mb=nil
		end

		t=trans.to_a   #get the transformation of the component instance
		#extract scale values
		scalex=Math.sqrt(t[0]**2+t[1]**2+t[2]**2)
		scaley=Math.sqrt(t[4]**2+t[5]**2+t[6]**2)
		scalez=Math.sqrt(t[8]**2+t[9]**2+t[10]**2)
		
		if ((scalex-scaley).abs<0.000001) and ((scaley-scalez).abs<0.000001)  #check if instance is uniform scale
			@component_instances.push([object,trans]) #store instance object and transformation in array
			return
		else #instance is non-uniform scale
			entity_list=SU2IN.dummy(object)
		end
		
	else #if not an instance
		entity_list=SU2IN.dummy(object)
	end

elsif object.class == Sketchup::Group
	text="Group"
	entity_list=object.entities
else
	entity_list=object
end

SU2IN.status_bar("Collecting Faces - Level #{@parent_mat.size} - #{text}")  #{@faces}

	for e in entity_list
		if (e.class == Sketchup::Group and e.visible? and e.layer.visible?)
			if e.material
				mat = e.material
				@parent_mat.push(e.material)
			else
				@parent_mat.push(@parent_mat.last)
			end
			get_meshes(e, trans*e.transformation, inst)
			@parent_mat.pop
		end
		if (e.class == Sketchup::ComponentInstance and e.visible? and e.layer.visible?)
			if e.material
				mat = e.material
				@parent_mat.push(e.material)
			else
				@parent_mat.push(@parent_mat.last)
			end
			if (e.definition.name.downcase.slice("indigosphere")=="indigosphere") 
				@spheres.push([e,trans])
			else
				get_meshes(e, trans*e.transformation, inst)
			end
			@parent_mat.pop
		end
		if (e.class == Sketchup::Face and e.visible? and e.layer.visible?)
			if e.material
				mat = e.material				
			else
				mat=@parent_mat.last
			end

			@mesh_materials[mat] = [] if not @mesh_materials[mat]
			(@mesh_materials[mat] ||= []) << [e,trans]
			
			@faces+=1   #count of number of faces collected
		end
	end

end


##################################
def get_meshes(object, trans, inst)


if object.class==Sketchup::ComponentInstance or object.class==Sketchup::Group
	definition=object.definition if object.class==Sketchup::ComponentInstance
	definition=object.entities.parent if object.class==Sketchup::Group
	def_name=definition.name
	text="Mesh: " + def_name
	if (definition.indigo_instance?) and (inst) 
		unless @component_meshes.find {|i| i[0]==definition}
			mb=MeshBuilder.new
			mb.get_meshes(object,Geom::Transformation.new, false)
			@component_meshes.push([definition,mb.mesh_materials])
			@faces+=mb.faces
			mb=nil
		end

		#t=trans.to_a   #get the transformation of the component instance
		#extract scale values
		#scalex=Math.sqrt(t[0]**2+t[1]**2+t[2]**2)
		#scaley=Math.sqrt(t[4]**2+t[5]**2+t[6]**2)
		#scalez=Math.sqrt(t[8]**2+t[9]**2+t[10]**2)
		#p scalex,scaley,scalez
		
		#if ((scalex-scaley).abs<0.000001) and ((scaley-scalez).abs<0.000001)  #check if instance is uniform scale
			@component_instances.push([object,trans]) #store instance object and transformation in array
			return
		#else #instance is non-uniform scale
		#	entity_list=SU2IN.dummy(object)
		#end
		
	else #if not an instance
		entity_list=SU2IN.dummy(object)
	end

else
	entity_list=object
end

SU2IN.status_bar("Collecting Faces - Level #{@parent_mat.size} - #{text}")  #{@faces}

	for e in entity_list
		if (e.class == Sketchup::Group and e.visible? and e.layer.visible?)
			if e.material
				mat = e.material
				@parent_mat.push(e.material)
			else
				@parent_mat.push(@parent_mat.last)
			end
			get_meshes(e, trans*e.transformation, inst)
			@parent_mat.pop
		end
		if (e.class == Sketchup::ComponentInstance and e.visible? and e.layer.visible?)
			if e.material
				mat = e.material
				@parent_mat.push(e.material)
			else
				@parent_mat.push(@parent_mat.last)
			end
			if (e.definition.name.downcase.slice("indigosphere")=="indigosphere") 
				@spheres.push([e,trans])
			else
				get_meshes(e, trans*e.transformation, inst)
			end
			@parent_mat.pop
		end
		if (e.class == Sketchup::Face and e.visible? and e.layer.visible?)
			if e.material
				mat = e.material				
			else
				mat=@parent_mat.last
			end

			@mesh_materials[mat] = [] if not @mesh_materials[mat]
			(@mesh_materials[mat] ||= []) << [e,trans]
			
			@faces+=1   #count of number of faces collected
		end
	end

end

end  #class end

class IndigoExporter

##################################Export all meshes
def export_meshes(meshbuilder,out)
	
	mm=meshbuilder.mesh_materials
	#Export the material meshes
	mm.each do |material,faces|
		mesh={material=>faces}    #create a new hash that contains only the faces from this material
		export_mesh(material,mesh,out)
		#export_mesh_bin(material,mesh,out)   #binary mesh export test
		if material==nil
			#export_model("Default",Geom::Transformation.new,out)
			export_model(mesh,"Default",Geom::Transformation.new,out)
		else
			im=IndigoMaterial.new(material)
			case im.type
				when "Blackbody Light","RGB Light"
					export_meshlight(im,Geom::Transformation.new,out)
				when "Exit Portal"
					export_exit_portal(im.name,Geom::Transformation.new,out)
				else
					#export_model(im.name,Geom::Transformation.new,out)
					export_model(mesh,im.name,Geom::Transformation.new,out)
			end
		end
	end

	#Export the component meshes
	meshbuilder.component_meshes.each {|mesh| export_mesh(mesh[0],mesh[1],out)}
	#meshbuilder.component_meshes.each {|mesh| export_mesh_bin(mesh[0],mesh[1],out)}
	
	#Export the instances
	export_instances(meshbuilder,out)
	
end

####################################Export Instances
def export_instances(meshbuilder,out)

	component_meshes=meshbuilder.component_meshes
	#Export the instances
	meshbuilder.component_instances.each do |inst|
		c_mesh=component_meshes.find {|m| m[0].name==inst[0].definition.name}    #find the mesh associated with this instance
		mesh=c_mesh[1]
		mesh_name=inst[0].definition.name if inst[0].class==Sketchup::ComponentInstance
		mesh_name=inst[0].entities[0].parent.name if inst[0].class==Sketchup::Group
		inst_mat=inst[0].material
		trans=inst[1]
		#trans=Geom::Transformation.new*inst[0].transformation  #sketchyphysics export test
		#boxcenter=inst[0].bounds.center         
		export_default_mat(out,inst_mat) if inst_mat!=@instance_mat  #this function allows instances to use different materials
		export_model(mesh,mesh_name,trans,out)
	end
end


#########New mesh exporting first implemented in Indigo 1.1.2
def export_mesh(object,mesh,out)

if object.class==Sketchup::Material
	im=IndigoMaterial.new(object)
	mesh_name=im.name
elsif object.class==Sketchup::ComponentDefinition
	mesh_name=object.name
	cent=object.bounds.center
	sphysics_trans=Geom::Transformation.translation(Geom::Vector3d.new(cent.x,cent.y,cent.z)).inverse if self.physics
	p sphysics_trans
elsif object==nil
	mesh_name="Default"
end

out.puts "		<mesh>"
out.puts "			<name>#{mesh_name}</name>"

if (not im)  #if this is the default material or if this is a component definition (instanced) mesh
	out.print "			<normal_smoothing>true</normal_smoothing>\n"
else
	out.puts "			 <normal_smoothing>true</normal_smoothing>\n"  
	if im.disp_map? or im.disp_shader?   #only subdivide if displacement is enabled
		out.puts "			 <max_num_subdivisions>#{im.max_subdiv}</max_num_subdivisions>"
		out.puts "			<subdivide_pixel_threshold>#{im.pixel_threshold}</subdivide_pixel_threshold>"
		out.puts "			<subdivide_curvature_threshold>#{im.curvature_threshold}</subdivide_curvature_threshold>"
		out.puts "			<subdivision_smoothing>#{im.smooth?}</subdivision_smoothing>"
	end
end

out.puts " 			<embedded_2>"

 
#A mesh is a hash object that contains arrays of faces each indexed by a Sketchup::Materials object
#iterate through mesh to find uv sets and also transform all faces to world coordinates

transformed_mesh={}
has_uvs=false
has_uv0=false
has_uv1=false
has_uv2=false
has_uv3=false
uvset0={}
uvset1={}
uvset2={}
uvset3={}
v_index = 0
mat_index=0

mesh.each {|mat,faces|
	
	meshes = []	
	
	for ft in faces
		
		polymesh = ft[0].mesh 5 
		
		
		polymesh.transform! ft[1]
		####sketchyphysics test
		polymesh.transform! sphysics_trans if sphysics_trans
		#######################
		meshes.push(polymesh)

		uvset1[polymesh]=ft[0].get_attribute 'uvs','uv1'
		uvset2[polymesh]=ft[0].get_attribute 'uvs','uv2'
		uvset3[polymesh]=ft[0].get_attribute 'uvs','uv3'
	end
	
	transformed_mesh[mat]=meshes   #add the transformed faces

	if mat!=nil
		if mat.texture!=nil
			has_uv0=true
		end
	end
}

####check for uvsets and expose them
if has_uv0   #this mesh has at least one material with a texture assigned in SketchUp so it will have at least one UVset
	has_uvs=true
	out.puts "				<expose_uv_set>"
	out.puts "					<index>0</index>"
	out.puts "					<name>default</name>"
	out.puts "				</expose_uv_set>"
end
if uvset1.values.detect {|uvs| uvs!=nil}  #search the hash to see if any uvs were found
	has_uvs=true
	has_uv1=true
	out.puts "				<expose_uv_set>"
	out.puts "					<index>1</index>"
	out.puts "					<name>1</name>"
	out.puts "				</expose_uv_set>"
end
if uvset2.values.detect {|uvs| uvs!=nil}
	has_uvs=true
	has_uv2=true
	out.puts "				<expose_uv_set>"
	out.puts "					<index>2</index>"
	out.puts "					<name>2</name>"
	out.puts "				</expose_uv_set>"
end
if uvset3.values.detect {|uvs| uvs!=nil}
	has_uvs=true
	has_uv3=true
	out.puts "				<expose_uv_set>"
	out.puts "					<index>3</index>"
	out.puts "					<name>3</name>"
	out.puts "				</expose_uv_set>"
end

transformed_mesh.each_key {|mat|
	if mat
		matname = mat.display_name.gsub(/[<>]/, '*') 
	else
		matname = "Default"
	end
	out.puts "				<used_material_name>#{matname}</used_material_name>"
}

transformed_mesh.each {|mat,meshes|

	
	#Exporting verticies

	SU2IN.status_bar("Writing Mesh - #{mesh_name} - verticies")
	for face in meshes
		for p in (1..face.count_points)
			pos = face.point_at(p)
			norm = face.normal_at(p).to_a
			out.puts "				<v p=\"#{"%.4f" %(pos[0]*@scale)} #{"%.4f" %(pos[1]*@scale)} #{"%.4f" %(pos[2]*@scale)}\" n=\"#{"%.4f" %(norm[0])} #{"%.4f" %(norm[1])} #{"%.4f" %(norm[2])}\"/>"			
		end
	end

	#Exporting uvs

	SU2IN.status_bar("Writing Mesh - #{mesh_name} - UVs")
	for face in meshes
		
		for p in (1..face.count_points)
			if has_uvs

				#default uvset
				uv = [face.uv_at(p,1).x, face.uv_at(p,1).y, face.uv_at(p,1).z] 
 				#stored uvsets
				uv1=uvset1[face][p-1] if uvset1[face]
				uv2=uvset2[face][p-1] if uvset2[face]
				uv3=uvset3[face][p-1] if uvset3[face]
				
				out.print "				<uvs "
				out.print "uv0=\"#{"%.4f" %(uv[0])} #{"%.4f" %(uv[1]+1)}\" " if has_uv0
				out.print "uv1=\"#{"%.4f" %(uv1[0])} #{"%.4f" %(uv1[1]+1)}\" " if uvset1[face]
				out.print "uv2=\"#{"%.4f" %(uv2[0])} #{"%.4f" %(uv2[1]+1)}\" " if uvset2[face]
				out.print "uv3=\"#{"%.4f" %(uv3[0])} #{"%.4f" %(uv3[1]+1)}\" " if uvset3[face]
				out.print "/>\n"
				
			end
			
			
		end
	end

	#Exporting triangle set

	SU2IN.status_bar("Writing Mesh - #{mesh_name} - triangles")
			
	for face in meshes
		for poly in face.polygons
			v1 = (poly[0]>=0?poly[0]:-poly[0])+v_index
			v2 = (poly[1]>=0?poly[1]:-poly[1])+v_index
			v3 = (poly[2]>=0?poly[2]:-poly[2])+v_index

			#face is a polygon mesh
			
			out.puts "				<t v=\"#{v1-1} #{v2-1} #{v3-1}\" uv=\"#{v1-1} #{v2-1} #{v3-1}\" m=\"#{mat_index}\"/>"
			
			$g_su2in_count_tri=$g_su2in_count_tri+1
		end
		v_index = v_index + face.count_points
	end

	faces=[] # all verticies and tris of this material have been exported so empty array
	mat_index+=1
}

uvset0={}
uvset1={}
uvset2={}
uvset3={}
			
out.puts "			</embedded_2>"
out.puts "		</mesh>"

end # end function

#########New binary mesh exporting first implemented
def export_mesh_bin(object,mesh,out)

if object.class==Sketchup::Material
	im=IndigoMaterial.new(object)
	mesh_name=im.name
elsif object.class==Sketchup::ComponentDefinition
	mesh_name=object.name
	cent=object.bounds.center
	sphysics_trans=Geom::Transformation.translation(Geom::Vector3d.new(cent.x,cent.y,cent.z)).inverse if self.physics
	#p sphysics_trans
elsif object==nil
	mesh_name="Default"
end

out.puts "		<mesh>"
out.puts "			<name>#{mesh_name}</name>"

if (not im)  #if this is the default material or if this is a component definition (instanced) mesh
	out.print "			<normal_smoothing>true</normal_smoothing>\n"
else
	out.puts "			 <normal_smoothing>true</normal_smoothing>\n"  
	if im.disp_map? or im.disp_shader?   #only subdivide if displacement is enabled
		out.puts "			 <max_num_subdivisions>#{im.max_subdiv}</max_num_subdivisions>"
		out.puts "			<subdivide_pixel_threshold>#{im.pixel_threshold}</subdivide_pixel_threshold>"
		out.puts "			<subdivide_curvature_threshold>#{im.curvature_threshold}</subdivide_curvature_threshold>"
		out.puts "			<subdivision_smoothing>#{im.smooth?}</subdivision_smoothing>"
	end
end

out.puts " 			<external>"

 
#A mesh is a hash object that contains arrays of faces each indexed by a Sketchup::Materials object
#iterate through mesh to find uv sets and also transform all faces to world coordinates

transformed_mesh={}
has_uvs=false
has_uv0=false
has_uv1=false
has_uv2=false
has_uv3=false
uvset0={}
uvset1={}
uvset2={}
uvset3={}
v_index = 0
mat_index=0

mesh.each {|mat,faces|
	
	meshes = []	
	
	for ft in faces
		
		polymesh = ft[0].mesh 5 
		
		
		polymesh.transform! ft[1]
		####sketchyphysics test
		polymesh.transform! sphysics_trans if sphysics_trans
		#######################
		meshes.push(polymesh)

		uvset1[polymesh]=ft[0].get_attribute 'uvs','uv1'
		uvset2[polymesh]=ft[0].get_attribute 'uvs','uv2'
		uvset3[polymesh]=ft[0].get_attribute 'uvs','uv3'
	end
	
	transformed_mesh[mat]=meshes   #add the transformed faces

	if mat!=nil
		if mat.texture!=nil
			has_uv0=true
		end
	end
}

imesh=IndigoMesh.new
####check for uvsets and expose them
if has_uv0   #this mesh has at least one material with a texture assigned in SketchUp so it will have at least one UVset
	has_uvs=true
	imesh.num_uv_mappings+=1
	imesh.uv_set_expositions.push(["default",0])
end
if uvset1.values.detect {|uvs| uvs!=nil}  #search the hash to see if any uvs were found
	has_uvs=true
	has_uv1=true
	imesh.num_uv_mappings+=1
	imesh.uv_set_expositions.push(["1",1])
end
if uvset2.values.detect {|uvs| uvs!=nil}
	has_uvs=true
	has_uv2=true
	imesh.num_uv_mappings+=1
	imesh.uv_set_expositions.push(["2",2])
end
if uvset3.values.detect {|uvs| uvs!=nil}
	has_uvs=true
	has_uv3=true
	imesh.num_uv_mappings+=1
	imesh.uv_set_expositions.push(["3",3])
end

transformed_mesh.each_key {|mat|
	if mat
		matname = mat.display_name.gsub(/[<>]/, '*') 
	else
		matname = "Default"
	end
	imesh.used_materials.push(matname)
}

transformed_mesh.each {|mat,meshes|

	
	#Exporting verticies
	verts=[]
	normals=[]
	SU2IN.status_bar("Writing Mesh - #{mesh_name} - verticies")
	for face in meshes
		for p in (1..face.count_points)
			pos = face.point_at(p)
			norm = face.normal_at(p).to_a
			verts.push([pos.x*@scale,pos.y*@scale,pos.z*@scale])
			normals.push(norm)
		end
	end
	imesh.vert_positions=verts
	imesh.vert_normals=normals
	#Exporting uvs
	uv_pairs=[]
	SU2IN.status_bar("Writing Mesh - #{mesh_name} - UVs")
	for face in meshes
		
		for p in (1..face.count_points)
			if has_uvs

				#default uvset
				uv = [face.uv_at(p,1).x, face.uv_at(p,1).y, face.uv_at(p,1).z] 
 				#stored uvsets
				uv1=uvset1[face][p-1] if uvset1[face]
				uv2=uvset2[face][p-1] if uvset2[face]
				uv3=uvset3[face][p-1] if uvset3[face]
				
				#out.print "				<uvs "
				uv_pairs.push([uv[0],uv[1]+1]) if has_uv0
				#out.print "uv0=\"#{"%.4f" %(uv[0])} #{"%.4f" %(uv[1]+1)}\" " if has_uv0
				#out.print "uv1=\"#{"%.4f" %(uv1[0])} #{"%.4f" %(uv1[1]+1)}\" " if uvset1[face]
				#out.print "uv2=\"#{"%.4f" %(uv2[0])} #{"%.4f" %(uv2[1]+1)}\" " if uvset2[face]
				#out.print "uv3=\"#{"%.4f" %(uv3[0])} #{"%.4f" %(uv3[1]+1)}\" " if uvset3[face]
				#out.print "/>\n"
				
			end
			
			
		end
	end
	imesh.uv_pairs=uv_pairs
	#Exporting triangle set
	triangles=[]
	SU2IN.status_bar("Writing Mesh - #{mesh_name} - triangles")
			
	for face in meshes
		for poly in face.polygons
			v1 = (poly[0]>=0?poly[0]:-poly[0])+v_index
			v2 = (poly[1]>=0?poly[1]:-poly[1])+v_index
			v3 = (poly[2]>=0?poly[2]:-poly[2])+v_index

			#face is a polygon mesh
			tri=[v1-1,v2-1,v3-1]
			uv_i=[v1-1,v2-1,v3-1]
			triangles.push([tri,uv_i,mat_index])
			#out.puts "				<t v=\"#{v1-1} #{v2-1} #{v3-1}\" uv=\"#{v1-1} #{v2-1} #{v3-1}\" m=\"#{mat_index}\"/>"
			
			$g_su2in_count_tri=$g_su2in_count_tri+1
		end
		v_index = v_index + face.count_points
	end
	imesh.triangles=triangles
	faces=[] # all verticies and tris of this material have been exported so empty array
	mat_index+=1
}

uvset0={}
uvset1={}
uvset2={}
uvset3={}

mesh_dir=File.join(File.dirname(@path),@tex_path)
if !FileTest.exist?(mesh_dir)
	Dir.mkdir(mesh_dir)
end
mesh_path=File.join(mesh_dir,mesh_name+".igmesh")
out.puts "				<path>#{mesh_path}</path>"
out.puts "			</external>"
out.puts "		</mesh>"
imesh.write_to_file(mesh_path)

end # end function

#########New trial mesh exporting routine with vertex welding
def export_mesh_rev_1(object,mesh,out)

if object.class==Sketchup::Material
	im=IndigoMaterial.new(object)
	mesh_name=im.name
elsif object.class==Sketchup::ComponentDefinition
	mesh_name=object.name
elsif object==nil
	mesh_name="Default"
end

#use the original mesh exporting routine (no vertex welding) if the user is not using subdivision
if im
	if im.max_subdiv.to_i==0
		export_mesh_old(object,mesh,out)
		return
	end
end
	
out.puts "		<mesh>"
out.puts "			<name>#{mesh_name}</name>"
if (not im)  #if this is the default material or if this is a component definition (instanced) mesh
	out.print "			<normal_smoothing>true</normal_smoothing>\n"
else
	out.puts "			 <normal_smoothing>false</normal_smoothing>\n"
	#out.puts "			<normal_smoothing>true</normal_smoothing>\n" if not im.smooth?
	out.puts "			 <max_num_subdivisions>#{im.max_subdiv}</max_num_subdivisions>"
	out.puts "			<subdivide_pixel_threshold>#{im.pixel_threshold}</subdivide_pixel_threshold>"
	out.puts "			<subdivide_curvature_threshold>#{im.curvature_threshold}</subdivide_curvature_threshold>"
	out.puts "			<subdivision_smoothing>#{im.smooth?}</subdivision_smoothing>"
end
out.puts " 			<embedded>"

#####temporarily disable multiple uv sets
#for i in (0..3)	
#	out.puts "				<expose_uv_set>"#
#	out.puts "					<index>#{i}</index>"
#	out.puts "					<name>uv#{i}</name>"
#	out.puts "				</expose_uv_set>"
#end	
		
v_index = 0

uvset0={}
uvset1={}
uvset2={}
uvset3={}

master_mesh=Geom::PolygonMesh.new 
 
#A mesh is a hash object that contains arrays of faces each indexed by a Sketchup::Materials object
mesh.each do |mat,faces|
	meshes = []
	mirrored={}
	
	for ft in faces
		
		polymesh = ft[0].mesh 5 
		polymesh.transform! ft[1]
		#polymesh.transform! @exrshift if @exrshift

		mirrored[polymesh] = true
		xa = SU2IN.point_to_vector(ft[1].xaxis)
		ya = SU2IN.point_to_vector(ft[1].yaxis)
		za = SU2IN.point_to_vector(ft[1].zaxis)
		xy = xa.cross(ya)
		xz = xa.cross(za)
		yz = ya.cross(za)
		if xy.dot(za) < 0
			mirrored[polymesh] = !mirrored[polymesh]
		end
		if xz.dot(ya) < 0
			mirrored[polymesh] = !mirrored[polymesh]
		end
		if yz.dot(xa) < 0
			mirrored[polymesh] = !mirrored[polymesh]
		end
		meshes.push(polymesh)

		uvset0[polymesh]=ft[0].get_attribute 'uvs','uv0'
		uvset1[polymesh]=ft[0].get_attribute 'uvs','uv1'
		uvset2[polymesh]=ft[0].get_attribute 'uvs','uv2'
		uvset3[polymesh]=ft[0].get_attribute 'uvs','uv3'
	end

	has_texture = false
	if mat
		matname = mat.display_name
		matname=matname.gsub(/[<>]/, '*') 
		has_texture=true
	else
		matname = "Default"
	end

	#Exporting verticies

	SU2IN.status_bar("Writing Mesh - #{mesh_name} - verticies")
	for face in meshes
		
		for p in (1..face.count_points)
			pos = face.point_at(p)
			if master_mesh.point_index(pos)==0   #point not found so export it
				master_mesh.add_point(pos)
				norm = face.normal_at(p).to_a
				if (has_texture and $g_su2in_monochrome!="Clay")
					if has_texture and mat==nil
						texsize = Geom::Point3d.new(mat.texture.width, mat.texture.height, 1)
					else
						texsize = Geom::Point3d.new(1,1,1)
					end

					#default uvset
					uv = [face.uv_at(p,1).x/texsize.x, face.uv_at(p,1).y/texsize.y, face.uv_at(p,1).z/texsize.z] 
 					#stored uvsets
					uv0=uvset0[face][p-1] if uvset0[face]	
					uv1=uvset1[face][p-1] if uvset1[face]
					uv2=uvset2[face][p-1] if uvset2[face]
					uv3=uvset3[face][p-1] if uvset3[face]
				
					if has_texture 
						out.print "				<vertex pos=\"#{"%.4f" %(pos[0]*@scale)} #{"%.4f" %(pos[1]*@scale)} #{"%.4f" %(pos[2]*@scale)}\" normal=\"#{"%.4f" %(norm[0])} #{"%.4f" %(norm[1])} #{"%.4f" %(norm[2])}\""
						out.print "uv0=\"#{"%.4f" %(uv[0])} #{"%.4f" %(uv[1]+1)}\" " if uv0==nil
						out.print "uv0=\"#{"%.4f" %(uv0[0])} #{"%.4f" %(uv0[1]+1)}\" " if uv0
						out.print "uv1=\"#{"%.4f" %(uv1[0])} #{"%.4f" %(uv1[1]+1)}\" " if uv1
						out.print "uv2=\"#{"%.4f" %(uv2[0])} #{"%.4f" %(uv2[1]+1)}\" " if uv2
						out.print "uv3=\"#{"%.4f" %(uv3[0])} #{"%.4f" %(uv3[1]+1)}\" " if uv3
						out.print "/>\n"
					end
				else
					out.print "				<vertex pos=\"#{"%.4f" %(pos[0]*@scale)} #{"%.4f" %(pos[1]*@scale)} #{"%.4f" %(pos[2]*@scale)}\" normal=\"#{"%.4f" %(norm[0])} #{"%.4f" %(norm[1])} #{"%.4f" %(norm[2])}\"/>\n"
				end
			end  #point is already in mesh
			
		end
	end

	#Exporting triangle set

			out.print "				<triangle_set>\n"
			if ($g_su2in_monochrome)
				out.print "					<material_name>#{$g_su2in_monochrome}</material_name>\n" if $g_su2in_monochrome!="Clay"
				out.print "					<material_name>Default</material_name>\n" if $g_su2in_monochrome=="Clay"
			
			else
				out.print "					<material_name>#{matname}</material_name>\n"
			end
	
	SU2IN.status_bar("Writing Mesh - #{mesh_name} - triangles")
			
	for face in meshes
		for poly in face.polygons
			#v1 = (poly[0]>=0?poly[0]:-poly[0])+v_index
			#v2 = (poly[1]>=0?poly[1]:-poly[1])+v_index
			#v3 = (poly[2]>=0?poly[2]:-poly[2])+v_index
			
			#face is a polygon mesh
			p1=face.point_at(poly[0].abs)
			p2=face.point_at(poly[1].abs)
			p3=face.point_at(poly[2].abs)
			v1=master_mesh.point_index(p1)
			v2=master_mesh.point_index(p2)
			v3=master_mesh.point_index(p3)
			if !mirrored[face]
				out.print "					<tri>#{v1-1} #{v2-1} #{v3-1}</tri>\n"
			else
				out.print "					<tri>#{v2-1} #{v1-1} #{v3-1}</tri>\n"
			end
			$g_su2in_count_tri=$g_su2in_count_tri+1
		end
		v_index = v_index + face.count_points
	end
			out.puts "				</triangle_set>"

	faces=[] # all verticies and tris of this material have been exported so empty array

end 

uvset0={}
uvset1={}
uvset2={}
uvset3={}
			
out.puts "			</embedded>"
out.puts "		</mesh>"

end # end function


#########Export and individual mesh - a mesh is a hash of an array of faces referenced by a sketchup material object
def export_mesh_old(object,mesh,out)

if object.class==Sketchup::Material
	im=IndigoMaterial.new(object)
	mesh_name=im.name
elsif object.class==Sketchup::ComponentDefinition
	mesh_name=object.name
elsif object==nil
	mesh_name="Default"
end
	
out.puts "		<mesh>"
out.puts "			<name>#{mesh_name}</name>"

if (not im)  #if this is the default material or if this is a component definition (instanced) mesh
	out.print "			<normal_smoothing>true</normal_smoothing>\n"
else
	out.puts "			 <normal_smoothing>true</normal_smoothing>\n"  
	out.puts "			 <max_num_subdivisions>#{im.max_subdiv}</max_num_subdivisions>"
	out.puts "			<subdivide_pixel_threshold>#{im.pixel_threshold}</subdivide_pixel_threshold>"
	out.puts "			<subdivide_curvature_threshold>#{im.curvature_threshold}</subdivide_curvature_threshold>"
	out.puts "			<subdivision_smoothing>#{im.smooth?}</subdivision_smoothing>"
end

####check if this mesh has UVs
has_uvs=false
if (im) and (im.texture!=nil)
	has_uvs=true
end
#if $g_su2in_monochrome=="Clay"
#	has_uvs=false
#end

out.puts " 			<embedded>"

##########todo - for component meshes, iterate through all materials and check if any materials have textures
if has_uvs
	
	out.puts "				<expose_uv_set>"
	out.puts "					<index>0</index>"
	out.puts "					<name>default</name>"
	out.puts "				</expose_uv_set>"
end


####temporary disable multiple UV sets
#for i in (1..3)	
#	out.puts "				<expose_uv_set>"
#	out.puts "					<index>#{i}</index>"
#	out.puts "					<name>#{i}</name>"
#	out.puts "				</expose_uv_set>"
#end	
		
v_index = 0

uvset0={}
uvset1={}
uvset2={}
uvset3={}

#A mesh is a hash object that contains arrays of faces each indexed by a Sketchup::Materials object - 
mesh.each do |mat,faces|
	meshes = []
	mirrored={}
	
	for ft in faces
		
		polymesh = ft[0].mesh 5 
		polymesh.transform! ft[1]
		#polymesh.transform! @exrshift if @exrshift

		mirrored[polymesh] = true
		xa = SU2IN.point_to_vector(ft[1].xaxis)
		ya = SU2IN.point_to_vector(ft[1].yaxis)
		za = SU2IN.point_to_vector(ft[1].zaxis)
		xy = xa.cross(ya)
		xz = xa.cross(za)
		yz = ya.cross(za)
		if xy.dot(za) < 0
			mirrored[polymesh] = !mirrored[polymesh]
		end
		if xz.dot(ya) < 0
			mirrored[polymesh] = !mirrored[polymesh]
		end
		if yz.dot(xa) < 0
			mirrored[polymesh] = !mirrored[polymesh]
		end
		meshes.push(polymesh)

		uvset0[polymesh]=ft[0].get_attribute 'uvs','uv0'
		uvset1[polymesh]=ft[0].get_attribute 'uvs','uv1'
		uvset2[polymesh]=ft[0].get_attribute 'uvs','uv2'
		uvset3[polymesh]=ft[0].get_attribute 'uvs','uv3'
	end

	if mat
		matname = mat.display_name
		matname=matname.gsub(/[<>]/, '*') 
	else
		matname = "Default"
	end

	#Exporting verticies

	SU2IN.status_bar("Writing Mesh - #{mesh_name} - verticies")
	for face in meshes
		
		for p in (1..face.count_points)
			pos = face.point_at(p).to_a
			norm = face.normal_at(p).to_a
			#if (mat) and (mat.texture!=nil)
			#	texsize = Geom::Point3d.new(mat.texture.width, mat.texture.height, 1)
			#else
				texsize = Geom::Point3d.new(1,1,1)
			#end
			
			#default uvset - the current texture position applied to the SU model
			uv = [face.uv_at(p,1).x/texsize.x, face.uv_at(p,1).y/texsize.y, face.uv_at(p,1).z/texsize.z]

 			#stored uvsets
			#uv0=uvset0[face][p-1] if uvset0[face]	
			#uv1=uvset1[face][p-1] if uvset1[face]
			#uv2=uvset2[face][p-1] if uvset2[face]
			#uv3=uvset3[face][p-1] if uvset3[face]
				
				
			out.print "				<vertex pos=\"#{"%.4f" %(pos[0]*@scale)} #{"%.4f" %(pos[1]*@scale)} #{"%.4f" %(pos[2]*@scale)}\" normal=\"#{"%.4f" %(norm[0])} #{"%.4f" %(norm[1])} #{"%.4f" %(norm[2])}\" "
				
			out.print "uv0=\"#{"%.4f" %(uv[0])} #{"%.4f" %(uv[1]+1)}\" " if has_uvs
				
			#out.print "uv0=\"#{"%.4f" %(uv0[0])} #{"%.4f" %(uv0[1]+1)}\" " if uv0
			#out.print "uv1=\"#{"%.4f" %(uv1[0])} #{"%.4f" %(uv1[1]+1)}\" " if uv1
			#out.print "uv2=\"#{"%.4f" %(uv2[0])} #{"%.4f" %(uv2[1]+1)}\" " if uv2
			#out.print "uv3=\"#{"%.4f" %(uv3[0])} #{"%.4f" %(uv3[1]+1)}\" " if uv3
			out.print "/>\n"
				
		end
	end

	#Exporting triangle set

			out.print "				<triangle_set>\n"
			if ($g_su2in_monochrome)
				out.print "					<material_name>#{$g_su2in_monochrome}</material_name>\n" if $g_su2in_monochrome!="Clay"
				out.print "					<material_name>Default</material_name>\n" if $g_su2in_monochrome=="Clay"
			
			else
				out.print "					<material_name>#{matname}</material_name>\n"
			end
	
	SU2IN.status_bar("Writing Mesh - #{mesh_name} - triangles")
			
	for face in meshes
		for poly in face.polygons
			v1 = (poly[0]>=0?poly[0]:-poly[0])+v_index
			v2 = (poly[1]>=0?poly[1]:-poly[1])+v_index
			v3 = (poly[2]>=0?poly[2]:-poly[2])+v_index
			if !mirrored[face]
				out.print "					<tri>#{v1-1} #{v2-1} #{v3-1}</tri>\n"
			else
				out.print "					<tri>#{v2-1} #{v1-1} #{v3-1}</tri>\n"
			end
			$g_su2in_count_tri=$g_su2in_count_tri+1
		end
		v_index = v_index + face.count_points
	end
			out.puts "				</triangle_set>"

	faces=[] # all verticies and tris of this material have been exported so empty array

end 

uvset0={}
uvset1={}
uvset2={}
uvset3={}
			
out.puts "			</embedded>"
out.puts "		</mesh>"

end # end function
##########################################Material Model Exporter
def export_model(mesh,mesh_name,trans,out)

#TODO fix for instances that have an emitting material applied to the instance
mats=mesh.keys  #get all the sketchup materials of the mesh - only one material for a material mesh
emit=false
lem=[] #array of all light emitting materials in this mesh
mats.each {|m|
	if m!=nil  #check if this is the default material
		im=IndigoMaterial.new(m)
		if im.emitter?
			lem.push(im)
			emit=true
		end
	end
}

out.print "		<model>\n"
write_transformation(trans,out)
out.print " 			<mesh_name>#{mesh_name}</mesh_name>\n"
if emit	
	lem.each {|im|
		out.puts "			<emission_scale>"
		lum=im.power_drawn.to_f*im.overall_luminous_efficacy.to_f   #calculate the luminous flux of the material from the power and the efficacy
		out.puts "				<material_name>#{im.name}</material_name>"
		out.puts "				<measure>luminous_flux</measure>" #only luminous flux is supported
		out.puts "				<value>#{lum}</value>"
		out.puts "			</emission_scale>"
		if im.ies?  #check if lem using ies profile
			ies_data=im.ies_profile  #returns in IESProfile object
			if ies_data and ies_data.valid?
				out.puts "				<ies_profile>"
				out.puts "					<material_name>#{im.name}</material_name>"
				out.puts "					<path>#{File.join(self.tex_path,ies_data.filename)}</path>"
				out.puts "				</ies_profile>"
				@ies.push(ies_data.path) if (not @ies.index(ies_data.path))    #copies stores the ies path for future export
			end
		end
			
	}
end

out.print "		</model>\n"
	
end

#############################################Export Meshlights
def export_meshlight(mat,trans,out)
	
out.print "		<meshlight>\n"
write_transformation(trans,out)
type=mat.type
mesh_name=mat.name
result=mat.rgb
ies_data=mat.ies_profile    #returns an IESProfile object
@meshlights+=1

out.print " 			<mesh_name>#{mesh_name}</mesh_name>\n"

case type
	when "Blackbody Light"
		out.print " 			<spectrum>\n"
		out.print "				<blackbody>\n"
		out.print " 					<temperature>#{mat.temperature}</temperature>\n"
		out.print "					<gain>1.0</gain>\n"
		out.print "				</blackbody>\n"
		out.print "			</spectrum>\n"
	when "RGB Light"
		out.print " 			<spectrum>\n"
		out.print "				<rgb>\n"
		out.print " 					<rgb>#{result[0]/255.0} #{result[1]/255.0} #{result[2]/255.0}</rgb>\n"
		out.print "					<gamma>2.2</gamma>\n"
		out.print "				</rgb>\n"
		out.print "			</spectrum>\n"
end

out.print "			<efficacy_scale>\n"
out.print "				<power_drawn>#{mat.power_drawn}</power_drawn>\n"
out.print "				<overall_luminous_efficacy>#{mat.overall_luminous_efficacy}</overall_luminous_efficacy>\n"
out.print "			</efficacy_scale>\n"

if (ies_data) and (ies_data.valid?) and (mat.ies?)
	out.puts "			<ies_profile>"
	out.puts "				<path>#{File.join(tex_path,ies_data.filename)}</path>"
	out.puts "			</ies_profile>"
	@ies.push(ies_data.path) if (not @ies.index(ies_data.path))    #copies stores the ies path for future export
end
		
export_emitter_map(mat,out) if mat.texture

out.print "		</meshlight>\n"
	
end

##########################################Export the exit portal
def export_exit_portal(mesh_name,trans,out)
	
out.print "		<exit_portal>\n"
write_transformation(trans,out)
out.print " 			<mesh_name>#{mesh_name}</mesh_name>\n"
out.print "		</exit_portal>\n"
	
end

###############################Extract and write the transformation of the model
def write_transformation(trans,out)

#trans=trans*@exrshift if @exrshift  #deprecated in 1.1.16
trans=trans.to_a

#the following code may not be required.  It extracts the scale of the instance
scalex=Math.sqrt(trans[0]**2+trans[1]**2+trans[2]**2)
scaley=Math.sqrt(trans[4]**2+trans[5]**2+trans[6]**2)
scalez=Math.sqrt(trans[8]**2+trans[9]**2+trans[10]**2)
			
scale=scalex
scale=scaley if scaley>scale
scale=scalez if scalez>scale

out.print "			<pos>#{trans[12]*@scale} #{trans[13]*@scale} #{trans[14]*@scale}</pos>\n"
#out.print "			<scale>#{scale}</scale>\n"
out.print "			<scale>1.0</scale>\n"	
out.print "			<rotation>\n"
out.print "				<matrix>\n"
#out.print "					#{trans[0]/scalex} #{trans[4]/scaley} #{trans[8]/scalez} #{trans[1]/scalex} #{trans[5]/scaley} #{trans[9]/scalez} #{trans[2]/scalex} #{trans[6]/scaley} #{trans[10]/scalez}\n"
out.print "					#{trans[0]} #{trans[4]} #{trans[8]} #{trans[1]} #{trans[5]} #{trans[9]} #{trans[2]} #{trans[6]} #{trans[10]}\n"
out.print "				</matrix>\n"
out.print "			</rotation>\n"

end

end  # end class

#####################################Region Selection Tool####################################
class SelectRegionTool

def initialize
    @ip1 = nil
    @ip2 = nil
    @xdown = 0
    @ydown = 0
	@x1=0
	@x2=0
	@y1=0
	@y2=0
end

def activate
    @ip1 = Sketchup::InputPoint.new
    @ip2 = Sketchup::InputPoint.new
    @ip = Sketchup::InputPoint.new
    @drawn = false    
    self.reset(nil)
end

def deactivate(view)
    view.invalidate if @drawn
end

def onMouseMove(flags, x, y, view)
    if( @state == 0 )
        # We are getting the first point of the region.  Call the pick method
        # on the InputPoint to get a 3D position from the 2D screen position
        # that is bassed as an argument to this method.
        @ip.pick view, x, y
        if( @ip != @ip1 )
            # if the point has changed from the last one we got, then
            # see if we need to display the point.  We need to display it
            # if it has a display representation or if the previous point
            # was displayed.  The invalidate method on the view is used
            # to tell the view that something has changed so that you need
            # to refresh the view.
            view.invalidate if( @ip.display? or @ip1.display? )
            @ip1.copy! @ip
		@x1=x
		@y1=y
            view.tooltip = @ip1.tooltip
        end
    else
        # Getting the second point of the region
        @ip2.pick view, x, y
        view.tooltip = @ip2.tooltip if( @ip2.valid? )
        view.invalidate
        
        # Update the length displayed in the VCB
        if( @ip2.valid? )
            length = @ip1.position.distance(@ip2.position)
            Sketchup::set_status_text length.to_s, SB_VCB_VALUE
		@x2=x
		@y2=y
        end
        
        # Check to see if the mouse was moved far enough to create a line.
        # This is used so that you can create a line by either draggin
        # or doing click-move-click
        if( (x-@xdown).abs > 10 || (y-@ydown).abs > 10 )
            @dragging = true
        end
    end
end

# The onLButtonDOwn method is called when the user presses the left mouse button.
def onLButtonDown(flags, x, y, view)
    # When the user clicks the first time, we switch to getting the
    # second point.  When they click a second time we create the line
    if( @state == 0 )
        @ip1.pick view, x, y
        if( @ip1.valid? )
            @state = 1
            Sketchup::set_status_text $exStrings.GetString("Select region"), SB_PROMPT
            @xdown = x
            @ydown = y
		@x1=x
		@y1=y
        end
    else
        # create the line on the second click
        if( @ip2.valid? )
            self.save_region(view)
            self.reset(view)
        end
    end
    
    # Clear any inference lock
    view.lock_inference
end

# The onLButtonUp method is called when the user releases the left mouse button.
def onLButtonUp(flags, x, y, view)
    # If we are doing a drag, then create the line on the mouse up event
    if( @dragging && @ip2.valid? )
        self.save_region(view)
        self.reset(view)
    end
end

# onKeyDown is called when the user presses a key on the keyboard.
# We are checking it here to see if the user pressed the shift key
# so that we can do inference locking
def onKeyDown(key, repeat, flags, view)
    if( key == CONSTRAIN_MODIFIER_KEY && repeat == 1 )
        @shift_down_time = Time.now
        
        # if we already have an inference lock, then unlock it
        if( view.inference_locked? )
            # calling lock_inference with no arguments actually unlocks
            view.lock_inference
        elsif( @state == 0 && @ip1.valid? )
            view.lock_inference @ip1
        elsif( @state == 1 && @ip2.valid? )
            view.lock_inference @ip2, @ip1
        end
    end
end

# onKeyUp is called when the user releases the key
# We use this to unlock the interence
# If the user holds down the shift key for more than 1/2 second, then we
# unlock the inference on the release.  Otherwise, the user presses shift
# once to lock and a second time to unlock.
def onKeyUp(key, repeat, flags, view)
    if( key == CONSTRAIN_MODIFIER_KEY &&
        view.inference_locked? &&
        (Time.now - @shift_down_time) > 0.5 )
        view.lock_inference
    end
end


# The draw method is called whenever the view is refreshed.  It lets the
# tool draw any temporary geometry that it needs to.
def draw(view)
    if( @ip1.valid? )
        if( @ip1.display? )
            @ip1.draw(view)
            @drawn = true
        end
        
        if( @ip2.valid? )
            @ip2.draw(view) if( @ip2.display? )
            
            # The set_color_from_line method determines what color
            # to use to draw a line based on its direction.  For example
            # red, green or blue.
            view.set_color_from_line(@ip1, @ip2)
            self.draw_geometry([@x1,@y1,0],[@x2,@y1,0],[@x2,@y2,0],[@x1,@y2,0], view)
            @drawn = true
        end
    end
end

# onCancel is called when the user hits the escape key
def onCancel(flag, view)
    self.reset(view)
end


# The following methods are not directly called from SketchUp.  They are
# internal methods that are used to support the other methods in this class.

# Reset the tool back to its initial state
def reset(view)
    # This variable keeps track of which point we are currently getting
    @state = 0
	@x1=0
	@x2=0
	@y1=0
	@y2=0
    
    # Display a prompt on the status bar
    Sketchup::set_status_text($exStrings.GetString("Select region"), SB_PROMPT)
    
    # clear the InputPoints
    @ip1.clear
    @ip2.clear
    
    if( view )
        view.tooltip = nil
        view.invalidate if @drawn
    end
    
    @drawn = false
    @dragging = false
end

# Create new geometry when the user has selected two points.
def save_region(view)

irs=IndigoRenderSettings.new
w=view.vpwidth.to_f
h=view.vpheight.to_f
width=irs.width
height=irs.height
cam=view.camera
aspect=cam.aspect_ratio
view_aspect=w/h
aspect=view_aspect if aspect==0.0
if view_aspect>=aspect   #black borders on left and right edges
	eff_width_pixels=aspect*h
	border_offset=((w-eff_width_pixels)/2).to_i
	width_fraction_x1=(@x1-border_offset)/eff_width_pixels
	width_fraction_x2=(@x2-border_offset)/eff_width_pixels
	height_fraction_y1=(@y1)/h
	height_fraction_y2=(@y2)/h
	x1=(width*width_fraction_x1).to_i
	x2=(width*width_fraction_x2).to_i
	y1=(height*height_fraction_y1).to_i
	y2=(height*height_fraction_y2).to_i

elsif view_aspect<aspect  #black borders on top and bottom edges
	eff_height_pixels=w/aspect
	border_offset=((h-eff_height_pixels)/2).to_i
	width_fraction_x1=(@x1)/w
	width_fraction_x2=(@x2)/w
	height_fraction_y1=(@y1-border_offset)/eff_height_pixels
	height_fraction_y2=(@y2-border_offset)/eff_height_pixels
	x1=(width*width_fraction_x1).to_i
	x2=(width*width_fraction_x2).to_i
	y1=(height*height_fraction_y1).to_i
	y2=(height*height_fraction_y2).to_i
	
end

#Validate region and store

min_x=[x1,x2].min
max_x=[x1,x2].max
min_y=[y1,y2].min
max_y=[y1,y2].max
min_x=0 if min_x<0
max_x=width if max_x>width
min_y=0 if min_y<0
max_y=height if max_y>height
reg=[min_x,max_x,min_y,max_y]
UI.messagebox "Region (#{min_x},#{min_y}) (#{max_x},#{max_y}) selected."
irs.region=reg
	
end

# Draw the geometry
def draw_geometry(pt1, pt2, pt3, pt4, view)
    view.draw2d(GL_LINE_LOOP,[pt1,pt2,pt3,pt4])
end

end #class


class IndigoMesh

attr_reader :num_uv_mappings, :used_materials, :uv_set_expositions, :vert_positions, :vert_normals, :uv_pairs, :triangles
attr_writer :num_uv_mappings, :used_materials, :uv_set_expositions, :vert_positions, :vert_normals, :uv_pairs, :triangles

MAX_STRING_LENGTH=1024
MAX_VECTOR_LENGTH=1000000
MAGIC_NUMBER=5456751
FORMAT_VERSION=1

def initialize

@num_uv_mappings=0  #uint32
@used_materials=[]  #array of strings of material names
@uv_set_expositions=[]  #array of uv sets (string name and uint32 uv set index)
@vert_positions=[]  #array of vertex positions (3 floats)
@vert_normals=[]  #array of normals (3 floats)
@uv_pairs=[]   #array of UVs (2 floats)
@triangles=[]  #array of triangles  (uint32 vertex indices[3], uint32 uv indices[3], uint32 material index)

end

def writeBasic(out,object)   #object is a binary string
	out.write(object)
end

def write_string(out,string)
	len=string.length
	len_bin=[len].pack("I")  #convert uint32
	#p len_bin.unpack("I")
	writeBasic(out,len_bin)  #write the length of the string
	str_arr=[string]
	#str_arr=[]
	#string.each {|c| str_arr.push(c)}  #build the string array (may not be required)
	string_bin=str_arr.pack("a#{len}")  #convert to null terminated string
	#string_bin=str_arr.pack("a#{len+1}")
	p string_bin.unpack("a#{len+1}")
	writeBasic(out,string_bin)
end

def write_float(out,float)
	float_bin=[float].pack("f")  #convert to single precision float
	#p float_bin.unpack("f")
	writeBasic(out,float_bin)
end

def write_uint(out,uint)
	uint_bin=[uint].pack("I")  #convert to unsigned integer
	#p uint_bin.unpack("I")
	writeBasic(out,uint_bin)
end

def write_vec2f(out,vec2f)  #vec2f is an array of two floats
	vec2f_bin=vec2f.pack("ff")
	#p vec2f_bin.unpack("ff")
	writeBasic(out,vec2f_bin)
end

def write_vec3f(out,vec3f)  #vec3f is an array of three floats
	vec3f_bin=vec3f.pack("fff")
	#p vec3f_bin.unpack("fff")
	writeBasic(out,vec3f_bin)
end

def write_uvSetExposition(out,x)  #x is an array of a uv set name and an index number
	set_name=x[0]
	set_index=x[1]
	write_string(out,set_name)
	write_uint(out,set_index)
end

def write_triangle(out,tri)  #tri is an array of 3 vertex indices, 3 uv indices and a material index
	verts=tri[0]  #get the array of vertex indices
	uvs=tri[1]   #get the array of uv_indices
	mat_index=tri[2]
	verts_bin=verts.pack("III")
	#p verts_bin.unpack("III")
	uvs_bin=uvs.pack("III")
	#p uvs_bin.unpack("III")
	mat_index_bin=[mat_index].pack("I")
	#p mat_index_bin.unpack("I")
	writeBasic(out,verts_bin)
	writeBasic(out,uvs_bin)
	writeBasic(out,mat_index_bin)
end

def write_array(out,arr,type)  #intended to replace the C++ writeVector method
	len=arr.length    #get the number of items in the array
	#return if len==0
	len_bin=[len].pack("I")  #convert uint32
	#p len_bin.unpack("I")
	writeBasic(out,len_bin)  #write the length of the array
	case type
	when "tri"
		arr.each {|tri| write_triangle(out,tri)}
	when "vec3f"
		arr.each {|vec| write_vec3f(out,vec)}
	when "vec2f"
		arr.each {|vec| write_vec2f(out,vec)}
	when "uvse"
		arr.each {|uv| write_uvSetExposition(out,uv)}
	when "string"
		arr.each {|mat| write_string(out,mat)}
	end
end
	
def write_to_file(path)
	out=File.new(path,"wb")  #create a new file in binary write mode
	begin
	write_uint(out,MAGIC_NUMBER)
	p "wrote magic number"
	write_uint(out,FORMAT_VERSION)
	p "wrote format version"
	write_uint(out,@num_uv_mappings)
	p "wrote num uv mappings"
	
	write_array(out,@used_materials, "string")
	p "wrote used materials"
	write_array(out,@uv_set_expositions, "uvse")
	p "wrote uv set expositions"
	write_array(out,@vert_positions, "vec3f")
	p "wrote vert positions"
	write_array(out,@vert_normals, "vec3f")
	p "wrote normals"
	write_array(out,@uv_pairs, "vec2f")
	p "wrote uvs"
	write_array(out,@triangles, "tri")
	p "wrote triangles"
	ensure
	out.close()
	end
end

end #class indigomesh

def set_mesh()
	mesh=IndigoMesh.new
	mesh.num_uv_mappings=0
	mesh.used_materials=["Default"]
	mesh.uv_set_expositions=[["Default",0]]
	#mesh.uv_set_expositions=[]
	mesh.vert_positions=[2.54,2.54,0.0],[0.0,0.0,0.0],[0.0,2.54,0.0],[2.54,0.0,0.0],[2.54,0.0,2.54],[0.0,2.54,2.54],[0.0,0.0,2.54],[2.54,2.54,2.54],[2.54,2.54,0.0],[2.54,0.0,2.54],[2.54,0.0,0.0]
	mesh.vert_normals=[0.0,0.0,-1.0],[0.0,0.0,-1.0],[0.0,0.0,-1.0],[0.0,0.0,-1.0],[0.0,0.0,1.0],[0.0,0.0,1.0],[0.0,0.0,1.0],[0.0,0.0,1.0],[1.0,0.0,0.0],[1.0,0.0,0.0],[1.0,0.0,0.0]
	mesh.uv_pairs=[0.0,0.0],[0.0,0.0],[0.0,0.0],[0.0,0.0],[0.0,0.0],[0.0,0.0],[0.0,0.0],[0.0,0.0],[0.0,0.0],[0.0,0.0],[0.0,0.0]
	#mesh.uv_pairs=[]
	
	t1=[0,1,2],[0,1,2],0
	t2=[1,0,3],[1,0,3],0
	t3=[4,5,6],[4,5,6],0
	t4=[5,4,7],[5,4,7],0
	t5=[8,9,10],[8,9,10],0
	mesh.triangles=[t1,t2,t3,t4,t5,t5]
	return mesh
end

#-----------------------------------------------------------------------------
# This functions is just a shortcut for selecting the new tool
def select_region_tool
    Sketchup.active_model.select_tool SelectRegionTool.new
end

def eim
	m=set_mesh()
	path="C:\\Users\\Dale\\Downloads\\indigo_v1.1.12\\indigo_v1.1.12\\imesh\\test.igmesh"
	m.write_to_file(path)
end


# ---------------------------------------- Menu item
if( not file_loaded?("SkIndigo_1_1_16.rb") )

	main_menu = UI.menu("Plugins").add_submenu("SkIndigo")
	main_menu.add_item("Render Scene") {(SU2IN.export(0,true,nil,true))}
	main_menu.add_separator
	main_menu.add_item("Export Scene  as..") { (SU2IN.export_as(0,true)) }
	#main_menu.add_item("Export Animation") { (SU2IN.export_animation()) }
	main_menu.add_item("Render Settings") { (SU2IN.render_settings)}
	main_menu.add_item("Material Editor") { ($smo.show_editor if $smo) }
	main_menu.add_item("Query Material Types") { (SU2IN.mat_query) }
	main_menu.add_item("Resume a Render") { (Indigo.res) }
	main_menu.add_separator
	main_menu.add_item("About SkIndigo 1.1.16") { (SU2IN.about) }
	
	Sketchup.add_observer(SkindigoAppObserver.new)

	$smo=SkindigoMatObserver.new
	Sketchup.active_model.materials.add_observer $smo

	plugins = Sketchup.find_support_file("Plugins")
	icon1 = File.join(plugins, "SkIndigo", "IndigoLogo.gif")
	icon2 = File.join(plugins, "SkIndigo", "IndigoLogo3.gif")
	icon3=  File.join(plugins, "SkIndigo", "IndigoLogo2.gif")
        tb = UI::Toolbar.new("SkIndigo")
	cmd1 = UI::Command.new("Render Scene"){(SU2IN.export(0,true,nil,true))}
	cmd1.small_icon = icon1
	cmd1.large_icon = icon1
	cmd1.tooltip = cmd1.status_bar_text = "Render with Indigo"
	cmd2 = UI::Command.new("Quick Export"){(SU2IN.quick_export)}
	cmd2.menu_text="   Quick Export"
	cmd2.set_validation_proc { (validate_quick_export)}
	cmd2.small_icon = icon2
	cmd2.large_icon = icon2
	cmd2.tooltip = cmd2.status_bar_text = "Quick Export"
	cmd3 = UI::Command.new("Render Settings"){(SU2IN.render_settings)}
	cmd3.menu_text="Render Settings"
	cmd3.small_icon = icon3
	cmd3.large_icon = icon3
	cmd3.tooltip = cmd3.status_bar_text = "Render Settings"
	tb.add_item(cmd1)
	tb.add_item(cmd2)
	tb.add_item(cmd3)
	tb.show
	
	
##############################UV Manager Context menu##########################
	
	UI.add_context_menu_handler do |menu|
	ent=Sketchup.active_model.selection.first
	mat=IndigoMaterial.new(ent.material) if (ent) and (ent.material!=nil)
	menu.add_separator
	menu.add_item("SkIndigo"){(nil)}
        if mat
			unless mat.color_picker? or mat.uv_helper?
				menu.add_item("   Edit \"#{mat.display_name}\" (#{mat.type.upcase})") {($smo.sm=mat;$smo.show_editor)}
			end
		 end
   	end
	
	
UI.add_context_menu_handler do |menu|
	sel=Sketchup.active_model.selection
	ent=sel.first
	mat=IndigoMaterial.new(ent.material) if (ent) and (ent.material!=nil)
	if mat and mat.texture!=nil
		uv_menu=menu.add_submenu("   UV Mapping") 
		#TODO - fix so that user can triple click on faces
		#if mat.uv_helper?
		#	current_set=mat.mat.get_attribute('indigo_uv','current_set')  #get the uv set that is currently being edited
		#		if current_set!=nil
		#			uv_menu.add_item("Save UV set #{current_set} and Restore Material") {
		#			faces=Sketchup.active_model.active_entities.find_all {|e| e.class==Sketchup::Face} #find all faces in current context
		#			uv_faces=faces.find_all {|f| f.material==mat.mat}  #find all faces in current context that are using the UV helper material
		#			mat.store_uvs(uv_faces,current_set)                 #save the current uvs to the current set
		#			UI.messagebox("Saved current UVs to set #{current_set}")
		#			status=mat.restore_old_mat(uv_faces)               #revert back to the original material
		#			if status==false
		#				UI.messagebox("Error restoring material.")
		#			end
		#		}
		#		end
		#end
		
		uv_menu.add_item("Save UVs to set 1") {mat.store_uvs(sel,1)} 
		uv_menu.add_item("Save UVs to set 2") {mat.store_uvs(sel,2)} 
		uv_menu.add_item("Save UVs to set 3") {mat.store_uvs(sel,3)} 
		uv_menu.add_item("Purge all UV sets") {mat.purge_uvs(sel)}
		uv_menu.add_separator
		uv_menu.add_item("Explode distorted texture") {(UVS.explode_distorted_texture)} if (mat.texture)
		
	end
		
end
	
	UI.add_context_menu_handler do |menu|
	sel=Sketchup.active_model.selection
	ent=sel.first
	e=nil
	if ent.class==Sketchup::ComponentInstance
		e=ent.definition
	elsif ent.class==Sketchup::Group
		e=ent.entities[0].parent
	end
	
	if e and sel.length==1
		instanced=e.get_attribute 'indigo07_settings','inst',false
		if not instanced
			menu.add_item("   \"#{e.name}\" Enable Instancing") {(e.set_attribute 'indigo07_settings','inst',true)}
		else
			menu.add_item("   \"#{e.name}\" Disable Instancing") {(e.set_attribute 'indigo07_settings','inst',false)}
		end
	elsif e and sel.length>1
		menu.add_item("   Enable Instancing") {(SU2IN.set_instancing(sel,true))}
		menu.add_item("   Disable Instancing") {(SU2IN.set_instancing(sel,false))}
	end	
	end
	
	UI.add_context_menu_handler do |menu|
	menu.add_item(cmd2)
	end
	
end 

#-----------------------------------------------------------
file_loaded("SkIndigo_1_1_16.rb")

